function Item() {};

Item.COLORS = {
	'RED': '1', 'BLUE': '2', 'GREEN': '3', 'GREY': '4', 'ORANGE': '5', 'CYAN': '6', 'BROWN': '7',
	'PURPLE': '8', 'LIGHT_BLUE': '9', 'YELLOW': 'A', 'COMPLETE': 'Y', 'CLEAR': 'Z'
};

Item.open = function(id, aOtherData, aValues, sFolderType, bForce) {
	if (gui.frm_main && gui.frm_main.main && gui.frm_main.main.itemview){

		if (!bForce && dataSet.get('preview', id)) return;

		dataSet.add('active_items', [id[0],id[1]], id[2]);

		var aItemsInfo = {"aid": id[0], "fid": id[1], "iid": id[2]};

		if (WMFolders.getType(id) == 'F')
			aItemsInfo.values = [
				'EVN_ID',
				'EVNGRP_ID',
				'EVNOWN_ID',
				'EVNLOCKOWN_ID',
				'EVNMODIFIEDOWN_ID',
				'EVN_EDITCOUNTER',
				'EVN_CREATED',
				'EVN_MODIFIED',
				'EVNFOLDER',
				'EVNORIGINALFOLDER',
				'EVNTITLE',
				'EVNTYPE',
				'EVNNOTE',
				'EVNDESCFORMAT',
				'EVNLOCATION',
				'EVNCOMPLETE',
				'EVNCOLOR',
				'EVNCLASS',
				'EVNSHARETYPE',
				'EVNTIMEFORMAT',
				'EVNSTATUS',
				'EVNURL',
				'EVNSTARTDATE',
				'EVNSTARTTIME',
				'EVNENDDATE',
				'EVNENDTIME',
				'EVNRID',
				'EVNUID',
				'EVNFLAGS',
				'EVNLOCKHASH',
				'EVNLOCKINFO',
				'EVNLOCKOWN_EMAIL',
				'EVNLOCKAPPMASK',
				//'DATA',
				'TICKET'];

		WMItems.list(aItemsInfo, 'preview'); //,'','',[gui.frm_main.main.itemview,'_value']
	}
	else
		Item.openwindow(id, aOtherData, aValues, sFolderType);
};

Item.openwindow = function(id, aOtherData, aValues, sFolderType, oResponse) {

	if (!sFolderType){
		sFolderType = dataSet.get("folders", [id[0], id[1], 'TYPE']);
		if (!sFolderType)
			if (id[0]==sPrimaryAccount){
				if (id[1] == '__@@ADDRESSBOOK@@__' || id[1] == '@@mycard@@')
					sFolderType = 'C';
			}
			else
				return;
	}

	return gui._create('gw', Mapping.getFormNameByGWType(sFolderType), '', '', id[0], id[1], id[2], aValues, aOtherData, oResponse);
};


Item.print = function(ids){

	if (!ids || !ids[2].length)
		return;

	var ids = ids,
		aItemsInfo = {aid:ids[0],fid:ids[1]},
		sType = WMFolders.getType(ids);

	aItemsInfo.filter = {search:'items:(' + ids[2].join(' or ').replace(/\*/g,'') + ')'};

	switch(sType){

		case 'T':
			aItemsInfo.values = [
				'EVNTITLE','EVNLOCATION','EVNNOTE','EVNSTATUS','EVNCOMPLETE','EVNENDDATE','EVNSTARTDATE','EVNTYPE'
			];

			WMItems.list(aItemsInfo, '', '','', [function(aData){

				if (aData && (aData = aData[aItemsInfo.aid]) && (aData = aData[aItemsInfo.fid])){
					var tmp, out = [];

					for(var i in ids[2])
						if (aData[ids[2][i]])
							out.push(aData[ids[2][i]]);

					if (out.length){
						var frm;
						if (!(frm = gui.print))
							frm = gui._create('print', 'frm_print');

						frm._add(sType, out);
					}
				}

			}]);

			break;
		case 'C':
			aItemsInfo.values = [
				'ITMCLASSIFYAS','ITMTITLE','ITMFIRSTNAME','ITMMIDDLENAME','ITMSURNAME','ITMCLASS','ITMSUFFIX','ITMCOMPANY','ITMJOBTITLE','ITMDEPARTMENT',
				'LCTEMAIL1','LCTEMAIL2','LCTEMAIL3',
				'LCTIM',
				//ALL Phones
				'LCTPHNPRIMARY',
				'LCTPHNWORK1','LCTPHNWORK2','LCTPHNFAXWORK',
				'LCTPHNHOME1','LCTPHNHOME2','LCTPHNFAXHOME',
				'LCTPHNASSISTANT','LCTPHNCALLBACK','LCTPHNCOMPANY','LCTPHNCAR','LCTPHNISDN','LCTPHNOTHER','LCTPHNOTHERFAX','LCTPHNPAGER',
				'LCTPHNFAXWORK','LCTPHNMOBILE','LCTPHNRADIO','LCTPHNTELEX','LCTPHNHEARING'
			];

			aItemsInfo.filter.sort = 'ITMSURNAME,ITMFIRSTNAME,ITMCLASSIFYAS';

			WMItems.list(aItemsInfo, '', '','', [function(aData){

				if (aData && (aData = aData[aItemsInfo.aid]) && (aData = aData[aItemsInfo.fid])){
					var tmp,out = [];
					for(var i in ids[2])
						//Contacts only
						if (aData[ids[2][i]] && aData[ids[2][i]].ITMCLASS == 'C'){

							tmp = {PHONES:[]};

							for(var j in aData[ids[2][i]])
								if (j.indexOf('LCTPHN') == 0){
									if (aData[ids[2][i]][j])
										tmp.PHONES.push({PHNTYPE:getLang('PHONE::'+ j.toUpperCase()), PHNNUMBER:aData[ids[2][i]][j]});
								}
								else
									tmp[j] = aData[ids[2][i]][j];

							out.push(tmp);
						}

					if (out.length){
						var frm;
						if (!(frm = gui.print))
							frm = gui._create('print', 'frm_print');

						frm._add(sType, out);
					}
				}

			}]);

		break;
	}
};

Item.create = function(sType, sAccount, sFolder) {
	// TODO	move code from obj_hmenu_basic to here
	gui.frm_main.hmenu1.__createNewGW(sType);
};

Item.createInFolder = function(sAccount, sFolder, aValues) {
	var sFolderType = dataSet.get("folders", [sAccount, sFolder, 'TYPE']);

	if (sFolderType == 'M'){

		newMessage = new NewMessage();
		newMessage.addSignature();

		if (aValues.PUSH_ATTACHMENTS){
			newMessage.aAttachments = {'attachments': []};
			for (var i in aValues.PUSH_ATTACHMENTS)
				if (aValues.PUSH_ATTACHMENTS[i].fullpath)
					newMessage.aAttachments.attachments.push({'values': {'class': 'item', 'fullpath':aValues.PUSH_ATTACHMENTS[i].fullpath, 'name':aValues.PUSH_ATTACHMENTS[i]['title']}});
		}

		if (aValues.EVNTITLE)
			newMessage.sSubject = aValues.EVNTITLE;

		gui._create('frm_compose', 'frm_compose', '', '', newMessage);
	}
	else
		gui._create('gw', Mapping.getFormNameByGWType(sFolderType), '', '', sAccount, sFolder, null, aValues);
};

Item.set_lock = function(ids, bLock, bRefreshPreview, aHandler){
	WMItems.action({"aid": ids[0], "fid": ids[1], "iid": ids[2]}, (bLock?'lock':'unlock'), [function(aData){

		//Refresh DataGrid
		Item.__refreshView(ids,true);

/*		//called in __refreshView
		//Refresh preview
		if (bRefreshPreview){
			if (gui.frm_main && gui.frm_main.main && gui.frm_main.main.itemview){

				if (!Is.Array(ids[2]))
					ids[2] = [ids[2]];

				for (var i in ids[2])
					if (dataSet.get('preview', [ids[0], ids[1], ids[2][i]])){
						dataSet.remove('preview');
						Item.open([ids[0], ids[1], ids[2][i]]);
						break;
					}
			}
		}
*/
		if (aHandler)
			executeCallbackFunction(aHandler,aData);
	}]);
};


Item.edit_value = function(sValue,id,sColumn,aOut){

	var	aOut = aOut || {values:{}};

	if (sColumn == 'EVNFILENAME' || sColumn == 'CONVERT'){
		WMItems.list({"aid": id[0], "fid": id[1], "iid": id[2], "values": ['ATTACHMENTS']},'','','',[
			function(aData){
				if ((aData = aData[id[0]]) && (aData = aData[id[1]]) && (aData = aData[id[2]]) && (aData = aData.ATTACHMENTS)){
					for(var uid in aData){

						if (sColumn == 'CONVERT'){
							aOut = {ATTACHMENTS:[{"uid":uid,"values":{"convert":sValue}}]};
						}
						else{
							aOut.values['EVNTITLE'] = sValue;
							aOut.values['EVNLOCATION'] = sValue;
							aOut.values['EVNRID'] = sValue;
							aOut.ATTACHMENTS = [{"uid":uid,"values":{"description":sValue}}];
						}

						Item.edit_value('',id,'',aOut);
						return;
					}
				}

				//Some Error...
				Item.__refreshView(id,true);
			}
		]);
		return;
	}
	else
	if (sColumn)
		aOut.values[sColumn] = sValue;

	WMItems.add(id,aOut,'items','','',[
		function(bOK){
			Item.__refreshView(id,true);

			//Refresh preview
			// if (gui.frm_main && gui.frm_main.main && gui.frm_main.main.itemview){

			// 	if (!Is.Array(id[2]))
			// 		id[2] = [id[2]];

			// 	for (var i in id[2])
			// 		if (dataSet.get('preview', [id[0], id[1], id[2][i]])){
			// 			dataSet.remove('preview');
			// 			Item.open([id[0], id[1], id[2][i]]);
			// 			break;
			// 		}
			// }


		}
	]);
};

Item.edit_tags = function(ids, aHandler) {
	try{
		var tag_elm = {M:'TAGS',C:'ITMCATEGORY'}[dataSet.get("folders", [ids[0], ids[1], 'TYPE']) || 'M'] || 'EVNTYPE',
			sInitString = WMItems.list({"aid": ids[0], "fid": ids[1], "iid": ids[2][0], "values": [tag_elm]})[ids[0]][ids[1]][ids[2][0]][tag_elm];
	}
	catch(r){
		return;
	}

	var tag = gui._create('categories', 'frm_categories', '', '', sInitString,[
		function(sTags,ids){
			var	out = {values:{}};
				out.values[tag_elm] = sTags;

			WMItems.add(ids, out, 'items','','',[
				function(bOK, ids){
					if (bOK && Is.Array(ids))
						Item.__refreshView(ids,true);

				},[ids]]);

			if (aHandler)
				executeCallbackFunction(aHandler);

		},[ids]]);
};

Item.addCert = function(id) {
	gui._create('add_cert','frm_insert_item','','frm_insert_item_nobottomdiv',[Item.addCert_request, [id]],sPrimaryAccount,Mapping.getDefaultFolderForGWType('C'),'C','w');
};
Item.addCert_request = function(aItem,ids) {
	if (aItem && aItem[0]){
		aItem = aItem[0];
		WMItems.certificate({account:ids[0],folder:ids[1],item:ids[2],aid:aItem.aid,fid:aItem.fid,iid:aItem.id}, [Item.addCert_response]);
	}
};
Item.addCert_response = function(aData){
	//Error
	if (aData.error){
		var tmp = 'CERTIFICATE::';
		switch(aData.error){
			case 'account_invalid_id':
			case 'item_invalid_id':
			case 'folder_does_not_exist':
				tmp += 'INVALIDITEM';
				break;
			case 'certificate_data_missing':
			    tmp += 'MISSING';
		}

		gui._create('error','frm_alert','','',null,'',tmp);
	}
	// OK
	else{
		var obj = gui._create('confirm','frm_confirm','','',[Item.open,[[aData.data.aid, aData.data.fid, aData.data.iid]]],'CERTIFICATE::CERTIFICATE','CERTIFICATE::ASSIGNED');
		    obj.btn_ok._value('POPUP_ITEMS::OPEN');
		    obj = null;
	}

/*
 [data]
.. [aid](string) = admin@merakdemo.com
.. [fid](string) = Contacts
.. [iid](string) = 3a2c8e2a3005
*/

};

Item.recover = function(ids,bAsk) {
	if (bAsk){
		var obj = gui._create('confirm','frm_confirm','','',[Item.recover,[ids]],'POPUP_ITEMS::RECOVER','CONFIRMATION::RECOVER_ITEM');
		    obj.btn_ok._value('POPUP_ITEMS::RECOVER');
		    obj = null;
	}
	else{
		WMItems.recover({'aid':ids[0],'fid':ids[1],'iid':ids[2],action:'recover'},'items','','folders');
		if (!Item.__removeFromDataset(ids))
			Item.__refreshView(ids,true);
	}
};


Item.copy = function(ids) {
	gui._create('frm_select_folder', 'frm_select_folder', '', '', 'POPUP_ITEMS::COPY_MAIL_TO', ids[0], ids[1],
		[Item.__copyOrMoveItems, ['copy', ids]], false, false, dataSet.get("folders", [ids[0], ids[1], 'TYPE']),'w'
	);
};

Item.move = function(ids) {
	gui._create('frm_select_folder', 'frm_select_folder', '', '', 'POPUP_ITEMS::MOVE_MAIL_TO', ids[0], ids[1],
		[Item.__copyOrMoveItems, ['move', ids]], false, false, dataSet.get("folders", [ids[0], ids[1], 'TYPE']),'w'
	);
};

Item.downloadMultiple = function(ids) {
	WMItems.save_items({"aid": ids[0], "fid": ids[1], "iid": ids[2]},currentBrowser().indexOf('MSIE')<0);
};

Item.downloadSource = function(id,ext) {
	var aUrl = {'sid': dataSet.get('main', ['sid']), 'class': 'item'+(ext || ''), 'fullpath': id[0]+'/'+id[1]+'/'+WMItems.__serverID(id[2])};
	downloadItem(buildURL(aUrl));
};

Item.webdavURL = function(id,sAtId){
	try{
		if (!Is.Defined(sAtId)){
			var aData = WMItems.list({"aid": id[0], "fid": id[1], "iid": id[2], "values": ['EVN_ID']})[id[0]][id[1]][id[2]];
			for (var sAtId in aData['ATTACHMENTS'])
				break;

			if (!Is.Defined(sAtId))
				return false;
		}

		return 'server/download.php?' + buildURL({'sid':dataSet.get('main',['sid']),'class':(sAtId.length?'attachmentticket':'itemticket'),'fullpath':id[0]+'/'+id[1]+'/'+WMItems.__serverID(id[2])+(sAtId.length?'/'+sAtId:'')});
	}
	catch(r){}

	return false;
};
Item.downloadFile = function(id) {
	try{
		var aData = WMItems.list({"aid": id[0], "fid": id[1], "iid": id[2], "values": ['EVN_ID']})[id[0]][id[1]][id[2]];
		for (var sAtId in aData['ATTACHMENTS']){
			downloadItem(buildURL({'sid':dataSet.get('main',['sid']),'class':'attachment','fullpath':id[0]+'/'+id[1]+'/'+WMItems.__serverID(id[2])+'/'+sAtId}));
			return true;
		}
	}
	catch(r){}

	return false;
};
Item.getPublicUrl = function(id) {
	try{
		var aData = WMItems.list({"aid": id[0], "fid": id[1], "iid": id[2], "values": ['EVN_ID']})[id[0]][id[1]][id[2]];
		for (var sAtId in aData['ATTACHMENTS'])
			break;

		return aData.ATTACHMENTS[sAtId].values.TICKET || false;
	} catch(r) {}

	return false;
}

/**
 * oOriginator - object which will be focused after execution
 * iNext - originator next value
 */
Item.remove = function(ids, bForce, oRepeating, oOriginator, iNext)
{
	if (Is.Object(oRepeating)){
		var frm = gui._create('frm_confirm','frm_confirm_repeating','','', [Item.__removeWithRepeating, [ids,oRepeating,void 0, bForce]],'REPEATING_CONFIRM::TITLE_DELETE','REPEATING_CONFIRM::TEXT_DELETE');

		//return focus to originator object if any
		if (oOriginator && oOriginator._focus){
			frm.___returnFocus = function(){
				oOriginator._focus();
			};
			frm._add_destructor('___returnFocus');
		}

		return;
	}

	storage.library('gw_others');

	if (bForce){
		Item.__delete(ids,oOriginator,iNext, bForce);
		return;
	}
	else
	if (dataSet.get("folders",[ids[0],ids[1],'TYPE']) == 'M' && parseInt(GWOthers.getItem('MAIL_SETTINGS_GENERAL','move_to_trash'))>0){

		//Primary Account
		var sTrashFolder = Path.split(GWOthers.getItem('DEFAULT_FOLDERS','trash'))[1];

		//Other Account
		if (sPrimaryAccount != ids[0]){
			var sTrash = dataSet.get('accounts',[ids[0],'TRASHFOLDER']);
			if (sTrash)
				sTrashFolder = Path.split(sTrash)[1];
		}

		if (sTrashFolder != ids[1]){

			var aFolders = dataSet.get('folders');
			if (!aFolders[ids[0]][sTrashFolder])
				dataSet.add('folders',[ids[0],sTrashFolder],{'NAME':sTrashFolder,'TYPE':'M','RIGHTS':'rwmd'});

			Item.__copyOrMoveItems(ids[0],sTrashFolder,'move',[ids[0],ids[1],ids[2]]);

			//return focus to originator object if any
			if (oOriginator){
				if (oOriginator._focus)
					oOriginator._focus();
				if (typeof iNext != 'undefined')
					oOriginator._value([iNext]);
			}

			return;
		}
	}

	if (gui.__bSkipDeleteConfirmation){
		Item.__delete(ids,oOriginator,iNext);
		if (oOriginator && oOriginator._focus)
			oOriginator._focus();
	}
	else
	{
		var frm = gui._create('frm_confirm','frm_confirm', '', 'noblur', [Item.__delete, [ids,oOriginator,iNext]],
			'CONFIRMATION::DELETE_ITEM_CONFIRMATION','CONFIRMATION::DELETE_ITEM'
		);
		addcss(frm.x_btn_ok._main,'color2');

		var skip = frm._create('skip','obj_button_check','footer', 'big noborder simple x_btn_right');
			skip._value('POPUP_ITEMS::SKIP_DELETE');
			skip._tabIndex();
			skip._onclick = function(){
				gui.__bSkipDeleteConfirmation = this._checked()>0;
			};

		//return focus to originator object if any
		if (oOriginator && oOriginator._focus){
			frm.___returnFocus = function(){
				if (oOriginator._focus)
					oOriginator._focus();
			};
			frm._add_destructor('___returnFocus');
		}
	}
};

Item.setColor = function(id, sColor) {
	var sOldColor = Item.getColor(id);

	if (!sOldColor || (sOldColor != sColor)) {
		// TODO rollback on error
		dataSet.add('items', id.concat(['EVNCOLOR']), sColor);
		WMItems.add(id, {'values': {'EVNCOLOR': sColor}}, 'items');
	}
};

Item.getColor = function(id) {
	return dataSet.get('items', id.concat(['EVNCOLOR']));
};

Item.hasReccurence = function(id,rcr_id) {
	if (!Is.Object(id))	return false;

	var tmpItm = dataSet.get('items',id);
	if (!Is.Object(tmpItm) || tmpItm.EVNCLASS == 'O') return false;

	if (!Is.Defined(rcr_id))
		rcr_id = tmpItm.EVNRCR_ID;

	return rcr_id?true:false;
};
Item.sendEmailTo = function(sLctEmail,aValues){
	var newMessage = new NewMessage();
		newMessage.sTo = sLctEmail;

	if (aValues){
		for (var i in aValues)
			if (Is.Function(newMessage[i]))
				newMessage[i](aValues[i]);
			else
				newMessage[i] = aValues[i];
	}

	gui._create('frm_compose', 'frm_compose', '', '', newMessage);

}

Item.sendAsEmail = function(ids) {

	var aData, sName = '', sSize,
		sFTyle = (ids[1] == '@@mycard@@'?'C':dataSet.get('folders', [ids[0], ids[1], 'TYPE'])),
		newMessage = new NewMessage();
		newMessage.addSignature();
		newMessage.aAttachments = {'attachments': []};

	for (var i in ids[2]){
		if (!Is.Defined(sName = dataSet.get('items', [ids[0], ids[1], ids[2][i], sFTyle == 'C'?'ITMCLASSIFYAS':'EVNTITLE']))){
			aData = WMItems.list({"aid": ids[0], "fid": ids[1], "iid": ids[2][i], "values": [(sFTyle == 'C'?'ITMCLASSIFYAS':'EVNTITLE')]});
			try{
				sName = aData[ids[0]][ids[1]][ids[2][i]][sFTyle == 'C'?'ITMCLASSIFYAS':'EVNTITLE'] || '';
			}
			catch(r){
				continue;
			}
		}

		sSize = dataSet.get('items', [ids[0], ids[1], ids[2][i],'EVNCOMPLETE']);

		if (sName){
			newMessage.sSubject = sName;

			if (sFTyle != 'F')
				sName += sFTyle == 'C'?'.vcf':'.ics';

			newMessage.aAttachments.attachments.push({'values': {'class': 'item', 'fullpath': ids[0]+'/'+ids[1]+'/'+WMItems.__serverID(ids[2][i]), size: sSize, 'name': sName}});
		}
	}

/*
<attachments>
<attachment>
<values>
<class>item</class>
<type>normal</type>
<fullpath>lukas@icewarp.com/Calendar/424c52691185</fullpath>
</values>
</attachment>
</attachments>
*/


	gui._create('frm_compose', 'frm_compose', '', '', newMessage);
};
/*
	acc, fol - destination folder
	v - drop values
*/
Item.__convertToFolder = function(acc,fol,v){
	var t1  = dataSet.get('folders',[acc,fol,'TYPE']),
		t2  = dataSet.get('folders',[v.value[0].aid,v.value[0].fid,'TYPE']);

	//create ids
	var ids = [v.value[0].aid,v.value[0].fid,[]];
	for(var i in v.value)
		ids[2].push(v.value[i].iid);

	//Drag & Drop doesnt work with popups because of event handlers.
	gui.frm_main.dnd.remove_drag(true);

	if (fol == 'SPAM_QUEUE/Whitelist' || fol == 'SPAM_QUEUE/Blacklist'){
		if (t2 == 'M')
			OldMessage.__blackOrWhiteList(ids, fol == 'SPAM_QUEUE/Whitelist');
	}
	else
	if (t1!=t2){
			var title = [], name, mail, q, note, tmp, arg, out = {}, att = [];
			for(var i in v.value){

				arg = {	id:v.value[i].iid,
						fullpath:v.value[i].aid+'/'+v.value[i].fid+'/'+WMItems.__serverID(v.value[i].iid),
						embedded:true};

				//Detail Request
				var aReq = {"aid": v.value[i].aid, "fid": v.value[i].fid, "iid": v.value[i].iid};
				if (t2 == 'P' || t2 == 'M')
					aReq.values = ['SUBJECT','SIZE','FROM','HTML','STATIC_FLAGS'];

				if (!(q = WMItems.list(aReq)[v.value[i].aid][v.value[i].fid][v.value[i].iid]))
					return;

				switch(t2){
				case 'R':
						try{
                            if (typeof title[0] == 'undefined')	title.push(q.SUBJECT);
							note = note || q.TEXT || q.HTML;
						}
						catch(r){}

					break;

				case 'P':
				case 'M':
					arg.title = q.SUBJECT || '';
					arg.size =  q.SIZE || 0;

					if (typeof title[0] == 'undefined'){
						if (t1=='C'){
							var splited = MailAddress.splitEmailsAndNames(q.FROM);
							if (splited[0]){
								mail = splited[0].email;
								name = splited[0].name;
							}
						}
						title.push(arg.title);

						note = q.HTML;
						if (q.STATIC_FLAGS & 1)
							out[t1 == 'C' || t1 == 'D'?'ITMDESCFORMAT':'EVNDESCFORMAT'] = 'text/html';
					}

					arg.title += (arg.title?' - ':'')+ WMItems.__serverID(v.value[i].iid) +'.eml';

					break;

				case 'F':

					for (var sAtId in q['ATTACHMENTS'])
						break;

					arg.title = q.EVNLOCATION;
					arg.size = q.EVNCOMPLETE || 0;
					arg.fullpath += '/'+sAtId;
					arg.type = 'push_attachment';

					if (typeof title[0] == 'undefined' && !note)
						note = q.EVNNOTE;

					break;

				case 'C':
				case 'D':

					if (typeof title[0] == 'undefined' && !note)
						note = q.ITMDESCRIPTION;

					arg.title = q.ITMCLASSIFYAS + '.vcf';
					break;

				case 'N':
				case 'T':
				case 'E':
				case 'J':
					if (typeof title[0] == 'undefined' && !note)
						if (t2 == 'N')
							note = q.NOTES && q.NOTES[0].values?q.NOTES[0].values.NOTE_TEXT:'';
						else
							note = q.EVNNOTE;

					arg.title = (q.EVNTITLE || q.ITMTITLE || '') + '.ics';
				}

				att.push(arg);
			}

			if (name)
                parseNameToLocation(name,out);

			if (mail)
				out.LOCATIONS = [{values:{LCTTYPE:'H',LCTEMAIL1:mail}}];

			if (note){
				switch(t1){
				case 'C':
				case 'D':
				    out.ITMDESCRIPTION = note;
					break;
				case 'N':
					out.NOTES = [{values:{NOTE_TEXT:note}}];
					break;
				default:
					out.EVNNOTE = note;
				}
			}

			out.EVNTITLE = title.join(', ');

			if (t2 != 'R')
				out.PUSH_ATTACHMENTS = att;

			Item.createInFolder(acc, fol, out);
	}
	else
		Item.__copyOrMoveItems(acc, fol, v.ctrl?'copy':'move', ids);
};


Item.__copyOrMoveItems = function(sDestAccount, sDestFolder, sAction, ids) {

	if (sDestAccount && sDestFolder && (sAction != 'move' || sDestAccount != ids[0] || sDestFolder != ids[1]))
	{
		// Refresh folders (folder tree)
		var aFolderProps = dataSet.get('folders', [ids[0], ids[1]], true),
			aNewFolderProps = dataSet.get('folders', [sDestAccount, sDestFolder], true),
			nFlag;

		if (aFolderProps && (aFolderProps['TYPE'] == 'M' || aFolderProps['TYPE'] == 'Q')){

			if (typeof aFolderProps['RECENT'] == 'undefined')
				aFolderProps['RECENT'] = 0;

			if (typeof aNewFolderProps != 'undefined' && !aNewFolderProps['RECENT'])
				aNewFolderProps['RECENT'] = 0;

			for (var n in ids[2]) {
				if (typeof aNewFolderProps != 'undefined' && !(nFlag = WMItems.getFlag([ids[0],ids[1],ids[2][n]],'SEEN','items')))
					dataSet.add('folders', [sDestAccount, sDestFolder, 'RECENT'], (++aNewFolderProps['RECENT']).toString(), true);

				if (sAction == 'move' && !nFlag)
					dataSet.add('folders', [ids[0], ids[1], 'RECENT'], (--aFolderProps['RECENT']).toString(), true);
			}

			dataSet.update('folders');
		}

		switch(sAction)
		{
			case 'copy':
				//Async copy items and refresh folders (folder tree)
				WMItems.copy({'aid':ids[0],'fid':ids[1],'iid':ids[2],'account':sDestAccount,'folder':sDestFolder},'items','','folders',[function(bOK){ Item.__refreshView([sDestAccount,sDestFolder],true)}]);
				break;

			case 'move': // sinchronous

				if (sDestAccount != ids[0] || sDestFolder != ids[1])
				{
					/*
					//Async move items and refresh folders (folder tree)
					var aHandler = null;
					if (!Item.__removeFromDataset(ids))
						aHandler = [Item.__refreshView, [ids]];
						WMItems.move({'aid':ids[0],'fid':ids[1],'iid':ids[2],'account':sDestAccount,'folder':sDestFolder},'items','','folders',aHandler);
					*/

					//synchro move
					WMItems.move({'aid':ids[0],'fid':ids[1],'iid':ids[2],'account':sDestAccount,'folder':sDestFolder},'items','','folders',[
					function(){
						if (!Item.__removeFromDataset(ids))
							Item.__refreshView(ids,true);
					}]);
				}
				break;
		}
	}
};

Item.__removeWithRepeating = function(iState, ids, oRepeating,oOriginator, bForce) {
	var aValues = {};
	bForce && (aValues.skip_trash = 1);
	switch(iState.toString()){
	case '2':
		aValues.EXPFOLLOWING = 'true';
	case '0':
		aValues.EXPDATE = oRepeating['EVNSTARTDATE'];
		WMItems.remove({'aid':ids[0],'fid':ids[1],'iid':ids[2],'values':ids[2].map(function(){return aValues;})},'items','','folders',[function(bOK){
			if (bOK)
				Item.__refreshView(ids,true);
		}]);
		break;
	default:
		Item.__delete(ids, void 0, void 0, bForce);
	}
};

/**
 * optional oOriginator,iNext (for DataGrid purpose)
 **/
Item.__delete = function(ids,oOriginator,iNext, skip_trash) {

	if (oOriginator && oOriginator._focus)
		oOriginator._focus();

	// DELETE SELECTION 2
	for (var i in ids[2])
		 if (ids[2][i].indexOf('|')>-1)
		 	delete ids[2][i];

	if (!count(ids[2])) return;

	// Refresh folders (folder tree)
	var aFolderProps = dataSet.get('folders',[ids[0],ids[1]]);
	if (aFolderProps && (aFolderProps['TYPE'] == 'M' || aFolderProps['TYPE'] == 'R')){
		var iRecent = aFolderProps['RECENT'] || 0;

		for(var n in ids[2])
			if (!WMItems.getFlag(makeIDFromIDS(ids,n),'SEEN','items'))
                iRecent--;

		dataSet.add('folders',[ids[0],ids[1],'RECENT'],(iRecent>0?aFolderProps['RECENT']:0).toString(),true);
        dataSet.update('folders',[ids[0],ids[1],'RECENT']);
	}
	var data = {
		'aid': ids[0],
		'fid': ids[1],
		'iid': ids[2],
	};
	if (skip_trash) {
		data.values = ids[2].map(function () {
			return {skip_trash: 1};
		});
	}

	WMItems.remove(data,'items','','folders',[function(bOK){
		if (bOK){
			if (oOriginator  && typeof iNext != 'undefined')
				oOriginator._value([iNext]);

			// Async remove items
			if(!Item.__removeFromDataset(ids))
				Item.__refreshView(ids);
		}
	}]);
};

Item.__removeFromDataset = function(ids)
{
	var sFolType = dataSet.get('folders',[ids[0],ids[1],'TYPE']);
	if (sFolType && ids && ids[2]){
		// Vymazání položek z datasetu
		var n = 0, i;
		for(i in ids[2])
			if (dataSet.remove('items', makeIDFromIDS(ids, i), true))
				n++;

		// Correct Total (Count)
		var iTotal	= dataSet.get("items",[ids[0],ids[1],'/']);
		if (Is.Defined(iTotal))
			dataSet.add("items",[ids[0],ids[1],'/'],parseInt(iTotal,10)-n,true);

		// Mažeme mail, který byl aktivní pro náš folder?
		var sIt = dataSet.get('active_items',[ids[0],ids[1]]);
		if (Is.Defined(sIt) && inArray(ids[2], sIt) > -1){
			dataSet.remove('active_items',[ids[0],ids[1]]);
			dataSet.remove('preview');
		}

		if (sFolType != 'E' || Cookie.get(['views',ids[0],ids[1],'view']) == 'list_view'){
			dataSet.update('items');
			return true;
		}
		else
			// indicate that the view needs to be updated from the server
			return false;
	}
};

Item.__refreshView = function(ids,bNoRefresh) {
	var aActive = getPathFromDataset('items'),
		ids = ids;

	if ((aActive && aActive[0] == ids[0] && aActive[1] == ids[1]) || (WMFolders.getType(ids) == 'E' && aActive[1] == '__@@VIRTUAL@@__/__@@EVENTS@@__' && (ids[1] = '__@@VIRTUAL@@__/__@@EVENTS@@__'))){

		gui.frm_main._selectView({'aid':ids[0],'fid':ids[1]},null,false,null,(bNoRefresh?false:true));

		//Refresh preview
		if (bNoRefresh){
			if (gui.frm_main && gui.frm_main.main && gui.frm_main.main.itemview){

				if (!Is.Array(ids[2]))
					ids[2] = [ids[2]];

				for (var i in ids[2])
					if (dataSet.get('preview', [ids[0], ids[1], ids[2][i]])){
						dataSet.remove('preview');
						Item.open([ids[0], ids[1], ids[2][i]]);
						break;
					}
			}
		}
	}
};

Item.playFile = function(id){
	if (gui.audio && Is.Array(id)){
		try{
			var aData = WMItems.list({"aid": id[0], "fid": id[1], "iid": id[2], "values": ['EVN_ID']},'','','',[function(aData){
				if (aData && (aData = aData[id[0]]) && (aData = aData[id[1]]) && (aData = aData[id[2]]))
					for (var sAtId in aData['ATTACHMENTS']){
						var sName = aData['ATTACHMENTS'][sAtId].values.ATTDESC || sAtId;
						if (Path.extension(sName) == 'mp3')
							gui.audio._value('server/download.php?' + buildURL({'sid':dataSet.get('main',['sid']),'class':'attachment','fullpath':id[0]+'/'+id[1]+'/'+WMItems.__serverID(id[2])+'/'+sAtId}), sName);
					}
			}]);
		}
		catch(r){}
	}
};

Item.openPDF = function(id){
	if (Is.Array(id)){
		try{
			var aData = WMItems.list({"aid": id[0], "fid": id[1], "iid": id[2], "values": ['EVN_ID']},'','','',[function(aData){
				if (aData && (aData = aData[id[0]]) && (aData = aData[id[1]]) && (aData = aData[id[2]]))
					for (var sAtId in aData['ATTACHMENTS']){
						var sName = aData['ATTACHMENTS'][sAtId].values.ATTDESC || sAtId;
						if (Path.extension(sName) == 'pdf')
							gui._create('pdf','frm_pdf')._load('server/download.php?' + buildURL({'sid':dataSet.get('main',['sid']),'class':'attachment','fullpath':id[0]+'/'+id[1]+'/'+WMItems.__serverID(id[2])+'/'+sAtId}), sName);
					}
			}]);
		}
		catch(r){}
	}
};

/**
 * Open in Dialog
 * 12.2.2013
 **/

Item.editFile = function(id){
	if (Is.Array(id)){
		var frm = gui._create('text','frm_editor');
			frm._load(id);
	}
};

/*

[aData]
.. [admin@merakdemo.com]
.... [Files/fff]
...... [$](string) = 0
...... [*424751d1f703]
........ [aid](string) = admin@merakdemo.com
........ [fid](string) = Files/fff
........ [EVNTITLE](string) = html.html
........ [DATA](string) = <head><title></title></head>
<body></body>

........ [ATTACHMENTS]
.......... [html.html]
............ [values]
.............. [ATTNAME](string) = html.html
.............. [ATTTYPE](string) = attachment
.............. [ATTTIME](string) = 1360228475
.............. [ATTSIZE](string) = 0
.............. [ATTDESC](string) = html.html
.............. [ATTPARAMS](undefined) = undefined
.............. [TICKET](string) = http://merakdemo.com/webdav/ticket/eJwVyjEOgCAMAMDX2E2F0gaWTib8Q7FVIi7q,6MuN90mwUiZUlDSAia5Nr07nswMimS4pEdP8QvMCCpQhZAi.9VbdGHcn7MNP3CI.dkhLpjSCy7eGDM_/html.html
 [id]
.. [0](string) = admin@merakdemo.com
.. [1](string) = Files/fff
.. [2](string) = *424751d1f703
 [sType](string) = html


*/

/**
 * Open in office by SharePoint or Java OfficeLauncher
 * 26.1.2012 15:21:07
 **/

Item.officeSupport = function(sFile){
	if (sPrimaryAccountWebDAV)
		return inArray([
		 	'xls', 'xlsx', 'xlw', 'xlt', 'ods', 'ppt', 'pptx', 'pps', 'pot', 'odp', 'doc', 'docx', 'dot', 'rtf', 'odt'
		], Path.extension(sFile))>-1;

	return false;
};

Item.imageSupport = function(sFile){
	return inArray([
	 	'jpg', 'jpeg', 'png', 'gif'
	], Path.extension(sFile))>-1;
};
/*
Item.imageOpen = function(aItemInfo){

	var id = [aItemInfo.aid,aItemInfo.fid,aItemInfo.iid];
	if (aItemInfo.attid)
		id.push(aItemInfo.attid);

	var url =  'server/download.php?' + buildURL({'sid':dataSet.get('main',['sid']), 'class':'attachment', 'fullpath': id.join('/'),'resize':1, 'width':screen.width, 'height':screen.height});

	var img = gui._create('imgview','frm_imgview');
		img._fill([url]);
		img._value(0);
};
*/

Item.editSupport = function(sFile){
	return inArray([
	 	'txt', 'html', 'htm'
	], Path.extension(sFile))>-1;
};


/*
Item.officeSupport = function(sFile){
	if ((GWOthers.getItem('LAYOUT_SETTINGS','disable_office') || 0)<1)
		return inArray([
			'accda','accdb','accdc','accde','accdp','accdr','accdt','accdu','ade','adp','maf','mam','maq','mar','mat','mda','mdb','mde','mdt','mdw','laccdb','snp','csv','dbf','dif','ods','prn','slk','xla','xlam','xls','xlsb','xlsm','xlsx','xlt','xltm','xltx','xlw','xps','obi','oft','ost','prf','pst','msg','oab','iaf','emf','odp','pot','potm','potx','ppa','ppam','pps','ppsm','ppsx','ppt','pptm','pptx','pptx','thmx','tif','wmf','xml','xps','doc','docm','docx','dot','dotm','dotx','htm','html','mht','mhtml','odt','rtf','wps','xps','btr','dwt','elm','fwp','htx','mso'
		 ], Path.extension(sFile))>-1;
	else
		return false;
};
*/

Item.officeOpen = function(aItemInfo, aErrHandler, sExtension, bExternal){

	if (sPrimaryAccountWebDAV){

		storage.library('wm_tools');
		var tool = new wm_tools();

		if (!bExternal && dataSet.get('accounts',[sPrimaryAccount,'USE_LIBREOFFICE'])=="true") {
			if (WMFolders.getAccess(aItemInfo,'modify'))
				tool.ticket(aItemInfo,'rwil',[function(sPath){
					gui._create('doc','frm_document')._open(aItemInfo, sPath);
				},[aItemInfo]]);
			else
				gui._create('doc','frm_document')._open(aItemInfo);

			//gui._create('doc','frm_document')._open(Item.getPublicUrl([aItemInfo.aid, aItemInfo.fid, aItemInfo.iid]));
			return;
		}

		if ((GWOthers.getItem('LAYOUT_SETTINGS','disable_office') || 0)<1 && WMFolders.getAccess(aItemInfo,'modify')){
			tool.ticket(aItemInfo,'rwil',[Item.officeWebdav,[aErrHandler,sExtension]]);
			return;
		}
	}

	if (aErrHandler)
		executeCallbackFunction(aErrHandler);
};

Item.officeWebdav = function(sPath,aErrHandler,sExtension){

// console.log(sPath); return;

//alert(sExtension); return;
//doc dot docx docm dotx dotm docb

	if (sPath === false || !Item.officeSupport(Path.basename(sPath.indexOf('?')>-1?sPath.substr(0,sPath.indexOf('?')):sPath))){
		if (aErrHandler)
			executeCallbackFunction(aErrHandler);

		return;
	}

	var r,a = null;

	//MSIE
	if ("ActiveXObject" in window) {

		//MS Office
		try {
			a = new ActiveXObject("SharePoint.OpenDocuments.3")
		} catch (r) {
			a = null;
			try {
				a = new ActiveXObject("SharePoint.OpenDocuments.2")
			} catch (r) {
				a = null;
				try {
					a = new ActiveXObject("SharePoint.OpenDocuments.1")
				} catch (r) {
					a = null;
				}
			}
		}

		//Open Office
		if (a == null){
			try{
				if ((a = new ActiveXObject("com.sun.star.ServiceManager")))
					if ((a = a.createInstance("com.sun.star.frame.Desktop")))
						return a.LoadComponentFromURL(sPath, "_blank", 0, []);
			}
			catch(r){}

			a = null;
		}
	}
	else
	if (currentBrowser()!='Chrome' || currentBrowser(true)<42)
	//Safari & FFox NPAPI plugin
	{
		var sType = '', a = document.getElementById("SharePointPlugin") || null;
		if (a == null){
			if (IsBrowserPluginInstalled("application/x-sharepoint-webkit"))
				sType = "application/x-sharepoint-webkit";
			else
				sType = "application/x-sharepoint";

			try{
				a = mkElement("object",{
					'id':"SharePointPlugin",
					'type':sType,
					'width':0,
					'height':0,
					'style':{'visibility':"hidden"}
				});
				document.body.appendChild(a);
			}
			catch(r){
				a = null;
			}
		}
	}

	try {
		if (a.EditDocument)
			setTimeout(function(){
				if (!a.EditDocument(sPath) && aErrHandler)
					executeCallbackFunction(aErrHandler);
			},0);
		else
			throw true;
	}
	//Go Java go...
	catch (r) {

		//Use Java
		if ((!sExtension || currentBrowser()!='Chrome' || currentBrowser(true)<42) && navigator.javaEnabled()){

			//Open in OfficeLauncher
			if ((a = document.getElementById("OfficeLauncher"))){
				try{
					a.openDocument(sPath, 0, -1);
					Item.__officeFilePath = '';
					return true;
				}
				catch(err){

					if (!sExtension || currentBrowser()!='Chrome' || currentBrowser(true)<42){
						gui._create('confirm','frm_confirm','','',[function(){
							if (sPath){
								downloadItem(sPath,true);
								Item.__officeFilePath = '';
							}
						}],'OFFICELAUNCHER::OFFICELAUNCHER','OFFICELAUNCHER::OPENFAILED');
						return false;
					}

				}
			}
			//Init OfficeLauncher
			else{
				Item.__officeFilePath = sPath;

				var elm = mkElement('div',{'style':{'position':"absolute",'top':"-1000px;"}});
					elm.innerHTML = '<applet code="com.elementit.OfficeLauncher.OfficeLauncher" codebase="'+ document.getElementsByTagName('base')[0].href +'client/inc/officelauncher/" archive="OfficeLauncher.jar" width="0" height="0" name="OfficeLauncher" id="OfficeLauncher" mayscript="true">'+
			 		'<param name="separate_jvm" value="true">'+
			 		'<param name="permissions" value="all-permissions">'+
			 		'<param name="MSOffice.Types.Access" value="accda,accdb,accdc,accde,accdp,accdr,accdt,accdu,ade,adp,maf,mam,maq,mar,mat,mda,mdb,mde,mdt,mdw,laccdb,snp">'+
			 		'<param name="MSOffice.Types.Excel" value="csv,dbf,dif,ods,pdf,prn,slk,xla,xlam,xls,xlsb,xlsm,xlsx,xlt,xltm,xltx,xlw,xml,xml,xps">'+
			 		'<param name="MSOffice.Types.Outlook" value="obi,oft,ost,prf,pst,msg,oab,iaf">'+
			 		'<param name="MSOffice.Types.PowerPoint" value="emf,odp,pdf,pot,potm,potx,ppa,ppam,pps,ppsm,ppsx,ppt,pptm,pptx,pptx,rtf,thmx,tif,wmf,xml,xps">'+
			 		'<param name="MSOffice.Types.Word" value="doc,docm,docx,dot,dotm,dotx,htm,html,mht,mhtml,odt,pdf,rtf,txt,wps,xml,xml,xps">'+
			 		'<param name="MSOffice.Types.FrontPage" value="btr,dwt,elm,fwp,htx,mso">'+
			 		'<param name="progressbar" value="true">'+
			 		'<param name="boxmessage" value="Loading OfficeLauncher Applet...">'+
					'</applet>';

				document.body.appendChild(elm);
				return;
			}
		}

		if (currentBrowser()=='Chrome' && currentBrowser(true)>41 && sExtension){
			var type = '';
			switch(sExtension) {
				// Open Word for editing
				case 'doc': case 'dot': case 'docx':
				case 'docm': case 'dotx': case 'dotm':
				case 'docb': case 'odt': case 'rtf':
					type = 'ms-word:ofe';
					break;
				// Open Excel for editing
				case 'xls': case 'csv': case 'xlsx':
				case 'xla': case 'xlam': case 'xlsb':
				case 'ods': case 'xlsb': case 'xlsm':
				case 'xlt': case 'xltm': case 'xltx':
					type = 'ms-excel:ofe';
					break;
				// Open PowerPoint for viewing
				case 'ppt': case 'pptx': case 'odp':
				case 'pps': case 'ppsm': case 'ppsx':
				case 'pptm': case 'ppa': case 'ppam':
					type = 'ms-powerpoint:ofv';
					break;
				// Open Access for editing
				case 'accda': case 'accdb': case 'accdc':
				case 'accde': case 'accdr': case 'accdt':
				case 'ade': case 'adp': case 'mda':
					type = 'ms-access:ofe';
					break;
			}
			if(type)
				downloadItem(type+'|u|' + sPath,true);

		}
		else{

			//No Java
			gui._create('officelauncher_error','frm_no_java','','','','OFFICELAUNCHER::OFFICELAUNCHER','',getLang('OFFICELAUNCHER::NOLAUNCH'));

			if (sPath){
				downloadItem(sPath,true);
				Item.__officeFilePath = '';
			}
		}
	}
};

//OfficeLauncher global functions
function onLauncherInited(a) {};

function onOfficePathDetected(a) {
	if (Item.__officeFilePath && a>0){
		Item.officeWebdav(Item.__officeFilePath);
		Item.__officeFilePath = '';
	}
};

function onOfficePathNotDetected() {
	gui._create('officenoapp_error','frm_alert','','','','OFFICELAUNCHER::OFFICELAUNCHER','',getLang('OFFICELAUNCHER::NOAPPFOUND'));

	if (Item.__officeFilePath){
		downloadItem(Item.__officeFilePath,true);
		Item.__officeFilePath = '';
	}
};