
/*
 *	Document preview and editing window with controls
 *
 *	Martin Ekblom 2015
 */

function frm_document() {};

frm_document.prototype.__constructor = function() {
	var me = this;

	this._defaultSize(-1,-1,1200,800, true);
	this._title('DOCUMENT::TITLE');

	this._create('loader','obj_loader');

	// Show document in window
	this._create('doc','obj_document','main');

	// Update title
	this.doc._oninit = function(arg){
		if (arg.title)
			me._title(getLang('DOCUMENT::TITLE') + ' - ' + arg.title, true);
		else
		if (arg.state && me.loader)
			me.loader._destruct();
	};
};

// Open file from webdav
frm_document.prototype._open = function(aItemInfo, sTicket) {
	if (Is.Object(aItemInfo))
		this.doc._open(aItemInfo, sTicket);
};

/** DOCKING **/
frm_document.prototype._ondock = function (){
	return true;
};

frm_document.prototype._onundock = function (){
	return true;
};


frm_document.prototype._onclose = function (){

	//hotfix
	try{

		if (this.doc && this.doc._view && this.doc._view.getPermission() == 'edit' && this.doc._view.getCommandValue('.uno:ModifiedStatus') == 'true'){

			var me = this;

			this.frmsave = gui._create('save_document','frm_confirm','','',null, 'DOCUMENT::SAVE', 'DOCUMENT::SAVE_TEXT');
			this.frmsave._closable(true);
			this.frmsave.x_btn_ok._value('FORM_BUTTONS::SAVE');
			this.frmsave.x_btn_ok._onclick = function() {

				this._parent._destruct();

				//bind save handler
				me.doc._onsave = function(b){
					if (b)
						me._destruct();
					else{
						me.__show();

						var frm = gui._create('save_document','frm_confirm','','frm_alert',null, 'DOCUMENT::SAVE','DOCUMENT::CLOSE_ERROR');
							frm.x_btn_ok._onclick = function(){
								this._parent._destruct();
								me._destruct();
							};
							frm.x_btn_cancel._onclick = function(){
								this._parent._destruct();
							};
					}
				};

				if (me.doc._save())
					me.__hide();
				else
					me._destruct();
			};

			this.frmsave.x_btn_cancel._value('COMMON::NO');
			this.frmsave.x_btn_cancel._onclick = function() {
				this._parent._destruct();
				me._destruct();
			};

			return false;
		}

	}
	catch(r){
		if (console)
			console.log('frm_document.close() error', r);
	}

	return true;
};