/*
#datagrid:
    - predelat na skin datagrid 2
    - zakazat move columns


        r(items read)
		i(items write)
		w(items modify)
		t(items delete)
		l(folder read)
		k(folder write)
		m(folder modify)
		x(folder delete)
		a(admin/owner)

		lrswipkcdexta

		SPCDET

*/

_me = frm_sharing.prototype;
function frm_sharing(){};

_me.__constructor = function(aFolderInfo, aHandler){

	this.__aFolderInfo = aFolderInfo;
	this.__aHandler = aHandler;

	var me = this;

	this._size(580,500,true);

	this.__bFormEnabled = false;

	this._title(getLang('POPUP_FOLDERS::SHARING')+' - '+(aFolderInfo.fid?aFolderInfo.fid.replace(/^\~/g,''):aFolderInfo.aid),true);

	this._draw('frm_sharing','main');


	// Create 'OK' button
	this._create('x_btn_ok', 'obj_button', 'footer','big noborder color1 ico ok simple');
	this.x_btn_ok._disabled(true);
	this.x_btn_ok._value('FORM_BUTTONS::OK');
	this.x_btn_ok._onclick = function() {
		me.__save();
	};

	// Create 'INHERITE' button
	if (aFolderInfo.fid){
		this._create('x_btn_inherit', 'obj_button', 'footer','big noborder ico ok simple');
		this.x_btn_inherit._disabled(true);

		this.x_btn_inherit._value('FORM_BUTTONS::INHERIT');
		this.x_btn_inherit._onclick = function() {
			//SMAZ PRAVA
			me.__aData = {};
			me.x_btn_ok._onclick();
		};
	}


	// Create 'CANCEL' button
	this._create('x_btn_cancel', 'obj_button', 'footer','big noborder ico cancel simple');
	this.x_btn_cancel._value('FORM_BUTTONS::CANCEL');
	this.x_btn_cancel._onclick = function() { me._destruct(); };


	this.users._addColumns({
		user:{title:"SHARING::USER", width:260,type:'static', encode:true},
		perm:{title:"SHARING::PERMISSIONS", width:140, css:'ico more', type:'static'/*, encode:true*/},
		x:{width:30, css:'ico remove', type:'static'}
	});


	//Load Data
	var bEnable = true;

	this.__aData = {};
	/*
	this.__aData  = {'anyone':[]};
	this.__aData['['+ sPrimaryAccount.split('@').pop() +']'] = [];
	*/

	try{
		var tmp;
		if (this.__aFolderInfo.fid)
			tmp = WMFolders.list(this.__aFolderInfo)[this.__aFolderInfo.aid][this.__aFolderInfo.fid];
		else
			tmp = WMAccounts.list(this.__aFolderInfo)[this.__aFolderInfo.aid];

		if (tmp){

			if (tmp.INHERITED_ACL == '1')
				this._title(getLang('POPUP_FOLDERS::SHARING')+' - '+(aFolderInfo.fid?aFolderInfo.fid.replace(/^\~/g,''):aFolderInfo.aid) + ' ('+ getLang('SHARING::INHERITED') +')',true);

			if (tmp.RIGHTS && tmp.RIGHTS.indexOf('a')<0)
			    bEnable = false;

			tmp = tmp.ACL;
		}

		for(var i in tmp)
			this.__aData[i]  = tmp[i];

		tmp = null;
	}
	catch(r){
		bEnable = true;
	}

	var bPublic = dataSet.get('folders',[aFolderInfo.aid,aFolderInfo.fid,'PUBLIC']);

	//check for shared folder
	if (this.__aFolderInfo && this.__aFolderInfo.fid && (this.__aFolderInfo.fid.indexOf(sPrimaryAccountSPREFIX) === 0 || bPublic)){
		if (bPublic || this.__aFolderInfo.fid.indexOf('@')>0){
			var a = this.__aData[sPrimaryAccount] || this.__aData.anyone;
			if (Is.Array(a) && inArray(a,'a')>-1){
				//Enable All
				this.__bFormEnabled = true;
				this.add._disabled(false);
				this.remove._disabled(false);
				this.x_btn_ok._disabled(false);

				if (this.x_btn_inherit)
					this.x_btn_inherit._disabled(false);
			}
		}
	}
	//Enable All
	else
	if (bEnable){
		this.__bFormEnabled = true;
		this.add._disabled(false);
		this.remove._disabled(false);
		this.x_btn_ok._disabled(false);

		if (this.x_btn_inherit)
			this.x_btn_inherit._disabled(false);
	}

	this.__aData2 = clone(this.__aData,true);

	this._fill();

	//ok
	this.users._onclick = function (e,elm,arg,row,cell){
		if (me.__bFormEnabled && arg && arg.user && Is.Array(me.__aData[arg.user])){

			switch(cell){
				case 'x':
					me.remove._onclick();
					return;

				case 'perm':

					if (arg && me.__aData[arg.user]){
						var r = me.__aData[arg.user].sort().join(''),
							pos = getSize(elm);

						me.cmenu = gui._create('cmenu','obj_context');
						me.cmenu._fill([
							{title:'SETTINGS::READ', arg:['l','r'], css: 'ico2' + (r=='lr'?' check':'')},
							{title:'SETTINGS::WRITE', arg:['i','k','l','r','w'], css: 'ico2' + (r=='iklrw'?' check':'')},
							{title:'SETTINGS::ALL', arg:['i','k','l','r','t','w','x'], css: 'ico2' + (r=='iklrtwx'?' check':'')},
							{title:'SETTINGS::FULL', arg:['a','i','k','l','r','t','w','x'], css: 'ico2' + (r=='aiklrtwx'?' check':'')},
							{title:'-'},
							{title:'SHARING::NONE', arg:[], css: 'ico2' + (r=='-'?' check':'')}
						]);
						me.cmenu._place(pos.x+pos.w/2,pos.y+pos.h,null,1);

						me.cmenu._onclick = function(e, elm, id, arg2){
							if (arg && arg.user && Is.Array(arg2)){
								me.__aData[arg.user] = arg2;
								me._fill();
								updateCheckLists(arg2);
							}
						};

						//Stop Propagation
						e.cancelBubble = true;
						if (e.stopPropagation) e.stopPropagation();
					}
			}

			updateCheckLists(me.__aData[arg.user]);
		}
	};

	//Address Book
	this.add._onclick = function (){
		var frm = gui._create('address_book', 'frm_addaddress', '', '',[me, '__onAddNewFromAddressbook'], ['ADDRESS_BOOK::SELECTED_ADDRESSES'],[''],'',false,2);
	};

	//Remove
	this.remove._onclick = function (){
		var v = me.users._value();

		if (Is.Empty(v)) return;

		try{
			me.__aData[me.users._aData[v[0]].arg.user] = ['~'];
			me._fill();
		}
		catch(e){}

		if (!me.users._aData[v[0]] && me.users._aData.length>0){
			v = [me.users._aData.length-1];
			me.users._value(v);
		}

		if (me.users._aData[v[0]])
			updateCheckLists(me.users._aData[v[0]].arg.rights);
		else
			me.__disable_perm(true);
	};

	//Quick Add Input
	this.inp_add._disobeyEvent('change',[this.inp_add,'_checksize']);
	this.inp_add._checksize = function(){};
	this.inp_add._placeholder(getLang('SHARING::ENTER_ADDRESS'));
	this.inp_add._qvalue = function(v){
		this._value(v);
		this._setRange(v.length);
	};
	this.inp_add._onsubmit = function(){
		var tmp = MailAddress.splitEmailsAndNames(this._value());
		this._value('');
		if (tmp && tmp[0] && tmp[0].email)
			me.__onAddNewFromAddressbook(true,[[MailAddress.createEmail(tmp[0].name, tmp[0].email)]]);
	};
	this.inp_add._onmouseselect = this.inp_add._onsubmit;


	//Permissions Checkboxes
	function updateCheckLists (aData){
		var a = [
			'r','i','w','t',
			'l','k','x',
			'a'];

		for (var i in a)
			me[a[i]]._checked(inArray(aData, a[i])>-1);

		me.__disable_perm(false);
	};

	this.a._onchange = function(){
		var v = me.users._value();

		if (!Is.Empty(v))
			for(var i in v){
				var u = me.users._aData[v[i]].arg.user;

				if (this._value()){
					if (Is.Array(me.__aData[u])){
						if (inArray(me.__aData[u],this._name)<0)
							me.__aData[u].push(this._name);
					}
					else
						me.__aData[u] = [this._name];
				}
				else
				if (Is.Array(me.__aData[u])){
					var p = inArray(me.__aData[u],this._name);
					if (p>-1)
						me.__aData[u].splice(p,1);
				}

				me._fill();
			}
	};
	this.r._onchange = this.a._onchange;
	this.i._onchange = this.a._onchange;
	this.w._onchange = this.a._onchange;
	this.t._onchange = this.a._onchange;
	this.l._onchange = this.a._onchange;
	this.k._onchange = this.a._onchange;
	this.x._onchange = this.a._onchange;

	this.__disable_perm(true);

	//preselect first
	if (this.__aData2)
		for (var i in this.__aData2){
			this.users._value([0]);
			updateCheckLists(this.__aData2[i]);
			break;
		}
};

_me.__disable_perm = function (b){
	this.r._disabled(b);
	this.i._disabled(b);
	this.w._disabled(b);
	this.t._disabled(b);
	this.l._disabled(b);
	this.k._disabled(b);
	this.x._disabled(b);
	this.a._disabled(b);
};


_me._fill = function(){
	var aData = [],
		arr = {'aiklrtwx':getLang('SETTINGS::FULL'),'iklrtwx':getLang('SETTINGS::ALL'),'lr':getLang('SETTINGS::READ'),'iklrw':getLang('SETTINGS::WRITE'),'-':getLang('SHARING::NONE'),'*':getLang('SHARING::CUSTOM')};

	for(var i in this.__aData)
		if (this.__aData[i][0]!='~'){

			var r = this.__aData[i].sort().join('') || '-';

			aData.push({
				data:{
					user:(i=='anyone'?getLang('SHARING::ANONYMOUS'):i),
					perm:'<span>' + (arr[r] || arr['*']).escapeHTML() +'</span>'
				},
				arg:{user:i,rights:this.__aData[i]},
				css:Is.Array(this.__aData[i])?this.__aData[i].join(' '):''});
		}

	this.__disable_perm(Is.Empty(aData));
	this.users._fill(aData);
};


_me.__onAddNewFromAddressbook = function(bOK, aAddresses){

	if (bOK && aAddresses && aAddresses[0]){
		var tmp;
		for(var i in aAddresses[0]){
			tmp = MailAddress.splitEmailsAndNames(aAddresses[0][i]);
			if (tmp && (tmp = tmp[0]) && tmp.email && (!this.__aData[tmp.email] || this.__aData[tmp.email][0]=='~'))
				this.__aData[tmp.email] = ['r','l'];
		}

		this._fill();
	}
};


_me.__save = function(){

	this.x_btn_ok._disabled(true);
	if (this.x_btn_inherit)
		this.x_btn_inherit._disabled(true);

	var d1 = clone(this.__aData,true),
		d2 = clone(this.__aData2,true);

	if (!Is.Empty(this.__aData)){
		for(var i in d2)
			if (d1[i] && arrayCompare(d2[i],d1[i]))
				delete d1[i];

		//No change, do not save
		if (Is.Empty(d1)){
			this.__true();
			return;
		}
	}

	this.__aFolderInfo.acl = d1;
	if (this.__aFolderInfo.fid)
		WMFolders.add(this.__aFolderInfo,'null','',[this,'__true'],[this,'__false']);
	else
		WMAccounts.add(this.__aFolderInfo,'null','',[this,'__true'],[this,'__false']);
};

_me.__true = function(){
	this._destruct();

	if (this.__aHandler)
		executeCallbackFunction(this.__aHandler, true);
};

_me.__false = function(arr,id,str){
	if (id && str){
		gui._create('acl','frm_alert','','','','POPUP_FOLDERS::SHARING','',str);
		this.x_btn_ok._disabled(false);
	}
	else
		this.__true();
};