// INIT script

/**
 * @brief : Initial class for IceWarp WebMail
 * @date  : 6.3.2006 19:01:49
 * @status: draft
 * @require: storage
 *

  ? check opener (for valid webmail window)
  - parse input vars to GLOBAL cookie_vars and url_vars
  - choose page ($page <- "login" <- cookie_vars <- url_vars)
  - check ID (!isset than page = login)
  - load settings (if doesnt exist in [opener.]dataset)
  - get Lang (depeds on settings)
*/

function cInit(aLogin){

	//remove HTML
	document.getElementsByTagName('body')[0].innerHTML = '';

	//remove CSS
	/*
	var elinks = document.getElementsByTagName('link');
	for(var i=elinks.length-1;i>=0;i--){
		elinks[i].disabled = true;
		elinks[i].parentNode.removeChild(elinks[i]);
	}
	*/

	//append index.css
	document.getElementsByTagName('head')[0].appendChild(mkElement('link',{"rel":'stylesheet',"type":'text/css',"href":'client/skins/index.css'}));

	//Unique Session ID Number (to avoid avatar img cache)
	window.sSessionUID = unique_id();

	//Create httprequet
	window.request = new cRequest('server/webmail.php');

	//create gui
	window.gui = new cObject('gui');

	//bind loader to request
	window.request.onstart = function(){ gui._loading(true); };
	window.request.onfinish = function(){ gui._loading(); };


	//registr function to global variable, must be here because it will be used
	window.oWM_INIT = this;

	//allowed content
	var	allowed_get = {"page":'index',"debug":null,"frm":null,"sid":null,"ref":null,"xml":null,"username":null,"password":null,"mailto":null,"subject":null,"video":null,"meeting":null,"cc":null,"bcc":null,'open':null,'telemetry':null,'from':null};

	//parse cookies and get vars
	gui._REQUEST_VARS = arrConcat(arrKeySlice(aLogin.get, allowed_get),/*{"lang":aLogin.language},*/ arrKeySlice(parseURL(), allowed_get));

	if (aLogin.language)
		storage.language(aLogin.language);
	else{
		storage.library('gw_others');
		GWOthers.load(['layout_settings']);
		GWOthers.getItem('LAYOUT_SETTINGS','language');
		storage.language(GWOthers.getItem('LAYOUT_SETTINGS','language'));
	}

	//create connection manager
	gui._create('connection','obj_connection');
	gui._create('preloader','obj_loader');

	var erString = '';

	if (gui && !gui._REQUEST_VARS['frm'] && gui._REQUEST_VARS['sid']){

		var sURL,sid = auth.login({"session":gui._REQUEST_VARS['sid'], "keep":gui._REQUEST_VARS['open']?true:false, "from": gui._REQUEST_VARS['from']});

		//Save referrer, WM will be redirected back to this adress after logout
		if (gui._REQUEST_VARS['ref'])
			dataSet.add('main',['referrer_url'],gui._REQUEST_VARS['ref']);
		//hwn
		else
		if (location.hash.replace('#ref=','').length<location.hash.length)
			dataSet.add('main',['referrer_url'], location.hash.replace('#ref=',''));
		else
		if (document.referrer && document.referrer != document.location.href){

			var sRef = document.referrer, p;
			if ((p = sRef.indexOf('?'))>-1){
				var aRef = parseURL(sRef.substr(p+1));
				delete aRef.mid;
				delete aRef.msg;
				delete aRef.eid;
				delete aRef['_s[action]'];

				sRef = sRef.substr(0,p)+'?'+buildURL(aRef);
			}

			dataSet.add('main',['referrer_url'], sRef);
		}

		//Add SID into dataset
		if (sid){
			dataSet.add('main',['sid'],sid);

			//start login sequence
			//this._checkBrowserVersion();
			this._continueLogin();
			return;
		}
		else{
			if (Is.Object(auth.error)){
				switch (auth.error.id){
					case 'login_account_valid':
						erString = 'ACCOUNT_DISABLED';
						break;
					case 'login_invalid':
					case 'session_no_user':
						erString = 'INVALID_LOGIN';
						break;
					case 'session_expired':
						erString = 'EXPIRED';
						break;
					case 'session_ip_mismatch':
						erString = 'IP_MISMATCH';
						break;
					default:
						inspect2(auth.error);
				}
			}
			else
				erString = 'INVALID_LOGIN';
		}
	}
	else{
 		//login
		try{
			var hash=location.hash.replace('#',''); if (hash.replace(':','').length<hash.length) {var credentials=hash.split(':');gui._REQUEST_VARS['username']=credentials[0];gui._REQUEST_VARS['password']=credentials[1];location.hash='#';} // allow to login using #
			var sid = auth.login({username:gui._REQUEST_VARS['username'],password:gui._REQUEST_VARS['password']});
		}
		catch(r){
			erString = 'CONNECTION';
            sid = '';
		}

	    if (sid && !auth.error){
			//this._checkBrowserVersion();
			this._continueLogin();
			return;
		}
		else
		if (Is.Object(auth.error)){
			switch (auth.error.id) {
				case 'db_auto_create':
					erString = 'NO_DB';
					break;
				case 'login_account_valid':
					erString = 'ACCOUNT_DISABLED';
					break;
				case 'login_invalid':
					erString = 'INVALID_LOGIN';
					break;
				case 'wm_disabled':
					erString = 'WC_DISABLED';
					break;
				case 'settings_user_set':
					erString = 'ACCESS_ERROR';
					break;
				case 'RSA':
					erString = 'INVALID_RSA';
			}
		}
	}

	//refresh
	this._goBack(arrConcat(aLogin.back || {},{reason:erString}));
};

cInit.prototype._goBack = function (aParam) {
    storage.library('gw_others');

	var sURL = GWOthers.getItem('LAYOUT_SETTINGS','logout_url') || dataSet.get('main',['referrer_url']) || (document.location.protocol +'//'+ document.location.hostname + (document.location.port?':'+document.location.port:'') + document.location.pathname);
	if (aParam){
		var eForm = mkElement('form',{method:'POST',action:sURL,style:'position: absolute;top:0;left:0;'});
		for (var i in aParam)
        	eForm.appendChild(mkElement('input',{type:'hidden',name:i,value:aParam[i]}));

		gui._main.appendChild(eForm);

		eForm.submit();
		return;
	}

	/*
	var	sParam = aParam?buildURL(aParam):'';
		document.location.replace(sURL + (sParam?sParam:''));
	*/
};

/**
 * Login sequence
 * @note: moved from frm_login (4.7.2007 10:58:11)
 **/
/*
cInit.prototype._checkBrowserVersion = function () {
	switch (currentBrowser()) {

		case 'Mozilla':
		case 'Opera':
		case 'Safari':
		case 'Chrome':
		case 'MSIE9':
		case 'MSIE11':
			this._continueLogin(); // do nothing, the browser is supported
			break;

		case 'MSIE7':
			if (currentBrowser(true)>7){
				this._continueLogin();
				break;
			}


		// case 'MSIE6':
		// case 'MSIE7':

		// 	if (currentBrowser(true)==8){
		// 		this._continueLogin();
		// 		break;
		// 	}

		// 	storage.library('wm_storage');
		// 	storage.library('gw_others');

		// 	if (GWOthers.getItem('RESTRICTIONS', 'disable_ie6warning')){
		// 		this._continueLogin();
		// 		break;
		// 	}

		// 	//nacist "resources" do datasetu "storage"
		// 	dataSet.add('storage','',WMStorage.get({'resources':['login_data']}));

		// 	//precist data z datasetu "storage"
		// 	var iLastShow = parseInt(GWOthers.getItem('LOGIN_DATA', 'ie_6_warning_show_on'));

		// 	var iNow = parseInt((new Date()).getTime());
		// 	if (!Is.Number(iLastShow) || iLastShow <= iNow-(86400000)){
		// 		GWOthers.set('LOGIN_DATA',{'ie_6_warning_show_on':iNow},'storage');
		// 		WMStorage.set({'resources':dataSet.get('storage')},'storage');

  		//		gui.preloader._destruct();

		// 		var cfm = gui._create('frm_confirm','frm_confirm','','', [this, '_continueLogin'], 'CONFIRMATION::BROWSER_WARNING_TITLE','CONFIRMATION::BROWSER_WARNING_TEXT_IE7');
		// 		    cfm.btn_cancel._onclick = function() {
		// 				cfm._destruct();
		// 				document.location.href = './basic/?sid='+dataSet.get('main',['sid']);
		// 			};
		// 	}
		// 	else
		// 		this._continueLogin();

		// 	break;

		default:
			if (window.confirm(getLang('CONFIRMATION::BROWSER_WARNING_TEXT_UNSUPPORTED')))
				this._continueLogin();
			else
				document.location.href = './basic/?sid='+dataSet.get('main',['sid']);

			break;
	}
};
*/

cInit.prototype._continueLogin = function (b) {
	//re-create preloader in case of MSIE6
	if (!gui.preloader)
		gui._create('preloader','obj_loader');

	// [Sync] load of BIG JavaSript
	if (!gui._REQUEST_VARS['frm']){
		setTimeout(function(){if (gui.preloader) gui.preloader._value(getLang('PRELOADER::FRAMEWORK'));},0);
		storage.library('javascript');

		setTimeout(function(){if (gui.preloader) gui.preloader._value(getLang('PRELOADER::DOCEDIT'));},0);
		storage.library('leaflet', 'libreoffice');
		storage.library('leaflet.draw', 'libreoffice');
	}

	var old_skin = GWOthers.getItem('LAYOUT_SETTINGS', 'skin');

	// [Sync] load resources
	setTimeout(function(){if (gui.preloader) gui.preloader._value(getLang('PRELOADER::SETTINGS'));},0);
	GWOthers.load([	'skins',
					'im',
					'sip',
					'chat',
					'mail_settings_default',
					'mail_settings_general',
					'login_settings',
					'layout_settings',
					'homepage_settings',
					'calendar_settings',
					'default_calendar_settings',
					'cookie_settings',
					'default_reminder_settings',
					'event_settings',
					'spellchecker_languages',
					'signature',
					'groups',
					'restrictions',
					'aliases',
					'read_confirmation',
					'global_settings',
					'paths',
					'streamhost',
					'password_policy',
					'fonts',
					'certificate',
					'timezones',
					'external_settings',
					'gw_mygroup',
					'default_folders',
					'documents']);

	// load font
	storage.css('font');

	// Clear already downloaded templates
	if (old_skin != GWOthers.getItem('LAYOUT_SETTINGS', 'skin'))
		storage.aStorage.template = {};

	// [Sync] load language
	setTimeout(function(){if (gui.preloader) gui.preloader._value(getLang('PRELOADER::LANGUAGE'));},0);
	storage.language(/*gui._REQUEST_VARS['lang'] || */GWOthers.getItem('LAYOUT_SETTINGS','language'));

	//Browser Check
	switch (currentBrowser()) {
		case 'MSIE7':
			if (currentBrowser(true)<=7)
				return;

		case 'Mozilla':
		case 'Opera':
		case 'Safari':
		case 'Chrome':
		case 'MSIE9':
		case 'MSIE11':
			break;

		default:
			if (!window.confirm(getLang('CONFIRMATION::BROWSER_WARNING_TEXT_UNSUPPORTED'))){
				document.location.href = './basic/?sid='+dataSet.get('main',['sid']);
				return;
			}
	}

	// get accounts
	var aAccounts = WMAccounts.list();
	dataSet.add('accounts','',aAccounts);

	// refresh main account & continue preloading...
	this.__refreshed = false;
	WMFolders.list({'aid':sPrimaryAccount},'folders',[sPrimaryAccount],[this,'_updatePreloader']);

	// Convert language codes to iso 639-1 and set as language localisation attribute
	var iso = {cn: 'zh', dk: 'da', jp: 'ja', kr: 'ko', se: 'sv'},
		lang = GWOthers.getItem('LAYOUT_SETTINGS','language');
	document.documentElement.lang = iso[lang] || lang || 'en';

	// Compact interface
	if(GWOthers.getItem('LAYOUT_SETTINGS','compact_view')==1)
		addcss(document.getElementsByTagName('body')[0],'compact');

	// Add dropbox functionality if allowed
	var dbappkey = GWOthers.getItem('EXTERNAL_SETTINGS', 'dropbox_app_key') || '';
	if(GWOthers.getItem('RESTRICTIONS','disable_dropbox')!='1' && dbappkey.length) {
		var dropbox = document.createElement('script');
			dropbox.type = "text/javascript";
			dropbox.src = "https://www.dropbox.com/static/api/1/dropbox.js";
			dropbox.id = "dropboxjs";
			dropbox.setAttribute('data-app-key',dbappkey);
		document.getElementsByTagName('head')[0].appendChild(dropbox);
	}

	// Load JsSIP module for SIP calls with WebRTC
	if(sPrimaryAccountSIP) {
		storage.library('sip_bridge');
		if(typeof IceSIP!="undefined" && IceSIP.supported()) {
			dataSet.add('sip',['state'],'offline');
			dataSet.add('sip',['activity'],'');
			storage.library('icewarp-jssip-1.0','sip');
		} else window.JsSIP = null;
	} else window.JsSIP = null;

};

cInit.prototype._updatePreloader = function (sError) {

	if (!dataSet.get('folders',[sPrimaryAccount])){
		this.__refreshed = true;
		setTimeout(function(){if (gui.preloader) gui.preloader._value(getLang('PRELOADER::INDEXING'));},0);
		WMAccounts.refresh({'aid':sPrimaryAccount},'folders',[sPrimaryAccount],[this,'_updatePreloader']);
		return;
	}

	//Create Cookie
	storage.library('class_cookie');
	window.Cookie = new class_cookie();

	// [Async] Load style.css (marged css files)
	if (!gui._REQUEST_VARS['frm']){

		setTimeout(function(){
			if (gui.preloader)
				gui.preloader._value(getLang('PRELOADER::STARTUP'));
		},0);

		storage.css('style');
		storage.template('templates');
		storage.preloadObj();
	}

	if (gui.preloader)
		gui.preloader._destruct();

	var last_tz = Cookie.get(['tzoffset']),
		new_tz = (new Date()).getTimezoneOffset()*-1;

	if (sPrimaryAccountGW>0 && last_tz != new_tz && sPrimaryAccountTZO != new_tz){
		gui._create('timezone','frm_timezone','main','',[function(){
			gui._create("frm_main","frm_main","","",true);
		}]);
	}
	else
		gui._create("frm_main","frm_main","","",true);
};

///////////////////////////
function initPRO(aData){
	new cInit(aData);
};