_me = obj_audio.prototype;
function obj_audio(){};

_me.__constructor = function() {
	
	this.__dockable = true;
	this.__closable = true;

	var me = this;

	// HTML5 <audio> tag is supported in Internet Explorer 9+, Firefox, Opera, Chrome, and Safari
	//this.__audio = document.createElement('audio');
	this.__audio = mkElement('audio',{autoplay:'autoplay'}) || null;

	//IE9 Server 2008 fix
	try{
		if (this.__audio && this.__audio.canPlayType && this.__audio.canPlayType('audio/mpeg;').replace(/no/, '')){
		    this.__audio.loadedPercent = 100;
		    this.__audio.duration = 0;

		    this.__audio.skipTo = function(percent) {
				if (percent > this.loadedPercent) return;
				this.currentTime = this.duration * (percent/100);
			};

			this.__audio.setVolume = function(percent) {
				this.volume = percent;
			};
		}
		else
			this.__audio = null;
	}
	catch(r){
		this.__audio = null;
	}

	// Flash
	if (!this.__audio)
		if (this.__swfcheck()){

			var name = this._pathName +'-swf',
				ins = this._pathName+'.__audio',
				flashSource = '<object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" id="'+ name +'" width="1" height="1" name="'+ name +'" style="position: absolute; left: -1px;">'+
				'<param name="movie" value="client/inc/swf/audiojs.swf?playerInstance='+ ins +'&datetime='+ unique_id() +'">'+
				'<param name="allowscriptaccess" value="always">'+
				'<embed name="'+ name +'" src="client/inc/swf/audiojs.swf?playerInstance='+ ins +'&datetime='+ unique_id() +'" width="1" height="1" allowscriptaccess="always">'+
				'</object>';

			this._main.innerHTML = flashSource;

			this.__audio = {
				element: me.__getswf(name),
				swf: true,
				swf_ready: false,
				paused: true,
				src: '',
				currentTime: 0,
				duration: 0,
				loadedPercent: 0,
				volume: 100
			};

			this.__audio.loadStarted = function(){
				this.swf_ready = true;
				this.load();
			};

			this.__audio.load = function(){

				if (this.swf_ready && this.src){

					this.element.load(this.src);

					//fire event
					this.oncanplay();
					this.oncanplaythrough();				
				}	
			};

			this.__audio.play = function(){
				if (this.swf_ready && this.src){
					this.paused = false;
					this.element.pplay();

					//fire event
					this.onplay();
				}	
			};

			this.__audio.pause = function(){
				if (this.swf_ready && this.src){
					this.paused = true;
					this.element.ppause();
					
					//fire event
					this.onpause();
				}	
			};

			this.__audio.skipTo = function(percent) {
	        	if (percent <= audio.loadedPercent){

	        		this.updatePlayhead.call(percent);        	
					this.element.skipTo(percent);

					//fire event
					this.onseeked();
	        	}
			};

			this.__audio.setVolume = function(percent) {
				this.volume = percent;
				this.element.setVolume(percent);

				//fire event
				this.onvolumechange();
			};

			this.__audio.loadProgress = function(percent, duration){
				
				this.loadedPercent = percent;

				if (this.duration != duration){
					this.duration = duration;
					
					//fire event
					this.ondurationchange();
				}
			};

			this.__audio.updatePlayhead = function(percent){
				this.currentTime = this.duration*percent;
				this.ontimeupdate();

				//Missing onended event
				if (Math.ceil(this.currentTime) == Math.floor(this.duration)){
					if (me.__timeout)
						window.clearTimeout(me.__timeout);

					me.__timeout = setTimeout(function(){
						if (me.__audio){
							me.__audio.pause();		// important, stops ontimeupdate
							me.__audio.onended();
						}
					},1000);
				}
			};

		}
		else{
			this.__audio = null;
			return;
		}	


	// shared methods
	this.__audio.onplay = function(){
		me._dock();
		me._exe('play', {duration:this.duration, currentTime:this.currentTime});
	};

	this.__audio.onpause = function(){
		if (me._docked)
			me._dock();

		me._exe('pause', {duration:this.duration, currentTime:this.currentTime});
	};

	// show in dock
	this.__audio.oncanplay = function(){
		me._dock();
		me._exe('canplay');
	};

	// ready to play, start playing automatically
	this.__audio.oncanplaythrough = function(){

		if (me._docked)
			me._dock();

		if (!this.swf)
			this.loadedPercent = 100;

		me._exe('canplaythrough');

		me._play();
	};

	this.__audio.ontimeupdate = function(){
		me._docktimer();

		me._exe('timerupdate', {duration:this.duration, currentTime:this.currentTime});
	};

	this.__audio.ondurationchange = function(){
		me._docktimer();

		me._exe('durationchange', {duration:this.duration, currentTime:this.currentTime});
	};

	this.__audio.onended = function(){
		
		if (me.__dockable){
			me._docked = false;

			var dock = me._mydock || gui._dock;
			if (dock)
				dock._remove(me,true);
		}
	
		me._exe('ended');
		
		//Clear SRC, Chrome fix
		if (!this.swf)
			this.removeAttribute('src');
	};

	this.__audio.onvolumechange = function(){};
	this.__audio.onseeked = function(){
		me._exe('seeked', {duration:this.duration, currentTime:this.currentTime});
	};
	
	// Destructor
	this._add_destructor('__destructor');	
};

///////////////////////////////////////////////

_me._value = function(src, sTitle, aHandler){
	if (this.__audio)
		if (Is.Defined(src)){

			if (this.__audio.src){
				this._pause();
				this.__audio.onended();
			}

			//bind controler
			if (aHandler)
				this._obeyEvent('player', aHandler, src);

			this.__audio.title = sTitle;

			if (src){
				this.__audio.src = src;
				if (!this.__audio.swf || this.__audio.swf_ready)
					this.__audio.load();


			}			
		}
		else
		if (this.__audio.swf)
			return this.__audio.src || '';
		else		
			return this.__audio.getAttribute('src') || '';

	return '';	
};
_me._seek = function(i){
	if (this.__audio && this.__audio.src)
		this.__audio.skipTo(i || 0);
};
_me._play = function(){
	if (this.__audio && this.__audio.src)
		this.__audio.play();
};
_me._pause = function(){
	if (this.__audio)
		this.__audio.pause();
};
_me._playing = function(){
	return this.__audio && this.__audio.paused == false;
};

_me._playpause = function(){
	if (this.__audio){
		if (this.__audio.paused)
			this._play();
		else
			this._pause();
	}	
};

_me._exe = function (action, value){
	var src = this._value();
	if (this._events && this._events['player'])
		for (var j in this._events['player'])
			if (!src || !this._events['player'][j][1] || this._events['player'][j][1] == src)
				if (!this._events['player'][j] || !Is.Object(this._events['player'][j][0]) || executeCallbackFunction(this._events['player'][j][0], {src:src, action:action, value:value}) === false)
					this._events['player'].splice(j, 1);
};
///////////////////////////////////////////////

_me._dock = function (){
	var dock = this._mydock || gui._dock;

	if (this.__audio && this.__dockable && dock){

		var sTitle = /*Path.basename(src)*/this.__audio.title || getLang('AUDIO::PLAYER'),
			aCSS = [this._playing()?'pause':'play'];

		this._docked = true;
		this.__docktimer = dock._add(this,sTitle,aCSS.join(' '));

		this._docktimer();

		return true;
	}
};

_me._undock = function (){
	if (this.__dockable){
		if (this.__skipundock){
			this.__skipundock = false;
			this._docked = false;
			return true;
		}	
		
		if (this.__audio){
			this._playpause();
			this._dock();
			return false;
		}
	}
};

_me._docktimer = function(){
	if (this.__docktimer)
		if (this.__docktimer.parentNode){
			var elm = this.__docktimer.getElementsByTagName('EM'),
				tim = this.__docktimer.getElementsByTagName('TIME');

			if (!elm || !(elm = elm[0])){
				elm = mkElement('EM');
				this.__docktimer.appendChild(elm);
			}

			if (!tim || !(tim = tim[0])){
				tim = mkElement('TIME');
				this.__docktimer.appendChild(tim);
			}

			elm.style.width = (this.__audio.duration>this.__audio.currentTime?Math.ceil(this.__audio.currentTime/(this.__audio.duration/100)):100) + '%';

			tim.innerHTML = (new Date()).setUNIX(Math.ceil(this.__audio.currentTime)).format('MM:ss');
		}
		else
			this.__docktimer = null;
};

_me._close = function(){
	this.__skipundock = true;
	this._pause();
};

_me.__destructor = function (){
	if (this.__audio){
		this._pause();
		this.__audio = null;
	}
	return true;
};

///////////////////////////////////////////////

_me.__swfcheck = function(){
	if (navigator.plugins && navigator.plugins.length && navigator.plugins['Shockwave Flash'])
		return true;
	else
	if (navigator.mimeTypes && navigator.mimeTypes.length) {
		var mimeType = navigator.mimeTypes['application/x-shockwave-flash'];
		return mimeType && mimeType.enabledPlugin;
	}
	else
	try {
		var ax = new ActiveXObject('ShockwaveFlash.ShockwaveFlash');
		return true;
	}
	catch (r) {}
};

_me.__getswf = function(name) {
	var swf = document[name] || window[name];
	return swf.length > 1 ? swf[swf.length - 1] : swf;
};