_me = obj_context_item.prototype;
function obj_context_item() {};

obj_context_item.createColorMailMenu = function(id) {
	return [
	{"title": 'COLOR_LABELS::RED_FLAG', "css": 'ico2 bg_red', 'arg': [OldMessage.setColor, [id, Item.COLORS.RED]]},
	{"title": 'COLOR_LABELS::BLUE_FLAG', "css": 'ico2 bg_blue', 'arg': [OldMessage.setColor, [id, Item.COLORS.BLUE]]},
	{"title": 'COLOR_LABELS::GREEN_FLAG', "css": 'ico2 bg_green', 'arg': [OldMessage.setColor, [id, Item.COLORS.GREEN]]},
	{"title": 'COLOR_LABELS::ORANGE_FLAG', "css": 'ico2 bg_orange', 'arg': [OldMessage.setColor, [id, Item.COLORS.ORANGE]]},
	{"title": 'COLOR_LABELS::PURPLE_FLAG', "css": 'ico2 bg_purple', 'arg': [OldMessage.setColor, [id, Item.COLORS.PURPLE]]},
	{"title": 'COLOR_LABELS::YELLOW_FLAG', "css": 'ico2 bg_yellow', 'arg': [OldMessage.setColor, [id, Item.COLORS.YELLOW]]},
	{"title": '-'},
	{"title": 'COLOR_LABELS::FLAG_COMPLETE', "css": 'ico2 bg_complete', 'arg': [OldMessage.setColor, [id, Item.COLORS.COMPLETE]]},
	{"title": 'COLOR_LABELS::CLEAR_FLAG', "css": 'ico2 bg_none', 'arg': [OldMessage.setColor, [id, Item.COLORS.CLEAR]]}
	];
};

_me.__createMailMenu = function(id, ids, bMultiple, sFrom, aRights, bLimit) {

	// In Drafts or Sent folders some items should not be available:
	var folders = GWOthers.get('DEFAULT_FOLDERS', 'storage')['VALUES'],
		sFolderID = id[0] + '/' + id[1];

	// If SPAM_QUEUE/Blacklist folder doesn't exist, some items should not be available:
	var bDraft = (sFolderID == folders['drafts']),
		bTemplate = (sFolderID == folders['templates']),
		bSent = (sFolderID == folders['sent']),
		bRSS = dataSet.get('folders',[id[0],id[1],'RSS'])?true:false,
		bArchive = false;

	if (dataSet.get('main',['archive_path']) && sFolderID.indexOf(dataSet.get('main',['archive_path'])+'/') === 0){
		bArchive = true;

		if (sFolderID.indexOf(dataSet.get('main',['archive_path'])+'/Sent/') === 0)
			bSent = true;
	}

	var aMenu = [];
	if (bDraft)
		aMenu.push({"title": 'POPUP_ITEMS::EDIT', 'disabled': bMultiple, 'arg': [OldMessage.edit, [id]]});
	else
	if (bTemplate && !bLimit){
		aMenu.push({"title": 'MAIN_MENU::NEW_MESSAGE', 'disabled': bMultiple, 'arg': [OldMessage.edit, [id]]});
		aMenu.push({"title": 'POPUP_ITEMS::EDIT', 'disabled': bMultiple, 'arg': [OldMessage.edit, [id,true]]});
	}

	if (!bLimit){
		aMenu.push({"title": 'POPUP_ITEMS::OPEN_WINDOW', 'disabled': bMultiple, 'arg': [OldMessage.openwindow, [id]]});

		if (bTemplate)
			aMenu.push({"title": 'MAIN_MENU::NEW', 'arg': [NewMessage.compose,[{template:true}]]});
		else
			aMenu.push({"title": 'MAIN_MENU::NEW', 'arg': [NewMessage.compose]});
	}


	if (bSent && sPrimaryAccountDELIVERY && !bLimit)
		aMenu.push({"title": 'POPUP_ITEMS::DELIVERY_REPORT', 'disabled': bMultiple, 'arg': [OldMessage.delivery_report, [id]]});

	if(!bLimit)
		aMenu.push({"title": '-'});

	if (sFrom && !bDraft && !bTemplate){

		//Parse email (the same in frm_addaddress)
		var sTmp, aLCTval = {}, aFrom = MailAddress.splitEmailsAndNames(sFrom)[0];
		if (aFrom && aFrom.name)
			aLCTval = parseNameToLocation(aFrom.name,aLCTval);

		var tmp_amenu = [], tmp_cert;
		if (sPrimaryAccountGW>0){
			var dgw = GWOthers.getItem('RESTRICTIONS', 'disable_gw_types');
			if (!dgw || dgw.indexOf('c')<0){

				if (aFrom && aFrom.email)
					aLCTval.LOCATIONS = [{'values': {'LCTEMAIL1':aFrom.email,'LCTTYPE': 'H'}}];

				//Add Certificate
				if (dataSet.get('items',[id[0],id[1],id[2],'SMIME_STATUS'])>3)
					aLCTval.CERTIFICATES = [{values:{'class':'item','fullpath':id[0] +'/'+ id[1] +'/'+ WMItems.__serverID(id[2])}}];

				tmp_amenu.push({"title": 'POPUP_ITEMS::ADD_CONTACT', 'disabled': bMultiple,'arg': [gui, '_create', ['frm_contact', 'frm_contact', '', '', sPrimaryAccount, Mapping.getDefaultFolderForGWType('C'), '',aLCTval]]});
				tmp_cert = {"title": 'POPUP_ITEMS::CERT_TO_CONTACT', disabled: bMultiple || dataSet.get('items',[id[0],id[1],id[2],'SMIME_STATUS'])<4, 'arg': [Item.addCert,[id]]};
			}
		}

		//Add to IM Roster
		if (window.sPrimaryAccountIM && (GWOthers.getItem('RESTRICTIONS', 'disable_im') || 0)<1 && gui.frm_main && gui.frm_main.im && aFrom)
			tmp_amenu.push({"title": 'POPUP_ITEMS::ADD_IM', disabled: !gui.frm_main.im._is_active() || bMultiple,'arg': [gui.frm_main.im, '_add_item', ['', aFrom.email, aFrom.name]]});

		// Invite to appointment
		if(aFrom) tmp_amenu.push({"title": 'POPUP_ITEMS::INVITE_APPOINTMENT', disabled: false, arg: [Item.createInFolder, [id[0], "__@@VIRTUAL@@__/__@@EVENTS@@__",{
			CONTACTS: [{values:{CNTEMAIL: aFrom.email,CNTCONTACTNAME: aFrom.name,CNTROLE: 'Q', NEW: true}}]
		}]]});

		// Add Certificate after IM and Appointment
		if(tmp_cert)
			tmp_amenu.push(tmp_cert);

		// Add black/white list
		if (!bRSS && !bDraft && !bSent && (dataSet.get('folders', [sPrimaryAccount, 'SPAM_QUEUE/Blacklist']) || dataSet.get('folders', [sPrimaryAccount, 'SPAM_QUEUE/Whitelist'])))
			tmp_amenu.push(
				{"title": '-'},
				{"title": 'POPUP_ITEMS::BLACKLIST_SENDER', 'arg': [OldMessage.blacklistSender, [ids]],'disabled':dataSet.get('folders', [sPrimaryAccount, 'SPAM_QUEUE/Blacklist'])?false:true},
				{"title": 'POPUP_ITEMS::BLACKLIST_DOMAIN', 'arg': [OldMessage.blacklistDomain, [ids]],'disabled':dataSet.get('folders', [sPrimaryAccount, 'SPAM_QUEUE/Blacklist'])?false:true},
				{"title": 'POPUP_ITEMS::WHITELIST_SENDER', 'arg': [OldMessage.whitelistSender, [ids]],'disabled':dataSet.get('folders', [sPrimaryAccount, 'SPAM_QUEUE/Whitelist'])?false:true},
				{"title": 'POPUP_ITEMS::WHITELIST_DOMAIN', 'arg': [OldMessage.whitelistDomain, [ids]],'disabled':dataSet.get('folders', [sPrimaryAccount, 'SPAM_QUEUE/Whitelist'])?false:true}
			);

		aMenu.push({"title":'POPUP_ITEMS::MANAGE_SENDER',nodes:tmp_amenu});
	}

	aMenu.push(
	{"title": 'POPUP_ITEMS::SAVE_AS', 'arg': [Item.downloadSource, [id,'text']],
	"nodes":[
		{"title": 'POPUP_ITEMS::TEXT', 'disabled': bMultiple, 'arg': [Item.downloadSource, [id,'text']]},
		{"title": 'POPUP_ITEMS::HTML', 'disabled': bMultiple, 'arg': [Item.downloadSource, [id,'html']]},
		{"title": 'POPUP_ITEMS::EML', 'arg': [bMultiple?Item.downloadMultiple:Item.downloadSource, [bMultiple?ids:id]]}
	]
	},
	{"title": 'POPUP_ITEMS::SOURCE', 'arg': [OldMessage.source, [id]]},
	{"title":'-'});

	//if (1 || !bLimit){
		if (!bRSS && !bDraft && !bTemplate)
			aMenu.push({"title": bSent?'POPUP_ITEMS::REPLY_TO_ALL':'POPUP_ITEMS::REPLY_TO_SENDER', 'disabled': bMultiple, 'arg': [OldMessage.reply, [id, bSent]],
				nodes:[
					{"title": 'POPUP_ITEMS::REPLY_TO_SENDER', 'disabled': bMultiple || bSent, 'arg': [OldMessage.reply, [id, false]]},
					{"title": 'POPUP_ITEMS::REPLY_TO_ALL', 'disabled': bMultiple, 'arg': [OldMessage.reply, [id, true]]},
					{"title":'-'},
					{"title": 'MAIN_MENU::REPLY_TO_SENDER_T', 'disabled': bMultiple || bSent, 'arg': [OldMessage.replyTemplate, [id, false]]},
					{"title": 'MAIN_MENU::REPLY_TO_ALL_T', 'disabled': bMultiple, 'arg': [OldMessage.replyTemplate, [id, true]]}
				]});


/*

	if(!bLimit && !bTemplate)
		aMenu.push({"title": 'POPUP_ITEMS::FORWARD', 'disabled': bMultiple, 'arg': [OldMessage.forward, [id, false]]});

	aMenu.push({"title": 'POPUP_ITEMS::FORWARD_AS_MESSAGE', 'arg': [OldMessage.forward, [ids, true]]});

    if (!bTemplate && (GWOthers.getItem('RESTRICTIONS', 'disable_redirect') || 0)<1)
		aMenu.push({"title": 'POPUP_ITEMS::REDIRECT', 'disabled': bMultiple, 'arg': [OldMessage.redirect, [id]]});

*/

		if (bTemplate)
			aMenu.push({"title": 'POPUP_ITEMS::FORWARD_AS_MESSAGE', 'arg': [OldMessage.forward, [ids, true]]});
		else{
			var tmp = [
				{"title": 'POPUP_ITEMS::FORWARD', 'disabled': bMultiple, 'arg': [OldMessage.forward, [id, false]]},
				{"title": 'POPUP_ITEMS::FORWARD_AS_MESSAGE', 'arg': [OldMessage.forward, [ids, true]]}
			];

			if ((GWOthers.getItem('RESTRICTIONS', 'disable_redirect') || 0)<1)
				tmp.push({"title": 'POPUP_ITEMS::REDIRECT', 'disabled': bMultiple, 'arg': [OldMessage.redirect, [id]]});

			aMenu.push({"title": 'POPUP_ITEMS::FORWARD', 'disabled': false, 'arg': [OldMessage.forward, [id, false]],
				nodes:tmp
			});
		}
	// }
	// else
	//  if (!bTemplate && (GWOthers.getItem('RESTRICTIONS', 'disable_redirect') || 0)<1)
	// 	aMenu.push({"title": 'POPUP_ITEMS::REDIRECT', 'disabled': bMultiple, 'arg': [OldMessage.redirect, [id]]});


    aMenu.push(
	{"title": '-'},
	{"title": 'POPUP_ITEMS::MARK_AS_READ', 'arg': [OldMessage.markAsRead, [ids]],'disabled':!aRights.modify},
	{"title": 'POPUP_ITEMS::MARK_AS_UNREAD', 'arg': [OldMessage.markAsUnread, [ids]],'disabled':!aRights.modify},
	{"title": 'TAGS::TAGS', 'disabled': bArchive, 'arg': [Item.edit_tags, [ids]]},
	{"title": '-'}
	);

	aMenu.push(
	{"title": 'POPUP_ITEMS::MOVE_MAIL_TO', 'arg': [Item.move, [ids]],'disabled':!aRights.remove},
	{"title": 'POPUP_ITEMS::COPY_MAIL_TO', 'arg': [Item.copy, [ids]]}
	);

	if(!bLimit)
		aMenu.push({"title": 'POPUP_ITEMS::DELETE', 'arg': [this,'__deleteFromDG', [ids]],css:'color2','disabled':!aRights.remove});

	return aMenu;
};

_me.__createGWMenu = function(id, ids, sFolType, bMultiple, oRepeating, aAccess, sColumn, oObj, bLimit) {

	var oObj = oObj || this._owner,
		aMenu = [];

	if (sFolType == 'G'){
		aMenu.push(
			{"title":'POPUP_ITEMS::RECOVER', 'arg': [Item.recover, [ids]]},
			{'title':"-"},
			{"title":'POPUP_ITEMS::DELETE', 'arg': [this,'__deleteFromDG',[ids,oRepeating,oObj]],'css':'color2','disabled':!aAccess.remove}
		);
		return aMenu;
	}

	if (sFolType == 'L')
		aMenu.push({"title": 'POPUP_ITEMS::OPEN_ITEM', 'disabled': bMultiple, 'arg': [gui,'_create', [Mapping.getFormNameByGWType('L'),Mapping.getFormNameByGWType('L'),'','',id[0],id[1],id[2]]]});
	else
	if (sFolType == 'F'){

		var me = this;
		aMenu.push(	{"title":'POPUP_ITEMS::DOWNLOAD_FILE', 'arg': [(bMultiple?Item.downloadMultiple:Item.downloadFile), [bMultiple?ids:id]]});

		if (!bMultiple && sPrimaryAccountWebDAV){
			var sName = dataSet.get('items', [id[0], id[1], id[2], 'EVNTITLE']);
			if (sName)
				switch(Path.extension(sName)){
				case 'txt':
				case 'htm':
				case 'html':
					aMenu.push({"title":'POPUP_ITEMS::OPEN', 'arg': [Item.editFile, [id]]});
					break;

				case 'pdf':
					aMenu.push({"title":'POPUP_ITEMS::OPEN', 'arg': [Item.openPDF, [id]]});
					break;

				case 'mp3':
					if (gui.audio)
						aMenu.push({"title":'ATTACHMENT::PLAY_SOUND', 'arg': [Item.playFile, [id]]});
					break;

				default:
					if (Item.officeSupport(sName)) {
						var aArgWeb = [Item.officeOpen, [{aid:id[0],fid:id[1],iid:id[2]},[Item.downloadFile,[id]], Path.extension(sName),false]];
						var aArgExt = [Item.officeOpen, [{aid:id[0],fid:id[1],iid:id[2]},[Item.downloadFile,[id]], Path.extension(sName),true]];

						if(dataSet.get('accounts',[sPrimaryAccount,'USE_LIBREOFFICE'])=="true") {
							aMenu.push({
								title:'POPUP_ITEMS::OPEN',
								arg: aArgWeb,
								'nodes':[
									{"title":'DOCUMENT::OPENDOCUMENT', 'arg': aArgWeb},
									{"title":'OFFICELAUNCHER::OFFICESUITE', 'arg': aArgExt}
								]
							});
						} else
							aMenu.push({"title":'POPUP_ITEMS::OPEN', 'arg': aArgWeb});
					}
				}
		}
	}
	else if(!bLimit)
		aMenu.push({"title": 'POPUP_ITEMS::OPEN_ITEM', 'disabled': bMultiple, 'arg': [Item.openwindow, [id,oRepeating]]});


	if (sFolType == 'F'){

		//Try to get Lock_id
		var sLockID;
		if (!(sLockID = dataSet.get('items',[id[0], id[1], Is.Array(id[2])?id[2][id[2].length-1]:id[2],'EVNLOCKOWN_ID'])))
			sLockID = dataSet.get('items', [id[0], id[1], Is.Array(id[2])?id[2][id[2].length-1]:id[2],'EVNLOCKOWN_ID']);

		var bLocked = sLockID && sLockID != sPrimaryAccountGWID,
			aRights = WMFolders.getRights({aid:id[0], fid:id[1]});

		if(!bLimit) aMenu.push(
		{	"title":'MAIN_MENU::NEW',
			'arg': [Item.createInFolder, [id[0], id[1]]],
			'disabled':!aAccess.write,
			'nodes':[
				{"title": 'MAIN_MENU::NEW_UPLOAD', 'arg': [Item.createInFolder, [id[0], id[1]]]},
				{"title": '-'},
				{"title": 'MAIN_MENU::NEW_WORD', 'arg': [Item.createInFolder, [id[0], id[1], {'ATTACHMENTS':[{'values':{'ATTTYPE':'document', 'ATTDESC': '.docx'}}]}]]},
				{"title": 'MAIN_MENU::NEW_EXCEL', 'arg': [Item.createInFolder, [id[0], id[1], {'ATTACHMENTS':[{'values':{'ATTTYPE':'document', 'ATTDESC': '.xlsx'}}]}]]},
				{"title": 'MAIN_MENU::NEW_PPOINT', 'arg': [Item.createInFolder, [id[0], id[1], {'ATTACHMENTS':[{'values':{'ATTTYPE':'document', 'ATTDESC': '.pptx'}}]}]]},
				{"title": 'MAIN_MENU::NEW_TEXT', 'arg': [Item.createInFolder, [id[0], id[1], {'ATTACHMENTS':[{'values':{'ATTTYPE':'document', 'ATTDESC': '.txt'}}]}]]},
				{"title": 'MAIN_MENU::NEW_HTML', 'arg': [Item.createInFolder, [id[0], id[1], {'ATTACHMENTS':[{'values':{'ATTTYPE':'document', 'ATTDESC': '.html'}}]}]]}
			]
		});

		aMenu.push(
		{"title":'ITEM::SHARE', 'arg': [function(){
			gui._create('frm_public_url', 'frm_public_url','','',[ids[0],ids[1],[ids[2][0]]]);
		}], 'disabled': bMultiple},
		{"title":'-'},
		{"title":'POPUP_ITEMS::DOC_MANAGEMENT', 'disabled': bMultiple, 'arg': [Item.openwindow, [id,oRepeating]]},
		{"title":'ITEM::NEW_REVISION', 'arg': [function(){
			gui._create('revision', 'frm_revision','','',{aid:ids[0],fid:ids[1],iid:ids[2][0]});
		}], 'disabled':!aAccess.modify || bMultiple},
		{"title":'POPUP_ITEMS::SEND_NOTIFY', 'arg': [function(){
			gui._create('notify','frm_notify','','',ids);
		}], 'disabled':!aAccess.modify},
		{"title": (sLockID?'FILE::UNLOCK':'FILE::LOCK'), 'arg': [Item.set_lock, [ids,sLockID?false:true,true]],'disabled':!aAccess.modify || (!aRights.owner && bLocked)});
	}
	else if(!bLimit)
		aMenu.push({"title":'MAIN_MENU::NEW','arg': [Item.createInFolder, [id[0], id[1]]],'disabled':!aAccess.write});

	if (sFolType == 'T')
		aMenu.push({"title": 'MAIN_MENU::PRINT', 'arg':[Item.print,[ids]]});

	if (sFolType == 'C' || sFolType == 'L')
		aMenu.push({"title":'POPUP_ITEMS::NEW_DISTRIBLIST', 'arg': [Item.create, ['L', id[0], id[1]]],'disabled':!aAccess.write});

	if (sFolType == 'C'){
		var aContact = dataSet.get('items', [id[0], id[1], id[2]]);
		if (!aContact) return aMenu;

		aMenu.push({"title":'-'});

		if (window.sPrimaryAccountSIP && !bLimit)
			aMenu.push({"title":'MAIN_MENU::DIAL',"arg":[obj_context_item.__call,[id]]});

		if (window.sPrimaryAccountMEETING && !bLimit)
			aMenu.push({"title":'MAIN_MENU::CONFERENCE',"arg":[obj_context_item.__conference,[id]]});

		if (window.sPrimaryAccountSMS && !bLimit)
			aMenu.push({"title":'MAIN_MENU::SMS',"arg":[obj_context_item.__sms,[ids]]});

		if (gui.frm_main && gui.frm_main.im){
			var sJID = '';

			if (gui.frm_main.im._is_active())
				if (aContact.LCTIM && gui.frm_main.im._inRoster(aContact.LCTIM))
					sJID = aContact.LCTIM.toLowerCase();
				else
				if (aContact.LCTEMAIL1 && gui.frm_main.im._inRoster(aContact.LCTEMAIL1))
					sJID = aContact.LCTEMAIL1.toLowerCase();
				else
				if (aContact.LCTEMAIL2 && gui.frm_main.im._inRoster(aContact.LCTEMAIL2))
					sJID = aContact.LCTEMAIL2.toLowerCase();
				else
				if (aContact.LCTEMAIL3 && gui.frm_main.im._inRoster(aContact.LCTEMAIL3))
					sJID = aContact.LCTEMAIL3.toLowerCase();

			aMenu.push({"title": 'IM::CHAT', disabled: !sJID, 'arg':[gui.frm_main.im,'_chat',[sJID]]});
		}

		aMenu.push({"title": 'MAIN_MENU::PRINT', 'arg':[Item.print,[ids]]});

		if (aContact.LCTEMAIL1 || aContact.LCTEMAIL2 || aContact.LCTEMAIL3){
			aMenu.push(
			{"title":'-'},
			{"title":'POPUP_ITEMS::SEND_EMAIL_TO',"caption":true}
			);

			var sName = aContact.ITMCLASSIFYAS || ((aContact.ITMSURNAME || '') + (aContact.ITMFIRSTNAME?' '+aContact.ITMFIRSTNAME:'')) || '';

			if (aContact.LCTEMAIL1)
				aMenu.push({"text":aContact.LCTEMAIL1.entityify(),'arg': [NewMessage.compose,[{to:MailAddress.createEmail(sName,aContact.LCTEMAIL1)}]]});

			if (aContact.LCTEMAIL2)
				aMenu.push({"text":aContact.LCTEMAIL2.entityify(),'arg': [NewMessage.compose,[{to:MailAddress.createEmail(sName,aContact.LCTEMAIL2)}]]});

			if (aContact.LCTEMAIL3)
				aMenu.push({"text":aContact.LCTEMAIL3.entityify(),'arg': [NewMessage.compose,[{to:MailAddress.createEmail(sName,aContact.LCTEMAIL3)}]]});
		}
	}
	else
	if (sFolType == 'L'){
		var aContact = dataSet.get('items', [id[0], id[1], id[2]]);
		aMenu.push(
		{"title":'-'},
		{"title":'POPUP_ITEMS::SEND_EMAIL_TO','arg':[NewMessage.compose,[{to:'['+aContact.fid+'::'+(aContact.ITMCLASSIFYAS || aContact.ITMTITLE)+']'}]]}
		);
	}

    aMenu.push(
	{"title":'-'},
	{"title":'POPUP_ITEMS::SEND_AS_EMAIL', 'arg': [Item.sendAsEmail, [ids]]});


	if (sFolType == 'C' && gui.frm_main && gui.frm_main.im){
		var sName = aContact.ITMCLASSIFYAS || ((aContact.ITMSURNAME || '') + (aContact.ITMFIRSTNAME?' '+aContact.ITMFIRSTNAME:'')) || '';
		aMenu.push({"title": 'POPUP_ITEMS::ADD_TO_IM', disabled: !aContact.LCTIM || !gui.frm_main.im._is_active() || gui.frm_main.im._inRoster(aContact.LCTIM),'arg': [gui.frm_main.im, '_add_item', ['', aContact.LCTIM, sName]]});
	}

	aMenu.push({"title": 'TAGS::TAGS', 'arg': [Item.edit_tags, [ids]]});

	if (sFolType != 'F'){
		var sDownload;
		switch (sFolType) {
			case 'C':
			case 'L':	sDownload = 'DOWNLOAD_VCARD'; break;
			case 'E':
			case 'J':
			case 'T':	sDownload = 'DOWNLOAD_VCALENDAR'; break;
			case 'N':	sDownload = 'DOWNLOAD_VNOTE'; break;
			default:	sDownload = 'DOWNLOAD_SOURCE'; break;
		}

		aMenu.push(
			{'title':"-"},
			{"title":'POPUP_ITEMS::' + sDownload,  'arg': [bMultiple?Item.downloadMultiple:Item.downloadSource, [bMultiple?ids:id]]}
			);
	}

	/*
	aMenu.push(
	{"title": '-'},
	{"title": 'ITEMVIEW::PREVIEW',nodes:[
		{"title": 'ITEMVIEW::DOWN', 'arg': [gui.frm_main.main,'_changeview',['list_view']],'disabled':gui.frm_main.main._type == 'frm_main_datagrid_view'},
              {"title": 'ITEMVIEW::RIGHT', 'arg': [gui.frm_main.main,'_changeview',['list_wide']],'disabled':gui.frm_main.main._type == 'frm_main_datagrid_wide'},
              {"title": 'ITEMVIEW::NONE', 'arg': [gui.frm_main.main,'_changeview',['list']],'disabled':gui.frm_main.main._type == 'frm_main_datagrid'}
	]});
	*/

	aMenu.push({'title':"-"});

	//Rename File
	if (oObj && sFolType == 'F'){
		aMenu.push({"title":'FORM_BUTTONS::RENAME', 'arg': [
			function(){

				if (oObj._editColumn){
					oObj._editColumn(id[2],'EVNFILENAME',{},[Item.edit_value,[id,'EVNFILENAME']]);

					if (oObj.edit){
						var v = (oObj || me._owner).edit._value(),
							p = v.lastIndexOf('.');
						oObj.edit._setRange(0,p>-1?p:v.length);
					}
				}

			}], disabled:bMultiple || !aAccess.modify || !id[2] || bLocked});
	}

	aMenu.push(
	{"title":'POPUP_ITEMS::MOVE_ITEM_TO', 'arg': [Item.move, [ids]],'disabled':!aAccess.remove || bLocked},
	{"title":'POPUP_ITEMS::COPY_ITEM_TO', 'arg': [Item.copy, [ids]]}
	);

	// For calender type, check if it is an open invitation and offer to accept it
	if(sFolType == 'E' && ids[2].length==1) {
		var itm = dataSet.get('items',id);
		var prelim = itm && itm.EVNFLAGS && itm.EVNFLAGS&32;
		// If it is an invitation offer to accept it directly in calandar
		if(prelim)
			aMenu.push({title:'FILTERS::ACCEPT', arg: [WMItems,'imip', [{aid: id[0], fid: id[1], iid: id[2]},'accept',[function(){Item.__refreshView(ids);}]]],disabled: false});
	}
	// Delete or if preliminary reject invitation
	if(!bLimit)
		aMenu.push({"title":prelim?'FILTERS::REJECT':'POPUP_ITEMS::DELETE', 'arg': [this,'__deleteFromDG',[ids,oRepeating,oObj]], 'css':'color2','disabled':!aAccess.remove || bLocked});

	return aMenu;
};



obj_context_item.createQuarantineMenu = function(ids) {
	return [
	{"title": 'POPUP_ITEMS::DELIVER', 'arg': [OldMessage.deliver, [ids]]},
	{"title": 'POPUP_ITEMS::WHITE_LIST', 'arg': [OldMessage.whitelist, [ids]]},
	{"title": 'POPUP_ITEMS::BLACK_LIST', 'arg': [OldMessage.blacklist, [ids]]},
	{"title": 'POPUP_ITEMS::DELETE', 'css':'color2', 'arg': [Item.remove, [ids]]}
	];
};

obj_context_item.createBlacklistMenu = function(ids,arg) {
	return [
	{"title": 'POPUP_ITEMS::WHITE_LIST', 'arg': [OldMessage.whitelist, [ids]]},
	{"title": 'MAIN_MENU::NEW', 'arg': [gui, '_create', ['frm_blackwhite', 'frm_blackwhite', '', '', ids[0], ids[1]]]},
	{"title": '-'},
	{"title": 'POPUP_ITEMS::SEND_EMAIL_TO', 'arg': [NewMessage.compose, [{to:arg.data.SNDEMAIL}]]},
	{"title": '-'},
	{"title": 'POPUP_ITEMS::DELETE', 'css':'color2', 'arg': [Item.remove, [ids]]}
	];
};

obj_context_item.createWhitelistMenu = function(ids,arg) {
	return [
	{"title": 'POPUP_ITEMS::BLACK_LIST', 'arg': [OldMessage.blacklist, [ids]]},
	{"title": 'MAIN_MENU::NEW', 'arg': [gui, '_create', ['frm_blackwhite', 'frm_blackwhite', '', '', ids[0], ids[1]]]},
	{"title": '-'},
	{"title": 'POPUP_ITEMS::SEND_EMAIL_TO', 'arg': [NewMessage.compose, [{to:arg.data.SNDEMAIL}]]},
	{"title": '-'},
	{"title": 'POPUP_ITEMS::DELETE', 'css':'color2', 'arg': [Item.remove, [ids]]}
	];
};

_me._fillMenu = function(sType, arg, iid_list, bDisableOpen, aInitMenu, sColumn, oObj)
{
	var id = [arg['aid'], arg['fid'], arg['iid']],
		ids = [arg['aid'], arg['fid'], iid_list],
		bMultiple = iid_list.length > 1,
		aRights = WMFolders.getAccess(arg),
		aMenu = [];

	if (!bMultiple && arg.data && arg.data.EVNOWN_ID == sPrimaryAccountGWID)
		aRights = {'read':true,'write':true,'modify':true,'remove':true,'owner':true};



	if (sColumn == 'COLOR' && aRights.modify) {
		addcss(this._main,"obj_context_itemflags");
		aMenu = obj_context_item.createColorMailMenu(ids);
	}
	else
	switch (sType) {
		case 'E':
		case 'J':
		case 'T':
		case 'N':
		case 'F':
		case 'C':
		case 'G':
		case 'L':
			aMenu = this.__createGWMenu(id, ids, sType, bMultiple,'',aRights,sColumn,oObj);
			break;
		case 'M':
			var sFrom = dataSet.get('items', id.concat(['FROM']));
			aMenu = this.__createMailMenu(id, ids, bMultiple, sFrom, aRights);
			break;
		case 'Q':
			aMenu = obj_context_item.createQuarantineMenu(ids);
			break;
		case 'QL':
			if (arg['fid'].indexOf('White') >= 0)
				aMenu = obj_context_item.createWhitelistMenu(ids,arg);
			else
				aMenu = obj_context_item.createBlacklistMenu(ids,arg);
			break;
	}

	if (aInitMenu) {
		aInitMenu = reverse(aInitMenu);
		for (var i in aInitMenu)
			aMenu.unshift(aInitMenu[i]);
	}

	this._fill(aMenu);
};

obj_context_item.__call = function (id){
	if (id)
		gui.frm_main.hmenu3.__showDialDialog(id[0],id[1],id[2]);
};

obj_context_item.__sms = function (id){
	if (id)
		gui.frm_main.hmenu3.__showSMSDialog(id[0],id[1],id[2]);
};

obj_context_item.__conference = function (id){
	if (id)
		gui.frm_main.hmenu3.__showConferenceDialog(id[0],id[1],id[2]);
};

_me.__deleteFromDG = function (ids, oRepeating, oObj){
	if (ids){
		var oObj = oObj || this._owner;

		if (oObj && oObj._type == 'obj_datagrid2_ext' && oObj.__deleteItems){
			var ov = oObj._value();
			if (ids[2].length>1 || ov[0]==ids[2][0]){
				oObj.__deleteItems({aid:ids[0],fid:ids[1]},ids[2],false,oRepeating);
				return;
			}
		}

       	Item.remove(ids,false,oRepeating);
	}
};


_me._fillGeneralMenu = function(sType, oFolder) {
	var aMenu;

	if (oFolder){
		var aid = oFolder['aid'];
		var fid = oFolder['fid'];
		var aRights = WMFolders.getAccess(oFolder);
	}

	switch(sType) {
		case 'M':
			if (oFolder && aid+'/'+fid == GWOthers.getItem('DEFAULT_FOLDERS', 'templates'))
				aMenu = [{"title": 'MAIN_MENU::NEW', 'arg': [NewMessage.compose, [{template:true}]],'disabled':!aRights.write}];
			else
				aMenu = [{"title": 'MAIN_MENU::NEW', 'arg': [NewMessage.compose],'disabled':!aRights.write}];

			break;

		case 'QL':
			aMenu = [{"title": 'MAIN_MENU::NEW', 'arg': [gui, '_create', ['frm_blackwhite', 'frm_blackwhite', '', '', aid, fid]]}];
			break;

		case 'E':
			aMenu =[
				{"title": 'MAIN_MENU::NEW', 'arg': [Item.createInFolder, [aid, fid]],'disabled':!aRights.write},
				{"title": '-'},
				{"title": 'MAIN_MENU::DAY_VIEW', 'arg': [gui.frm_main, '_selectView', [oFolder, 'day_view', true]]},
				{"title": 'MAIN_MENU::WEEK_VIEW', 'arg': [gui.frm_main, '_selectView', [oFolder, 'week_view', true]]},
				{"title": 'MAIN_MENU::MONTH_VIEW', 'arg': [gui.frm_main, '_selectView', [oFolder, 'month_view', true]]},
				{"title": 'MAIN_MENU::EVENTS_LIST', 'arg': [gui.frm_main, '_selectView', [oFolder, 'list_view', true]]}
			];
			break;

		case 'C':
			aMenu = [
				{"title": 'MAIN_MENU::NEW', 'arg': [Item.createInFolder, [aid, fid]],'disabled':!aRights.write},
				{"title": 'POPUP_ITEMS::NEW_DISTRIBLIST', 'arg': [Item.create, ['L', aid, fid]],'disabled':!aRights.write}
			];
			break;

		case 'T':
			aMenu = [{"title": 'MAIN_MENU::NEW', 'arg': [Item.createInFolder, [aid, fid]],'disabled':!aRights.write}];
			break;

		case 'J':
			aMenu = [{"title": 'MAIN_MENU::NEW', 'arg': [Item.createInFolder, [aid, fid]],'disabled':!aRights.write}];
			break;

		case 'N':
			aMenu = [{"title": 'MAIN_MENU::NEW', 'arg': [Item.createInFolder, [aid, fid]],'disabled':!aRights.write}];
			break;

		case 'F':
			aMenu = [
				{"title": 'MAIN_MENU::NEW_UPLOAD', 'arg': [Item.createInFolder, [aid, fid]],'disabled':!aRights.write},
				{"title": '-'},
				{"title": 'MAIN_MENU::NEW_WORD', 'arg': [Item.createInFolder, [aid, fid, {'ATTACHMENTS':[{'values':{'ATTTYPE':'document', 'ATTDESC': '.docx'}}]}]],'disabled':!aRights.write},
				{"title": 'MAIN_MENU::NEW_EXCEL', 'arg': [Item.createInFolder, [aid, fid, {'ATTACHMENTS':[{'values':{'ATTTYPE':'document', 'ATTDESC': '.xlsx'}}]}]],'disabled':!aRights.write},
				{"title": 'MAIN_MENU::NEW_PPOINT', 'arg': [Item.createInFolder, [aid, fid, {'ATTACHMENTS':[{'values':{'ATTTYPE':'document', 'ATTDESC': '.pptx'}}]}]],'disabled':!aRights.write},
				{"title": 'MAIN_MENU::NEW_TEXT', 'arg': [Item.createInFolder, [aid, fid, {'ATTACHMENTS':[{'values':{'ATTTYPE':'document', 'ATTDESC': '.txt'}}]}]],'disabled':!aRights.write},
				{"title": 'MAIN_MENU::NEW_HTML', 'arg': [Item.createInFolder, [aid, fid, {'ATTACHMENTS':[{'values':{'ATTTYPE':'document', 'ATTDESC': '.html'}}]}]],'disabled':!aRights.write}
			];

			break;
	}

	this._fill(aMenu);
};