/***
	SIZE AWARE Small Mode View 
	14.3.2013

	@aParams:
		rows (int)		- row height multiplicator
		size (int)		- switch trashold
		sort (str)		- column name
		sorttype (str)	- asc | desc
***/
_me = obj_datagrid_small.prototype;
function obj_datagrid_small(){};

_me.__constructor = function(){
	this.__small = false;
	this.__smallOptions = null;
};

_me._small = function (aParams){

	if (!aParams){
		//Remove resize handler
		if (this.__smallOptions != null){
			var eFrame = this._main.getElementsByTagName('iframe')[0];
				eFrame.parentNode.removeChild(eFrame);
		}
		this.__smallOptions = null;

		this._smallfilter = '';

		if (this.sort)
			this.sort._destruct();
		if (this.filter)
			this.filter._destruct();
	}
	else{
		var me = this;

		//Add resize handler
		if (this.__smallOptions == null){
			
			var eFrame = mkElement('iframe',{frameborder:0,name:this._pathName + "#frame", marginheight:0, marginwidth:0, src:"", id: this._pathName + '#frame'});

			//	Use src="javascript: void(0);" in case of SSL problems
			//	var doc = eFrame.contentDocument || eFrame.contentWindow.document;
			//		doc.write();

			this._main.appendChild(eFrame);

			eFrame.contentWindow.onresize = function (e){
				if (this.__width != eFrame.offsetWidth){
					this.__width = eFrame.offsetWidth;

					if (me._onsize && me.__smallOptions!=null)
						me._onsize(true);
				}	
			};
		}

		if (aParams.sorting && !this.sort){
			this._create('sort', 'obj_select','','sort');
			this.sort._onchange = function(){
				var v = this._value();

				if (v && me._serverSort)
					me._serverSort('', v, me.sortdir._value());
			};

			this._create('sortdir', 'obj_label','','dir');

			this.sortdir._onclick = function(e){
				this._value(this._value() == 'asc'?'desc':'asc');
			};
			this.sortdir._value = function(v,bNoUpdate){
				if (typeof v != 'undefined'){
			
					if (v == 'asc'){
						removecss(this._main, 'desc');
						addcss(this._main, 'asc');
						this.__sort = 'asc';
					}
					else{
						removecss(this._main, 'asc');
						addcss(this._main, 'desc');
						this.__sort = 'desc';
					}

					if (!bNoUpdate && me._serverSort && me.sort._value())
						me._serverSort('', me.sort._value(), this.__sort);
				}
				else
					return this.__sort || 'desc';
			};
		}

		if (aParams.filters && !this.filter){
			this._create('filter', 'obj_label','','filter');
			this.filter._onclick = function (e){
				var elm = e.target || e.srcElement;
				if (elm && elm.tagName == 'A'){
					me._smallfilter = elm.getAttribute('rel') || '';

					//Save to Cookie
					if (me._cookiesEnabled){
						var aFolder = me._getFolder();
						Cookie.set(['views',aFolder['aid'],aFolder['fid'],'filter'], me._smallfilter);
					}

					// if (me._onfilter)
					// 	me._onfilter(me._smallfilter);
					
					me._serverSort();

					return false;						
				}
			};
		}

		this.__smallOptions = aParams;
		this.__smallOptions.size = this.__smallOptions.size || 500;
	}
	
	this._onsize();
};

_me._onsize = function(bRefresh){

	if (this.__smallOptions == null){
		if (this.__small == true){
			this.__small = false;
			removecss(this._main,'small');
			this._row_height = this._original_height;
		}
		else
			return;
	}	
	else{
		var width = this._main.offsetWidth;

		if (width<=this.__smallOptions.size && !this.__small)
			this.__small = true;
		else
		if (width>this.__smallOptions.size && this.__small)
			this.__small = false;
		else
			bRefresh = false;

		if (this.__small){
			addcss(this._main,'small');
			this._row_height = 25*(this.__smallOptions.rows || 1);
		}	
		else{
			removecss(this._main,'small');
			this._row_height = this._original_height;
		}
	}

	// Compact view decreases padding around rows
	if(GWOthers.getItem('LAYOUT_SETTINGS','compact_view')==1) 
		this._row_height -= this.__small ? 20 : 8;

	if (bRefresh){
		//clear limit
		this.__limit = [0,0];
		//refreah
		if (this._serverSort)
			this._serverSort();
		else
			this._fill();
	}
};