
/*
 *	Document preview and editing container
 *
 *

   on.hyperlinkclicked(erg.url) -> open popup
 */

function obj_document() {};

obj_document.prototype.__constructor = function() {
	var me = this;

	this.__scrollinit = false;
	this.__toolbarinit = false;
	this.__debug = gui._REQUEST_VARS['frm']?true:false;

	this.__doc = this._getAnchor('doc');

	//Height fix
	msiebox(this._getAnchor('msiebox'));

	// X Scrollbar
	this._create('x', 'obj_scrollbar','doc','x', false);

	//Unlock
	this._getAnchor('locked').onclick = function(e){
		if (me.__aItemInfo && me.__sTicket){

			//auto-lock file
			Item.set_lock([me.__aItemInfo.aid,me.__aItemInfo.fid,me.__aItemInfo.iid], true, false, [function(bOK){
				if (bOK === true){
					me.__locked = true;
					//me._view.setPermission('edit');
					me._reopen();
				}
				else{
					me.__locked = false;
					me._view.setPermission('readonly');

					gui._create('lock','frm_alert','','','','FILE::LOCK','ALERTS::UNLOCK');
				}
			}]);
		}
	};
};

obj_document.prototype._reopen = function() {

	//kill leaflet
	if (this._view)
		this._view.remove();

	//remove scrollbars
	if (this.__scrollinit){
		if (this.xy) this.xy._destruct();
		if (this.y) this.y._destruct();
		if (this.sheets) this.sheets._destruct();
		this.__scrollinit = false;
	}

	//disable toolbars
	var aObj = this._getChildObjects('tools');
	for(var i in aObj)
	    if (aObj[i]._disabled)
	        aObj[i]._disabled(true, true);

	var aObj = this._getChildObjects('tools2');
	for(var i in aObj)
	    if (aObj[i]._disabled)
	        aObj[i]._disabled(true, true);

	this.__toolbarinit = false;

	//Re-open the document
	this._open(this.__aItemInfo, this.__sTicket);
};

obj_document.prototype._open = function(aItemInfo, sTicket) {

		var me = this;

		this.__aItemInfo = aItemInfo;
		this.__sTicket = sTicket;

		if (sTicket)
			addcss(this._main, 'editable');

		var aItem = clone(this.__aItemInfo);
			aItem.values = ['EVNTITLE','EVN_MODIFIED','EVNLOCKOWN_ID'];

		WMItems.list(aItem, '', '', '', [function(aResult){

			if (Is.Object(aResult) && (aResult = aResult[me.__aItemInfo.aid]) && (aResult = aResult[me.__aItemInfo.fid]) && (aResult = aResult[me.__aItemInfo.iid])){

				for (var sAtId in aResult['ATTACHMENTS']){

					// Locked
					if (aResult.EVNLOCKOWN_ID){

						// by ME?
						me.__locked = (aResult.EVNLOCKOWN_ID == sPrimaryAccountGWID);

						//INIT
						if (!me._destructed && me._init){

							me._init(aResult.ATTACHMENTS[sAtId].values.TICKET, aResult.EVN_MODIFIED);

							//TITLE
							if (me._oninit)
								me._oninit({title:aResult.EVNTITLE});
						}
					}
					// Unlocked
					else{

						//Lock file
						Item.set_lock([me.__aItemInfo.aid,me.__aItemInfo.fid,me.__aItemInfo.iid], true, false, [function(bOK){

							me.__locked = (bOK === true);

							//INIT
							if (!me._destructed && me._init){

								me._init(aResult.ATTACHMENTS[sAtId].values.TICKET, aResult.EVN_MODIFIED);

								//TITLE
								if (me._oninit)
									me._oninit({title:aResult.EVNTITLE});
							}

						}]);
					}

					break;
				}
			}
		}]);
};

// Open file from webdav
obj_document.prototype._init = function(sURL, iTimeStamp) {

	this.__scrollinit = false;

	var me = this;

	try{
		var renderingOptions = {
			".uno:HideWhitespace": {
				"type": "boolean",
				"value": "true"
			},
			".uno:ShowBorderShadow": {
				"type": "boolean",
				"value": "false"
			}
		};

		var initOptions = {
			doc: sURL,
			//server: 'ws://192.168.6.176:9980',
			server: (document.location.protocol=='https:'?'wss:':'ws:')+'//'+document.location.host+'/loolwsd/',
			webserver: document.location.protocol+'//'+document.location.host+'/loolwsd',
			autoFitWidth:true,
			zoom:10,
			renderingOptions: renderingOptions,
			permission: (this.__sTicket && this.__locked?'edit':'readonly'),
			documentContainer: this._getAnchor('doc').parentElement,
			imagePath:'client/skins/'+  GWOthers.getItem('LAYOUT_SETTINGS', 'skin') + '/libre/images',
			cursorURL:'client/skins/'+  GWOthers.getItem('LAYOUT_SETTINGS', 'skin') + '/libre/cursors'
        };

		//GET Timestamp
		if (iTimeStamp)
			initOptions.timestamp = iTimeStamp;

    	this._view = L.map(this._getAnchor('doc'), initOptions);
	}
	catch(r){
		if (console)
			console.log('leaflet init error', r);

		return;
	}

	//basic controls
	this._view.addControl(L.control.columnHeader());
	this._view.addControl(L.control.rowHeader());

	//Command Buffer
	this._view.__commandBuffer = {toolbarcommandvalues:{}};
	this._view.on('commandstatechanged', function (e) {
		if (e.type = "commandstatechanged" && e.commandName)
			this.__commandBuffer[e.commandName] = e.state;
	});
	this._view.on('updateparts', function(arg){
		if (arg.partNames)
			this.__commandBuffer['partNames'] = arg.partNames;
	});
	this._view.on('cellformula', function(arg){
		this.__commandBuffer['cellformula'] = arg.formula || '';
	});

	//debug
	// this._view.on('updatetoolbarcommandvalues', function(arg){
	// 	if (arg.commandName){
	// 		this.__commandBuffer['toolbarcommandvalues'][arg.commandName] = true;
	// 		me._initToolbars();
	// 	}
	// });

	this._view.getCommandValue = function(commandName){
		return this.__commandBuffer[commandName];
	};

	//save handler
	this._view.on('commandresult', function(arg){

		if (arg.commandName == 'saveas'){

			//destructed view, this should never happen
			if (me._destructed){
				try{
					me._view.remove();
					me._view = null;
				}
				catch(r){}

				//remove lock
				// if (me.__aItemInfo && me.__locked)
				// 	Item.set_lock([me.__aItemInfo.aid,me.__aItemInfo.fid,me.__aItemInfo.iid], false, true);
			}

			if (arg.success == true){
				gui.notifier._value2(getLang('NOTIFIER::ITEM_SAVE'));

				if (me._onsave)
					me._onsave(true);
			}
			//Error :(
			else{
				gui.notifier._value2(getLang('DOCUMENT::SAVE_ERROR'));
				if (me._onsave)
					me._onsave(false);
			}
		}
	});


	this._add_destructor('__onDestruct');

	//Resize handler
	this._view.on('resize', function(arg){
		if (this.x)
			this.x._size(arg.newSize.x, true);

		if (this.y)
			this.y._size(arg.newSize.y, true);
		else
		if (this.xy)
			this.xy._size(arg.newSize.x, arg.newSize.y, true);

	}, this);

	this._view.on('docsize', function(arg){

		var o = this._view.scrollOffset();

		if (this.x){
			this.x._range(arg.x, true);
			this.x._size(this.__doc.clientWidth, true);
		}

		if (this.y){
			this.y._range(arg.y, true);
			this.y._size(this.__doc.clientHeight, true);
		}
		else
		if (this.xy){
			this.xy._range(arg.x, arg.y, true);
			this.xy._size(this.__doc.clientWidth, this.__doc.clientHeight, true);
		}

	}, this);

	//auto scroll to search
	this._view.on('scrollto', function(arg){
		this._view.scrollLeft(arg.x);
		this._view.scrollTop(arg.y);

		//update scroll offset manually
		this._view.fire('updatescrolloffset', this._view.scrollOffset());
	}, this);

	this._view.on('updatescrolloffset', function(arg){
		this.x._value(arg.x, true);

		if (this.y)
			this.y._value(arg.y, true);
		else
		if (this.xy)
			this.xy._value(arg.x, arg.y, true);
	}, this);


	this._view.on('statusindicator', function(arg){

		if (this.__debug)
			console.log('statusindicator', me.__scrollinit, arguments);

		switch(arg.statusType){
			case "setvalue":
				if (arg.value < 100){
					this._getAnchor('loader').style.display = '';
					this._getAnchor('loader').style.width = arg.value + '%';
					break;
				}

			case "finish":
				this._getAnchor('loader').style.display = 'none';
			break;

			case "alltilesloaded":
				this._getAnchor('loader').style.display = 'none';

				if (!this.__scrollinit){

					this.__scrollinit = true;

					switch(this._view.getDocType()){
						case 'presentation':
							addcss(this._main, 'preview presentation');

							this._create('xy', 'obj_document_parts','preview','', this._view);

							this.xy._onchange = function(arg){
								me._view.setPart(arg.part);
							};
							break;

						case 'text':
							addcss(this._main, 'preview');
							this._create('xy', 'obj_document_scrollbar','preview','', this._view);

							//Attach Scrollbar
							this.xy._onchange = function(arg){
								me._view.scrollTop(arg.value.y);
								me._view.scrollLeft(arg.value.x); //, {update:true}

								//fire once
								me._view.fire('updatescrolloffset',me._view.scrollOffset());
							};
							break;

						case 'spreadsheet':

							//tabs
							addcss(this._main, 'sheets');
							this._create('sheets', 'obj_document_sheets','sheets','', this._view);

						default:
							this._create('y', 'obj_scrollbar','doc','y', false);

							//Attach Scrollbar
							this.y._onchange = function(arg){
								me._view.scrollTop(arg.value, {update:true});
							};
					}

					//Attach Scrollbar
					this.x._onchange = function(arg){
						me._view.scrollLeft(arg.value, {update:true});
					};

					//OPEN LINK
					this._view.on('hyperlinkclicked', function (e) { window.open(e.url, '_blank'); });
				}

				//refresh scrollbars
				this._view.fire('docsize',this._view.getDocSize());

			break;

			case "initializationcomplete":
				this._initToolbars();
			break;

			case "reconnected":
				if (this.__error && !this.__error._destructed)
					this.__error._destruct();

				if (console)
					console.log('Leaflet RECONNECTED');
			break;

			case "loleafletloaded":
				if (this._oninit)
					this._oninit({state:'loaded'});
			break;
		}

	}, this);

	this._view.on('error', function(arg){

		//One instance is enough for now
		if (this.__error && !this.__error._destructed)
			this.__error._destruct();

		//	"Socket connection closed"
		this.__error = gui._create('doc_error','frm_alert','','error', '', 'DOCUMENT::ERROR', 'DOCUMENT::ERROR_MSG');

		if (arg.msg && document.console)
			console.log('error',arg);

	}, this);

	//keypress
	this._view.on('keyup', function(arg){

		var e = arg.originalEvent;

		if (this._view.getPermission() == 'view'){

			if (me._view.getDocType() == "presentation"){
				var p = me._view.getNumberOfParts();
				if (p>1)
					switch(e.keyCode){
						//PgUp
						case 33:
							me._view.setPart('prev');
							break;
						//PgDn
						case 34:
							me._view.setPart('next');
							break;
						//End
						case 35:
							me._view.setPart(p-1);
							break;

						//Top
						case 36:
							me._view.setPart(0);
							break;
					}
			}
			else
				switch(e.keyCode){

					//PgUp
					case 33:
						me._view.scroll(0, me._view.getSize().y*-1, {update:true});
						break;
					//PgDn
					case 34:
						me._view.scroll(0, me._view.getSize().y, {update:true});
						break;

					//End
					case 35:
						if (me.y)
							me._view.scrollTop(me.y._range(), {update:true});
						break;

					//Top
					case 36:
						me._view.scrollTop(0, {update:true});
						break;
				}
		}
		else
		//Save Ctrl+S
		if (this._view.getPermission() == 'edit' && e.keyCode == 83 && (e.ctrlKey || e.metaKey)){
			this._save();
		}

	}, this);

	//Attach mouse wheel
	AttachEvent(this.__doc, "onmousewheel", function(e){
		var deltaY = e.deltaY,
			deltaX = e.deltaX;

		//scroll view
		me._view.scroll(e.deltaX*12,e.deltaY*12, {update:true});
	});


	//Permissions
	this._view.on('updatepermission', function(arg){

		if (this.__debug)
			console.log('updatepermission',arg);

		removecss(me._main, 'view','edit','readonly');
		addcss(me._main, arg.perm);

		// this._view.__commandBuffer['permission'] = arg.perm;
		// this._initToolbars();

		if (this.__toolbarinit){
			//disable toolbars
			var aObj = me._getChildObjects('tools');
			for(var i in aObj)
			    if (aObj[i]._disabled)
			        aObj[i]._disabled(arg.perm != 'edit');

			var aObj = me._getChildObjects('tools2');
			for(var i in aObj)
			    if (aObj[i]._disabled)
			        aObj[i]._disabled(arg.perm != 'edit');
		}

	}, this);
};

// Document zoom
obj_document.prototype._zoomin = function() {
	this._view.zoomIn(1);
}
obj_document.prototype._zoomout = function() {
	this._view.zoomOut(1);
}
obj_document.prototype._zoomfit = function() {
	this._view.fitWidthZoom(this._view.getMaxZoom());
}


// Document search
obj_document.prototype._find = function(word) {
	this._lastsearch = word || '';
	this._view.highlightAll(this._lastsearch);
	this._view.search(this._lastsearch);
}
obj_document.prototype._findprevious = function() {
	this._view.search(this._lastsearch || '', true);
}
obj_document.prototype._findnext = function() {
	this._view.search(this._lastsearch || '');
}

obj_document.prototype._save = function(){
	if (this.__sTicket && this.__locked && this._view.getCommandValue('.uno:ModifiedStatus') == 'true'){
		this._view.saveAs(this.__sTicket);
		return true;
	}

	return false;
};

// Destruct leaflet
obj_document.prototype.__onDestruct = function(){
	try{
		this._view.remove();
		this._view = null;

		if (this.__aItemInfo && this.__locked)
			Item.set_lock([this.__aItemInfo.aid,this.__aItemInfo.fid,this.__aItemInfo.iid], false, true);
	}
	catch(r){}
};

obj_document.prototype._initToolbars = function(){
	if (!this.__toolbarinit){

		// var tb = this._view.getCommandValue('toolbarcommandvalues');
		// if (tb['.uno:StyleApply'] && tb['.uno:CharFontName'] && this._view.getCommandValue('finish') && this._view.getCommandValue('permission')){

			this.__toolbarinit = true;
			var bDisabled = this._view.getPermission() != 'edit';

			//destruct old toolbars
			var aObj = this._getChildObjects('tools');
			for(var i in aObj)
			    if (!aObj[i]._destructed)
			        aObj[i]._destruct();

			var aObj = this._getChildObjects('tools2');
			for(var i in aObj)
			    if (!aObj[i]._destructed)
			        aObj[i]._destruct();

			//base
			this._create('tb_base', 'obj_document_base','tools','', this._view);
			this.tb_base._disabled(bDisabled);

			//text
			this._create('tb_text', 'obj_document_text','tools','', this._view);
			this.tb_text._disabled(bDisabled);

			switch(this._view.getDocType()){
				case 'text':

					this._create('tb_align', 'obj_document_align','tools','', this._view);
					this.tb_align._disabled(bDisabled);

					this._create('tb_upload', 'obj_document_upload','tools','', this._view);
					this.tb_upload._disabled(bDisabled);
					break;

				case 'presentation':
					this._create('tb_align', 'obj_document_align','tools','', this._view);
					this.tb_align._disabled(bDisabled);

					this._create('tb_upload', 'obj_document_upload','tools','', this._view);
					this.tb_upload._disabled(bDisabled);
					break;

				case 'spreadsheet':
					this._create('tb_align', 'obj_document_align','tools','', this._view);
					this.tb_align._disabled(bDisabled);

					this._create('tb_upload', 'obj_document_upload','tools','', this._view);
					this.tb_upload._disabled(bDisabled);


					this._create('tb_formula', 'obj_document_formula','tools2','', this._view);
					this.tb_formula._disabled(bDisabled);
					this._getAnchor('tools2').style.display = 'block';
					break;
			}

			this._create('tb_search', 'obj_document_search','tools','', this);
		// }
	}
};

/*
//doesnt work as expected
obj_document.prototype._getFocusElement = function(){
	if (this._view && this._view._docLayer)
		return this._view._docLayer._textArea;

	return false;
};
obj_document.prototype._focus = function(){
	if (this._view && this._view.focus)
		this._view.focus();
};
*/