
_me = obj_document_parts.prototype;
function obj_document_parts() {};

_me.__constructor = function(view){
	var me = this;

	//retina
	this.__pixelRatio = window.devicePixelRatio || 1;

	this._view = view;
	this._imgs = [];

	this._width = '145';

	//Create body container
	this.__body = mkElement('div', {className:'maxbox relative'});
	this._main.appendChild(this.__body);

	this._scrollbar(this.__body,this._main);
	this._disable_scrolbar(this.__body, true, false);

	this.__body.onclick = function(e){
		var	e = e || window.event,
			elm = e.target || e.srcElement;

		if (elm.tagName == 'P')
			me._part(elm.getAttribute('rel')*1);

		// me._view.focus();

		// e.cancelBubble = true;
		// e.preventDefault();
		// e.stopPropagation();

		return false;
	};

	//listen to tiles
	this._view.on('tilepreview', function(arg){

		if (me._imgs[arg.id]){
			me._imgs[arg.id].firstChild.style.height = (arg.height/me.__pixelRatio) + 'px';
			me._imgs[arg.id].setAttribute('rel', arg.part);
			me._imgs[arg.id].firstChild.src = arg.tile;

			if (arg.part == me.__part){
				addcss(me._imgs[arg.id], 'active');
				me.__scroll();
			}
		}
		//problem?
		else{

		}

	}, this);


	this._view.on('updateparts', function(arg){

		var partNames = arg.partNames;

		if (pgn<arg.parts){
			addParts(pgn, arg.parts-pgn);
			pgn = arg.parts;
		}
		else
		if (pgn>arg.parts){
			removeParts(arg.parts-1, pgn-arg.parts);
			pgn = arg.parts;
		}

		me._part(arg.selectedPart,true);
	}, this);

	this._view.on('search', function(arg){

		console.log(arg);

		//remove previous searches
		var a = me.__body.getElementsByTagName('STRONG');
		for(var i = a.length-1;i>=0; i--)
			a[i].parentNode.removeChild(a[i]);
		var a = me.__body.getElementsByTagName('B');
		for(var i = a.length-1;i>=0; i--)
			a[i].parentNode.removeChild(a[i]);

		if (arg.count>0){
			var k = this.__getScale(),
				p, rec;

			for (var i = arg.results.length-1; i>=0; i--){
				if ((p = this._getPart(arg.results[i].part))){
					//draw
					for(var j = arg.results[i].rectangles.length-1; j>=0; j--){
						rec = arg.results[i].rectangles[j];

						//rectangle
						p.appendChild(mkElement('STRONG', {style:{width: ((rec.max.x - rec.min.x)*k) + 'px', height: ((rec.max.y - rec.min.y)*k) + 'px', left: (rec.min.x*k) + 'px', top: (rec.min.y*k) + 'px'}}));

						//marker
						p.appendChild(mkElement('B', {style:{top: ((rec.min.y + (rec.max.y - rec.min.y)/2)*k) + 'px'}}));
					}
				}
			}


		}

	}, this);

	//// LOAD images ////
	var doc = this._view.getDocSize(),
		pgn = this._view.getNumberOfParts(),
		h = Math.round(this._width * (doc.y/doc.x));

	function removeParts(iOffset,iLimit){
		for (var id = iOffset + iLimit; id>iOffset; id--){
			me._view.removePreviewUpdate(id);
			if (me._imgs[id]){
				if (me._imgs[id].parentNode)
					me._imgs[id].parentNode.removeChild(me._imgs[id]);

				me._imgs.splice(id,1);
			}
		}
	};

	function addParts(iOffset,iLimit){
		var aNames = me._view.getCommandValue('partNames');

		for (var id = iOffset; id<iOffset + iLimit; id++){

			var img = mkElement('img',{style:{height:h + 'px'}});
				img.ondragstart = function(){ return false };
				img.onload = function(){
					this.style.opacity = '1';
				};

			var p = mkElement('p',{id:me.__makeID(id), title:aNames[id] || ''}),
				i = mkElement('span',{innerHTML: id + 1});

			p.setAttribute('rel', id);
			p.appendChild(img);
			p.appendChild(i);

			me.__body.appendChild(p);
			me._imgs.push(p);

			me._view.getPreview(id, id, me._width*me.__pixelRatio, doc.y, {autoUpdate: true});
		}
	};
	addParts(0, pgn);
	this._part(this._view.getCurrentPartNumber(), true);
};

_me.__makeID = function(i){
	return this._pathName + '/' + i;
};


_me._range = function(x, y, bUpdate) {
	if (Is.Defined(x) && Is.Defined(y)) {
		this.__range = {x:x,y:y};

		// if (!bUpdate) this.__handle();
		// this.__draw();
	}
	else
		return this.__range;
};

_me._size = function(x, y, bUpdate){
	if (Is.Defined(x) && Is.Defined(y)) {
		this.__size = {x:x<0?0:x, y:y<0?0:y};

		// if (!bUpdate) this.__handle();
		// this.__draw();
	}
	else
		return this.__size;
};

_me._value = function(x, y, bUpdate) {
	if (Is.Defined(x) && Is.Defined(y)) {

		this.__value = {x:x<0?0:x, y:y<0?0:y};

		// if (!bUpdate) this.__handle();
		// this.__draw();
	}
	else
		return this.__value;
};

_me._part = function(i, bUpdate) {
	if (Is.Defined(i)) {

		// remove old
		var elm;
		if (Is.Defined(this.__part))
			if ((elm = this._getPart(this.__part)))
				removecss(elm, 'active');

		this.__part = i;

		// set new
		if ((elm = this._getPart(this.__part))){
			addcss(elm, 'active');
			this.__scroll();
		}

		if (!bUpdate)
			this.__handle();
	}
	else
		return this.__value;
};

_me._getPart = function(id){
	return document.getElementById(this.__makeID(id));
};

_me.__handle = function(){
	if (Is.Number(this.__part)){
		if (this._onchange)
			this._onchange({part:this.__part, value:this.__value, range:this.__range, size:this.__size});

		this.__exeEvent('onchange',null,{"owner":this, part:this.__part, value:this.__value, range:this.__range, size:this.__size});
	}
};

//Scroll to view
_me.__scroll = function(){
	if (Is.Defined(this.__part)){
		var elm = document.getElementById(this.__makeID(this.__part));
		if (elm){
			var pos1 = getSize(elm),
				pos2 = getSize(this.__body);

			if (pos1.y+pos1.h>pos2.y+pos2.h)
				this.__body.scrollTop += (pos1.y+pos1.h) - (pos2.y+pos2.h);
			else
			if (pos1.y<pos2.y)
				this.__body.scrollTop += pos1.y-pos2.y;
		}
	}
};

_me.__getScale = function(){
	return this._width/this._view.getDocSize().x;
};