
_me = obj_document_scrollbar.prototype;
function obj_document_scrollbar() {};

_me.__constructor = function(view){
	var me = this;

	//retina
	//((window.matchMedia && (window.matchMedia('only screen and (min-resolution: 124dpi), only screen and (min-resolution: 1.3dppx), only screen and (min-resolution: 48.8dpcm)').matches || window.matchMedia('only screen and (-webkit-min-device-pixel-ratio: 1.3), only screen and (-o-min-device-pixel-ratio: 2.6/2), only screen and (min--moz-device-pixel-ratio: 1.3), only screen and (min-device-pixel-ratio: 1.3)').matches)) || (window.devicePixelRatio && window.devicePixelRatio > 1.3));
	this.__pixelRatio = window.devicePixelRatio || 1;

	this._view = view;
	this._imgs = [];

	this._width = 145; // in px

	//Create body container
	this.__body = mkElement('div', {className:'maxbox relative'});
	this._main.appendChild(this.__body);

	this._scrollbar(this.__body,this._main);
	this._disable_scrolbar(this.__body, true, false);

	this.__body.onmousedown = function(e){
		// Scrollbar is not initialized yet
		if (!me.__elm) return;

		var ox, oy,
			e = e || window.event,
			elm = e.target || e.srcElement;

		// Click on scroller
		if (elm == me.__elm){
			// ox = e.layerX || e.x;
			// oy = e.layerY || e.y;
			var s = getSize(elm);
				ox = gui.__X - s.x;
				oy = gui.__Y - s.y;
		}
		// Click outside
		else{
			ox = Math.ceil(me.__elm.offsetWidth/2);
			oy = Math.ceil(me.__elm.offsetHeight/2);
		}

		gui._obeyEvent('mousemove',[me,'__scrollMove',[ox,oy]]);
		gui._obeyEvent('mouseup',[me,'__scrollEnd']);

		//move it now
		me.__scrollMove(e, null, ox, oy);

		return false;
	};


	//// LOAD images ////

	var doc = this._view.getDocSize(),
		pgn = this._view.getNumberOfPages();

	this._view.on('pagenumberchanged', function(arg){

		if (pgn<arg.pages){
			addTitles(pgn, arg.pages-pgn);
			pgn = arg.pages;
		}
		else
		if (pgn>arg.pages){
			removeTitles(arg.pages-1, pgn-arg.pages);
			pgn = arg.pages;
		}
	});


	this._view.on('tilepreview', function(arg){

		//Update Tile
		if (me._imgs[arg.id]){
			me._imgs[arg.id].firstChild.style.height = (arg.height/me.__pixelRatio) + 'px';
			me._imgs[arg.id].firstChild.style.width = (arg.width/me.__pixelRatio) + 'px';
			me._imgs[arg.id].firstChild.src = arg.tile;
		}
		//problem?
		else{

		}

	}, this);


	this._view.on('search', function(arg){

		if (arg.highlightAll == 'true' || arg.count == 0) {

			//remove previous searches
			var a = me.__body.getElementsByTagName('STRONG');
			for(var i = a.length-1;i>=0; i--)
				a[i].parentNode.removeChild(a[i]);
			var a = me.__body.getElementsByTagName('B');
			for(var i = a.length-1;i>=0; i--)
				a[i].parentNode.removeChild(a[i]);

			//draw searches
			if (arg.originalPhrase && arg.originalPhrase.length && arg.originalPhrase && arg.count){

				var rec,
					ps = me._view.getPageSizes().pixels,
					k = me.__getScale();

				for (var i = 0; i<arg.results.length; i++)
					for (var j = 0; j<arg.results[i].rectangles.length; j++){
						rec = arg.results[i].rectangles[j];
						me.__body.appendChild(mkElement('strong', {style:{width: ((rec.max.x - rec.min.x)*k) + 'px', height: ((rec.max.y - rec.min.y)*k) + 'px', left: ((rec.min.x - ps[0].min.x)*k) + 'px', top: ((rec.min.y - ps[0].min.y)*k) + 'px'}}));
						me.__body.appendChild(mkElement('b', {style:{top: ((rec.min.y + (rec.max.y - rec.min.y)/2 - ps[0].min.y)*k) + 'px'}}));
					}
			}
		}

	}, this);


	//FINAL
	function removeTitles(iOffset,iLimit){
		for (var id = iOffset + iLimit; id>iOffset; id--){
			me._view.removePreviewUpdate(id);
			if (me._imgs[id]){
				if (me._imgs[id].parentNode)
					me._imgs[id].parentNode.removeChild(me._imgs[id]);

				me._imgs.splice(id,1);
			}
		}
	};

	//FINAL
	function addTitles(iOffset,iLimit){
		var ps = me._view.getPageSizes().pixels;

		//get max width
		var maxw = 0;
		for(var i = ps.length-1; i>=0; i--)
			maxw = Math.max(ps[i].max.x - ps[i].min.x, maxw);

		for (var id = iOffset; id<iOffset + iLimit; id++)
			if (ps[id]){
				var k = (ps[id].max.x-ps[id].min.x)/maxw,
					h = (ps[id].max.y-ps[id].min.y)/(ps[id].max.x-ps[id].min.x)*me.__body.clientWidth,
					img = mkElement('img', {id:me.__makeID(id), style:{height: h + 'px'}});

					img.ondragstart = function(){ return false };
					img.onload = function(){
						this.style.opacity = '1';
					};

				var p = mkElement('p'),
					i = mkElement('span',{innerHTML:id + 1});

				p.appendChild(img);
				p.appendChild(i);

				me.__body.appendChild(p);
				me._imgs.push(p);

				me._view.getPreview(id, id, Math.ceil(me._width*k)*me.__pixelRatio, doc.y, {autoUpdate: true});
			}

	};

	addTitles(0, pgn);
};

_me.__makeID = function(i){
	return this._pathName + '/' + i;
};

_me._range = function(x, y, bUpdate) {
	if (Is.Defined(x) && Is.Defined(y)) {
		this.__range = {x:x,y:y};

		if (!bUpdate)
			this.__handle();

		this.__draw();
	}
	else
		return this.__range;
};

_me._size = function(x, y, bUpdate){
	if (Is.Defined(x) && Is.Defined(y)) {
		this.__size = {x:x<0?0:x, y:y<0?0:y};

		if (!bUpdate)
			this.__handle();

		this.__draw();
	}
	else
		return this.__size;
};

_me._value = function(x, y, bUpdate) {
	if (Is.Defined(x) && Is.Defined(y)) {

		this.__value = {x:x<0?0:x, y:y<0?0:y};

		if (!bUpdate)
			this.__handle();

		this.__draw();
	}
	else
		return this.__value;
};


_me.__handle = function(){
	if (this.__value && this.__value.x>=0 && this.__value.y>=0){
		if (this._onchange)
			this._onchange({value:this.__value, range:this.__range, size:this.__size});

		this.__exeEvent('onchange',null,{"owner":this, value:this.__value, range:this.__range, size:this.__size});
	}
};

_me.__draw = function(){

	if (this.__range && this.__size && this.__value){

		//scroll fading
		if (this.__scrolltimer)
			window.clearTimeout(this.__scrolltimer);

		if (!hascss(this.__body,'scroll'))
			addcss(this.__body,'scroll');

		var me = this;
		this.__scrolltimer = window.setTimeout(function(){
			removecss(me.__body,'scroll');
		},1500)

		//Create scroller block
		if (!this.__elm){
			this.__elm = mkElement('div', {className:'block'});
			this.__body.appendChild(this.__elm);
		}

		var ps = this._view.getPageSizes().pixels;
			h = 0;
		for(var i = ps.length-1; i>=0; i--)
			h += ps[i].max.y-ps[i].min.y;

		// DIMENSIONS
		var ds = this._view.getDocSize(),
			doc = {w: this.__body.clientWidth};
			doc.r = this.__getScale();
			doc.h = doc.r * ds.y;

		// width
		var w = this.__size.x * doc.r;
			w = w>doc.w?doc.w:w;

		// height
		var h = this.__size.y * doc.r;

		// POSITION
		var x = this.__value.x * doc.r;
		if (x+w>doc.w)
			w = doc.w-x;

		var y = this.__value.y * doc.r;

		if (y>doc.h)
			y = doc.h;

		if (y+h>doc.h)
			h = doc.h-y;

		this.__elm.style.left = x + 'px';
		this.__elm.style.top = y + 'px';
		this.__elm.style.width = w + 'px';
		this.__elm.style.height = h + 'px';

		//scroll to view
		if (y<this.__body.scrollTop && this.__body.scrollTop>0)
			this.__body.scrollTop = y;
		else
		if (y + h > this.__body.scrollTop + this.__body.clientHeight)
			this.__body.scrollTop = y + h - this.__body.clientHeight;
	}
};

_me.__scrollMove = function(e, arg, ox, oy){
	var sb = getSize(this.__body),
		k = this.__getScale(),
		x = (gui.__X - sb.x - ox),
		y = (gui.__Y - sb.y + this.__body.scrollTop - oy);

	this._value(x/k, y/k);
};

_me.__scrollEnd = function(e){
	gui._disobeyEvent('mousemove',[this,'__scrollMove']);

	//disobey myself
	return false;
};

_me.__getScale = function(){
	var maxw = 0,
		ps = this._view.getPageSizes().pixels;

	for(var i = ps.length-1; i>=0; i--)
		maxw = Math.max(ps[i].max.x - ps[i].min.x, maxw);

	return this.__body.clientWidth/maxw;
};