_me = obj_document_text.prototype;
function obj_document_text(){};

/**
 * @brief:
 * @date :
 **/
_me.__constructor = function(view){
	var me = this,
		aData;

	switch(view.getDocType()){
		case 'text':
			aData = {color:'FontColor',bgcolor:'BackColor'};
			break;

		case 'presentation':
		case 'drawing':
			aData = {color:'Color',bgcolor:'CharBackColor'};
			break;

		case 'spreadsheet':
			aData = {color:'Color',bgcolor:'BackgroundColor'};
	}

	this._draw('obj_document_text', 'main', aData);

	//Font Styles
	this.__styles = view.getToolbarCommandValues('.uno:StyleApply');

	var aStyles = {}, a;
	switch(view.getDocType()){
		case 'text':
			a = this.__styles.ParagraphStyles.slice(7, 19);
			for (var i in a)
				aStyles[a[i]] = a[i];

			a = this.__styles.ParagraphStyles.slice(0, 7);
			for (var i in a)
				aStyles[a[i]] = a[i];

			break;

		case 'presentation':
		case 'drawing':
			a = this.__styles.Default;
			for (var i in a)
				aStyles[a[i]] = a[i];

			break;

		case 'spreadsheet':
			a = this.__styles.CellStyles;
			for (var i in a)
				aStyles[a[i]] = a[i];
	}

	var a = this.__styles.Commands;
	if (a && a.length > 0)
		for(var i in a)
			if (a[i].text)
				aStyles[a[i].id] = a[i].text;

	this.StyleApply._fill(aStyles);
	this._oncommand('StyleApply', view.getCommandValue('.uno:StyleApply'));

	this.StyleApply._onchange = function(){

		var v = this._value();

		if (v.indexOf('.uno:') === 0){
		 	view.sendUnoCommand(v);
		}
		else
		switch(view.getDocType()){
			case 'text':
				view.applyStyle(v, 'ParagraphStyles');
				break;

			case 'presentation':
			case 'drawing':
				view.applyStyle(v, 'Default');
				break;

			case 'spreadsheet':
				view.applyStyle(v, 'CellStyles');
				break;
		}

		view.focus();
	};

	//Font Names
	this.__fonts = view.getToolbarCommandValues('.uno:CharFontName');
	var aFonts = [];
	for (var i in this.__fonts)
		aFonts[i] = i;

	this.FontHeight._readonly(false);

	this.CharFontName._fill(aFonts);
	this._oncommand('CharFontName', view.getCommandValue('.uno:CharFontName'));
	this.CharFontName._onchange = function(){
		view.applyFont(this._value());
		me.FontHeight._fill(me._getSizes(this._value()));

		view.focus();
	};

	this._oncommand('FontHeight', view.getCommandValue('.uno:FontHeight'));
	this.FontHeight._onchange = function(){
		view.applyFontSize(this._value());
		view.focus();
	};

	function colors(){
		me.frmcolor = gui._create('color','frm_ok_cancel','','noblur');
		me.frmcolor._size(400,300,true);
		me.frmcolor._modal(true);

		me.frmcolor._create('color','obj_colorpicker');
		me.frmcolor.color._value(this.__color);

		if (this._name == 'Color' || this._name == 'FontColor'){
			me.frmcolor._title('DOCUMENT::TEXTCOLOR');
			me.frmcolor.x_btn_ok._onclick = function(){
				var v = parseInt(this._parent.color._value().replace('#',''), 16);

				if (view.getDocType() == 'text')
					view.sendUnoCommand('.uno:FontColor',
					{
					  "FontColor": {
					    "type": "long",
					    "value": v
					  }
					});
				else
					view.sendUnoCommand('.uno:Color',
					{
					  "Color": {
					    "type": "long",
					    "value": v
					  }
					});

				this._parent._destruct();
				view.focus();
			};
		}
		else{
			me.frmcolor._title('DOCUMENT::BGCOLOR');
			me.frmcolor.x_btn_ok._onclick = function(){
				var v = parseInt(this._parent.color._value().replace('#',''), 16);

				switch(view.getDocType()){
					case 'text':
						view.sendUnoCommand('.uno:BackColor',
						{
						  "BackColor": {
						    "type": "long",
						    "value": v
						  }
						});
						break;
					case 'presentation':
					case 'drawing':
						view.sendUnoCommand('.uno:CharBackColor',
						{
						  "CharBackColor": {
						    "type": "long",
						    "value": v
						  }
						});
						break;

					case 'spreadsheet':
						view.sendUnoCommand('.uno:BackgroundColor',
						{
						  "BackgroundColor": {
						    "type": "long",
						    "value": v
						  }
						});
				}

				this._parent._destruct();
				view.focus();
			};
		}
	};

	var obj = this.FontColor || this.Color;
		obj.__span = mkElement('span');
		obj.__color = '#000000';
		obj._main.appendChild(obj.__span);
		this._oncommand(obj._name, view.getCommandValue('.uno:' + obj._name));
		obj._onclick = colors;

	var obj = this.BackColor || this.CharBackColor || this.BackgroundColor;
		obj.__span = mkElement('span');
		obj.__color = '#FFFFFF';
		obj._main.appendChild(obj.__span);
		this._oncommand(obj._name, view.getCommandValue('.uno:' + obj._name));
		obj._onclick = function(){
			if (view.getCommandValue('.uno:CharBackgroundExt') == 'true')
				view.sendUnoCommand('.uno:CharBackgroundExt');
			else
				colors.call(this);
		};

	this._oncommand('Bold', view.getCommandValue('.uno:Bold'));
	this._oncommand('Italic', view.getCommandValue('.uno:Italic'));
	this._oncommand('Underline', view.getCommandValue('.uno:Underline'));
};

_me._getSizes = function(sName){

	if (this.__fonts[sName])
		this.__size = this.__fonts[sName];
	else{
		//Font Size
		this.__size = {};
		for (var i = 6; i<36;){
			this.__size[i] = i;

			if (i>6 && i<12)
				i+=0.5;
			else
				i++;
		}
	}

	return this.__size;
};

_me._oncommand = function(cmd, value){
	if (Is.Defined(value))
	switch(cmd){
		case 'StyleApply':
			var s = this.StyleApply.__idTable[value];
			if (!s)
				for(var i in this.StyleApply.__idTable){
					s = this.StyleApply.__idTable[i];
					break;
				}

			if (s)
				this.StyleApply._value(s, true);
			break;

		case 'CharFontName':
			value = value.toString();
			if (!this.CharFontName.__idTable[value]){
				var tmp = {};
					tmp[value] = value;
				this.CharFontName._fill(objConcat(this.CharFontName.__idTable, tmp));
			}

			this.CharFontName._value(value, true);
			this.FontHeight._fill(this._getSizes(value));
			break;

		case 'FontHeight':
			this.FontHeight._value(value.toString(), true);
			break;

		case 'Color':
		case 'FontColor':
			if (this[cmd]){
				value = parseInt(value, 10);
				this[cmd].__color = '#' + (value == -1?'000000':value.toString(16));
				this[cmd].__span.style.background = this[cmd].__color;
			}
			break;

		//bg color
		case 'BackColor':
		case 'CharBackColor':
		case 'BackgroundColor':
			if (this[cmd]){
				value = parseInt(value, 10);
				this[cmd].__color = '#' + (value == -1?'FFFFFF':value.toString(16));
				this[cmd].__span.style.background = this[cmd].__color;
			}
			break;

		case 'CharBackgroundExt':
			var btn = this.BackColor || this.CharBackColor || this.BackgroundColor;
				btn._active(value == 'true')
	}
};