_me = obj_notifier.prototype;
function obj_notifier(){};
/*
_me.__constructor = function(){

};
*/
/*
	Notification object
	@RFC: http://www.w3.org/TR/notifications/

	Attributes:
		iconUrl - src string (PNG)
		body	- string
		tag		- string (notification are collapsed by this string)

	Methods:
		onclick
		onerror
		onshow
		onclose
*/
_me._value2 = function(v,aArg,bKeep){

	//INIT
	if (!Is.Defined(this.__buffer)){

		this.__interval;
		this.__timeout;

		this.__buffer = [];

		this._draw('obj_notifier','main');

		var me = this;
		this._main.onclick = function(){
			if (me.__interval){
			    clearInterval(me.__interval);
			    me.__interval = null;
			}
			if (me.__timeout){
			    clearTimeout(me.__timeout);
			    me.__timeout = null;
			}

			me.__move(true);
		};
	}

	this.__buffer.push(v);
	if (this.__buffer.length == 1){

		if (this.__interval){
		    clearInterval(this.__interval);
		    this.__interval = null;
		}
		if (this.__timeout){
		    clearTimeout(this.__timeout);
		    this.__timeout = null;
		}

		var box = this._getAnchor('box');
    	    box.style.bottom = '';
			box.innerHTML = v;

		this.__move();
	}
};

_me.__move = function(bDown){
	var me = this,
		box = this._getAnchor('box'),
		h = h2 = box.offsetHeight;

	if (!bDown)
		this._main.style.display = 'block';

	this.__interval = setInterval(function(){
		if (h<0){
		    clearInterval(me.__interval);
		    me.__interval = null;

			if (bDown){
				box.style.bottom = '';
				me.__buffer.shift();
				if (me.__buffer.length>0){
					box.innerHTML = me.__buffer[me.__buffer.length-1];
					me.__move();
				}
				else
					me._main.style.display = 'none';
			}
			else{
				box.style.bottom = '0px';
				me.__timeout = setTimeout(function(){
				   me.__move(true);
				},2500);
			}
		}
		else{
			if (bDown)
				box.style.bottom = (h-h2) + 'px';
			else
				box.style.bottom = -h + 'px';

			h-= 2;
		}
	},5);
};

_me._value = function(sTitle, sBody, aHandler, iTime, sGroup) {

	var iTime = (parseInt(iTime,10) || 3)*1000,
		iSetting = parseInt(GWOthers.getItem('LAYOUT_SETTINGS','notifications') || 0,10);

	//http://www.w3.org/TR/notifications/
	if (window.Notification && (iSetting == 1 || (iSetting == 0 && !gui.__focus)))
		if (this._value3(sTitle, sBody, aHandler, iTime, sGroup) !== false)
			return;

	//internal bubble
	this._value2(sTitle, aHandler, iTime);
};

_me._value3 = function(sTitle, sBody, aHandler, iTime, sGroup) {

	//Webkit 09/11/13 doesnt support Notification.permission
	if (window.Notification){

		if (!window.Notification.permission && window.webkitNotifications && window.webkitNotifications.checkPermission)
			window.Notification.permission = (['granted','default','denied'])[window.webkitNotifications.checkPermission()];

		if (window.Notification.permission == 'granted'){

			if (sTitle && !sBody && GWOthers.getItem('LAYOUT_SETTINGS','title')){
				sBody = sTitle;
				sTitle = GWOthers.getItem('LAYOUT_SETTINGS','title');
			}

			var arg = {
				body: sBody || '',
				dir: "auto",
				//lang: "",
				tag: sGroup,
				icon: './client/skins/default/images/logo.png'
			};

			var n = new Notification(sTitle || getLang('PRELOADER::LOADING'), arg);
				n.onclick = function() {
					//for Chrome
					window.focus();

					if (aHandler)
						try{
							executeCallbackFunction(aHandler);
						}
						catch(r){}

					window.focus();

					//Safari likes this
					this.close();
				};
				n.onshow = function () {
					this._date = new Date();

					if (iTime)
						setTimeout(function(){n.close()}, iTime);
				};

			//n.onerror;
			//n.onclose;
			return n;
		}
		else
		//Inform User ?
		if (window.Notification.permission == 'denied')
			return false;
		else
		//Ask for Permisson
		if (!this.__permission){
			this.__permission = true;

			var me = this;
			this._setPermissions([function(perm){
				if (perm == 'granted')
					me._value3(sTitle, sBody, aHandler, iTime, sGroup);
				// else
				// 	me._value2(sTitle, aHandler, iTime);
			}]);

			return true;
		}
	}
	else
		return false;
};

_me._getPermissions = function(){

	if (window.Notification){
		if (!window.Notification.permission && window.webkitNotifications && window.webkitNotifications.checkPermission)
			window.Notification.permission = (['granted','default','denied'])[window.webkitNotifications.checkPermission()];

		return window.Notification.permission;
	}
	else
		return 'unsupported';
};

_me._setPermissions = function(aHandler){
	var me = this;

	if (this._getPermissions() == 'denied'){
		gui._create('ask_notify','frm_alert','','',[
			function(){
				if (aHandler)
					executeCallbackFunction(aHandler,'denied');
			}
		],'NOTIFIER::NOTIFIER','NOTIFIER::DENIED');
	}
	else
	if (this._getPermissions() != 'granted'){
		var frm = gui._create('ask_notify','frm_confirm_select','','',[
			function(v){

				GWOthers.setItem('LAYOUT_SETTINGS','notifications', v , true);
				GWOthers.save();

				if (v != 2)
					window.Notification.requestPermission(function(perm){
						window.Notification.permission = perm;

						if (aHandler)
							executeCallbackFunction(aHandler,perm);
					});
			}
		],'NOTIFIER::NOTIFIER','NOTIFIER::PERMISSIONS','',[getLang('SETTINGS::NOFOCUS'), getLang('SETTINGS::ALWAYS'), getLang('SETTINGS::NEVER')],GWOthers.getItem('LAYOUT_SETTINGS','notifications') || '0');

	}
};