_me = obj_scrollbar.prototype;
function obj_scrollbar(){};
/*
	@Params:
		bPassive in Passive mode, there is no response from scrolled object

	@Event
		_onscroll({value:<scrollbar position>, range:<content size>, size:<container size>})	
*/
_me.__constructor = function(bPassive) {
	var me = this;
	
	this.__value = 0;	// scrollbar position
	this.__range = 0;	// content size
	this.__size = 0;	// container size

	this._passive = bPassive; // In passive moce

	this._main.innerHTML = '<ins><sub ondragstart="return false;" unselectable="on"></sub></ins><b ondragstart="return false;" unselectable="on"></b><i ondragstart="return false;" unselectable="on"></i>';
	this.__elm = this._main.firstChild.firstChild;

	//disable click events
	this._main.ondblclick = this._main.onclick = function(e){
		var e = e || window.event;
			e.cancelBubble = true;
		if (e.preventDefault) e.preventDefault();
		if (e.stopPropagation) e.stopPropagation();				
		return false;
	};

	this._main.onmousedown = function(e, bScrollInt){
		var e = e || window.event,
			tmp = e.target || e.srcElement,
			bX = hascss(this,'x');

		switch(tmp.tagName){
			//scroll
			case 'SUB':
				addcss(me._main,'active');

				gui._obeyEvent('mouseup',[me,'__disobey']);
				gui._obeyEvent('mousemove',[me,'__scroll',[(bX?'X':'Y'), me.__value, gui[bX?'__X':'__Y']]]);

				bScrollInt = true;
				break;

			//buttons
			case 'B':
				me._value(me.__value - (me.__size/4));
				break;

			case 'I':
				me._value(me.__value + (me.__size/4));
				break;

			case 'DIV':
			case 'INS':

				//page
				var pos = getSize(me.__elm);

				if (bX){
					var x = gui.__X;

					//PgUp
					if (x<pos.x)
						me._value(me.__value - me.__size);
					else
					//PgDown
					if (x>pos.x+pos.w)
						me._value(me.__value + me.__size);
				}
				else{
					var y = gui.__Y;

					//PgUp
					if (y<pos.y)
						me._value(me.__value - me.__size);
					else
					//PgDown
					if (y>pos.y+pos.h)
						me._value(me.__value + me.__size);
				}
				break;

			default:
				bScrollInt = true;
		}
		
		this.onclick(e);
	};
};

_me.__scroll = function(e, arg, sType, iScroll, iStart){
	
	var v = iScroll + (((gui[sType == 'X'?'__X':'__Y'] - iStart) / this._main.firstChild['offset'+ (sType == 'X'?'Width':'Height')]) * this.__range);

	if (this._passive)
		this._value(v);
	else{
		this.__value = v<0?0:v;
		this.__handle();
	}	
};

_me.__disobey = function(){
	gui._disobeyEvent('mousemove',[this,'__scroll']);
	removecss(this._main,'active');
	return false;
};

_me._range = function(iValue, bUpdate) {
	if (Is.Defined(iValue)) {
		this.__range = iValue;

		if (!bUpdate)
			this.__handle();

		this.__draw();
	}
	else
		return this.__range;
};

_me._size = function(iValue, bUpdate){
	if (Is.Defined(iValue)) {
		this.__size = iValue;

		if (!bUpdate)
			this.__handle();

		this.__draw();
	}
	else
		return this.__size;
};

_me._value = function(iValue, bUpdate) {
	if (Is.Defined(iValue)) {
		
		this.__value = iValue<0?0:iValue;

		if (!bUpdate)
			this.__handle();

		this.__draw();
	}
	else
		return this.__value;
};

_me.__draw = function(){

	if (this.__range && this.__size && this.__range>this.__size){
		
		var i = Math.ceil(this.__size/(this.__range/100)),
			iMin;

		//minimal size check
		if (hascss(this._main,'x'))
			iMin = this._main.clientWidth ? 20/(this._main.clientWidth/100) : 1;
		else
			iMin = this._main.clientHeight ? 20/(this._main.clientHeight/100) : 1;
		i = Math.max(i, iMin);

		this.__elm.style.width = i + '%';
		this.__elm.style.height = i + '%';

		var p = (100-i)*(this.__value/(this.__range-this.__size));

		if (p+i>100)
			p = 100-i;
		else
		if (p<0)
			p = 0;

		this.__elm.style.left = p + '%';
		this.__elm.style.top = p + '%';

		if (i<33)
			addcss(this._main,'long');
		else
			removecss(this._main,'long');

		if (this._main.style.display!='block')
			this._main.style.display = 'block';
	}
	else
		this._main.style.display = '';
};

_me.__handle = function(){
	if (this._onchange)
		this._onchange({value:this.__value, range:this.__range, size:this.__size});

	this.__exeEvent('onchange',null,{"owner":this, value:this.__value, range:this.__range, size:this.__size});
};