/*
._onactive(bool)
*/
_me = obj_tab.prototype;
function obj_tab(){};

_me.__constructor = function(bFirst){

	this._telemetry = 'off'; //telemetry log

	this._isActive = false;
	this._isDisabled = false;
	this._wasActivated = false;

	var me = this;

	this.__drawTpl = null;
	this.__drawObj = null;
	this.__drawData = null;

	this.__eLi = mkElement('li',{id:this._parent._pathName+"/"+this._name, className: this._css}); //ID is for automatic testing

	this.__eLi.onmousedown = function(e){
		var e = e || window.event;
			e.cancelBubble = true;
		try{e.preventDefault();}catch(r){}
		try{e.stopPropagation();}catch(r){}

		if (!me._isActive){
			me._active();

			if (gui.telemetry)
				gui.telemetry._add({id:this.id, type: me._parent._type});
		}

		return false;
	};
	this.__eLi.oncontextmenu = function(e){
		var e = e || window.event;

		if (me._oncontext)
			me._oncontext(e);

		return false;
	};

	var elm = this._parent._getAnchor('links');

	if (bFirst && elm.firstChild)
		elm.insertBefore(this.__eLi, elm.firstChild);
	else
		elm.appendChild(this.__eLi);

	//elm.appendChild(this.__eLi);
	elm = null;

	// clear memory
	this._add_destructor('__destruct');
};



/**
 * @Brief: set TITLE for tab
 * @Note predelat na _title() a _text()
 **/
_me._value = function(v,bNoLang){
	if (v){
		this.__tabTitle = v;
		this.__eLi.innerHTML = '<span>'+(bNoLang?v:getLang(v))+'</span>';
	}
	else
	    return this.__tabTitle || '';
};

_me._disabled = function(b){
	if (b == this._isDisabled) return;
	if (b){
		addcss(this.__eLi,'disabled');
		addcss(this._main,'obj_tabdisabled');
	}
	else{
		removecss(this.__eLi,'disabled');
		removecss(this._main,'obj_tabdisabled');
	}
	this._isDisabled = b;
};

_me._readonly = function(){
	addcss(this._main,'obj_tabreadonly');

	var obj = this._getChildObjects();
	for (var i in obj)
		if (obj[i]._readonly)
			obj[i]._readonly(true);
		else
		if (obj[i]._disabled)
			obj[i]._disabled(true);
};

_me._incorrect = function(bError) {
	if(bError)
		addcss(this.__eLi,'error');
	else
		removecss(this.__eLi,'error');
}

/**
 * @Brief: Public function
 **/
_me._active = function(draw){

	if (this._isDisabled) return;

	if (!Is.Defined(draw))
		if (!this._wasActivated)
			draw = true;
		else
			draw = false;

	if (!this._isActive){
		this._isActive = true;
		this._wasActivated = true;

		// add <draw>
		if (this.__drawTpl){
			if (count(this.__drawTpl[2]) <= 0 && count(this.__drawData) > 0)
				this.__drawTpl[2] = this.__drawData;
			this._draw(this.__drawTpl[0],this.__drawTpl[1],this.__drawTpl[2]);
			this.__drawTpl = null;
		}

		// add <obj>
		if (this.__drawObj){
			this.__addObjects(this.__drawObj,null,this.__drawData);
			this.__drawObj = null;
		}

		// deactivate previous tab
		if (this._parent.__value && this._parent[this._parent.__value])
			this._parent[this._parent.__value].__deactive();

		this._parent.__value = this._name;

		addcss(this._main,'obj_tab_active');
		addcss(this.__eLi,'active');

		//scroll to be visible
		this._parent._scrollHeader(this.__eLi);

		//Execute handlers
		if (this._onactive) this._onactive(draw);
		this.__exeEvent('onactive',null,{"draw":draw,"owner":this});

		//Select 1st input if no focus was set
		if (this.__tabIndexes && this.__tabIndexes.main && !this.__lastFocus){
			try{
				var tmp = (eval(this.__tabIndexes.main[0]));
				if (tmp._focus)
					tmp._focus();
			}
			catch(e){}
		}

		if (this._parent._onchange)
			this._parent._onchange(this._name);
	}
	else{
		//Execute handlers
		if (this._onactive) this._onactive(draw);
		this.__exeEvent('onactive',null,{"draw":draw,"owner":this});
	}

	// Re-focus text inputs that were focused last time
	if(!draw && this.__last_focused_field)
		this.__last_focused_field.focus();

	if (draw)
		this._scrollbar(this._getAnchor('main'));
};

/**
 * @Brief: Private function to deactivating tab
 * @Date : 3.5.2006 18:55:40
 **/
_me.__deactive = function(){
	if (this._isActive == false) return;

	removecss(this._main,'obj_tab_active');
	removecss(this.__eLi,'active');

	// Remember last active text input element in this tab
	this.__last_focused_field = document.activeElement && document.activeElement.nodeName=='INPUT' && document.activeElement.type=='text' && Is.Child(document.activeElement,this._main) ? document.activeElement : null;

	// Remove focus from text inputs and remember for next open, strictly necessary only for IE
	var input = this._main.getElementsByTagName('input');
	for(var n=input.length; n;)
		if(input[--n].type == "text")
			input[n].blur();

	this._isActive = false;

	//Execute handlers
	if (this._ondeactive) this._ondeactive();
	this.__exeEvent('ondeactive',null,{"owner":this});
};

/**
 * switch to other tab and destroy itself
 **/
_me._close = function (){
	if (this._isActive){

		var aObj = this._parent._getChildObjects(),
			oPrev;

		for (var i in aObj)
			if (aObj[i]._name == this._name){
				if (oPrev){
				    oPrev._active();
				    break;
				}
				else
					oPrev = 1;
			}
		    else
		    if (aObj[i]._active){
				if (oPrev === 1){
					aObj[i]._active();
					break;
				}
				else
					oPrev = aObj[i];
			}
	}

	this._destruct();
};

_me.__destruct = function(){
	if (this._isActive)
		this._parent.__value = '';

	if (this.__eLi) this.__eLi.parentNode.removeChild(this.__eLi);

	this.__eLi = null;
	this.__eMain = null;

	if (this._onclose)
	    this._onclose();
};