/**
 * TREE object is visual object for ordering array data into tree structure.
 *
 * Input array:
 * x[<p item>][link] = 'index.html'
 *            [childs][<ch item>][link]
 *                               [childs]...
 *
 * All items have its own ID identificator
 * ID = obj_tree._pathName + <name> + / + <name>...
 *
 * EVN: _onactivate
 *      _onclick
 *
 * doresit autoukladani do datasetu
 **/
_me = obj_tree.prototype;
function obj_tree(){};

_me.__constructor = function(){

	this._telemetry = 'id'; //telemetry log

	this.__value = [];		// array of open nodes
	this._saveState = true;	// save __value into dataset saver
	this.__idtable;			// table of arguments mapped on each node
	this.__activeNode;
	this._tree;
	this._treeCookie;

	this._autofocus = true;	//focus search input on click

	this.__filter = '';
	this.__filterOpen = [];

	var me = this;

	this.inp_search._onkeyup = function(e){
		var v = '';
		if (e.keyCode == 27)
			this._value('');
		else
			v = this._value();

		if (v){
			if (!me.__filter)
				addcss(me._main,'search');
		}
		else
			removecss(me._main,'search');

		if (me.__filter!= v){
			me.__filter = v;
			me._fill();
		}
	};
	this.inp_search._onblur = function(){
		if (!this._value()) removecss(me._main,'search');
	};

	this.__eBody = this._getAnchor('body');
	this._scrollbar(this.__eBody,this.__eBody.parentNode);

	this.__eBody.onclick = function(e){
		var e = e || window.event,
			elm = e.target || e.srcElement,
			eli,id;

		switch(elm.tagName){
			case 'DIV':
				if (elm.parentNode.tagName == 'LI'){
					if (hascss(elm.parentNode,'active') || hascss(elm.parentNode,'menu')){
						var p = getSize(elm);
						var ltr = document.documentElement.lang!="ar";
						var ctx = ltr && p.x+p.w-33<e.clientX || !ltr && p.x+33>e.clientX;

						if (ctx){

							e.cancelBubble = true;
							if (e.stopPropagation) e.stopPropagation();

							e = {srcElement:elm,clientX:ltr?p.x+p.w:p.x+22,clientY:p.y+(p.h/2),type:'contextmenu', originalType:e.type};
						}
					}
				}
				else
					break;

			case 'SPAN':
/*
				if (elm.tagName == 'SPAN' && e.type != 'contextmenu'){
					eli = Is.Child(elm,'LI');
					id = eli.id.substr(me._pathName.length+1);
					me._open(id);
					break;
				}
*/
			case 'I'   :
			case 'U'   :
			case 'B'   :
				eli = Is.Child(elm,'LI');
				id = eli.id.substr(me._pathName.length+1);

				if (elm.tagName == 'SPAN' && e.type != 'contextmenu'){
					me._open(id);
					break;
				}

				var idt = me.__idtable[id]?clone(me.__idtable[id],true):{};

				if (!idt.disabled || e.type == 'contextmenu'){
					if (e.type != 'contextmenu' && idt.ftype != "X")
						me._setActive(id);

					if (me._onclick) me._onclick(e,elm,id,idt || {});
					me.__exeEvent('click',e,{"arg":idt,"id":id,"elm":elm,"owner":me});
				}
				else{
					me._open(id);
				}

				break;
		}

		//Skip for MSIE10
		if (e.type != 'contextmenu' && !window.navigator.msPointerEnabled && me._autofocus)
			me._focus();

		return false;
	};

	//For MSIE10 Only
	if (window.navigator.msPointerEnabled)
		this.__eBody.onmspointerup = function(e){
			var e = e || window.event;
			if (me._autofocus && e.button == 0 && (!e.pointerType || (e.pointerType == e.MSPOINTER_TYPE_MOUSE) || (e.pointerType == 'mouse')))
				me._focus();
		};

	this.__eBody.ondblclick = function(e){
		var e = e || window.event;
		var elm = e.target || e.srcElement;

		switch(elm.tagName){
			case 'U':
			case 'B':
				if (me._ondblclick){
					var eli = Is.Child(elm,'LI'),
						id = eli.id.substr(me._pathName.length+1),
						idt = me.__idtable[id]?clone(me.__idtable[id],true):{};

					if (me._ondblclick(e,elm,id,idt || {})){
						me._setActive(id);
						return;
					}
				}

			case 'I':
				var eli = Is.Child(elm,'LI');
				me._open(eli.id.substr(me._pathName.length+1), hascss(eli,'root')?'plus':'');
		}
	};

	this.__eBody.oncontextmenu = this.__eBody.onclick;
};


_me._disabled = function(b){
	if (Is.Defined(b))
		window[b?'addcss':'removecss'](this._main,'disabled');
	else
		return hascss(this._main,'disabled');
};

_me._getFocusElement = function(){
	return this.inp_search._getFocusElement();
};
_me._focus = function(){
	return this.inp_search._focus();
};

/**
 * @brief: redraw tree object
	[Events]
	.. [nodes]
	.. [arg]
	.... [aid] = admin@merakdemo.com
	.... [fid] = Events
	.... [ftype] = E
	.... [disabled] = false
	.. [text] = Calendar
	.. [title2] =
	.. [ico] = ico_e
	.. [itmclass] =
 *
 **/
_me._fill = function (aData){
	if (aData || (aData = dataSet.get(this._listener_data,this._listenerPath_data))){

		if (this.__filter){
			this.__filter = this.__filter.toLowerCase();

			var aData2 = {}, aOpen = [];
			for(var sDomain in aData){
				var aTmp = aData[sDomain],
					aKey = [],
					sName;

				for(var i in aTmp)
					aKey.push(i);
				aKey.sort();

				for(var sLast = '',i = aKey.length-1;i>=0;i--){

					if (aKey[i] == sLast)
						sLast = aKey[i].indexOf('/')>-1?aKey[i].substr(0,aKey[i].lastIndexOf('/')):aKey[i];
						//sLast = aKey[i].substr(0,aKey[i].lastIndexOf('/'));
					else{
						if ((!aTmp[aKey[i]].NAME && aKey[i].toLowerCase().indexOf(this.__filter)>-1) ||	(aTmp[aKey[i]].NAME && aTmp[aKey[i]].NAME.toLowerCase().indexOf(this.__filter)>-1))
							//sLast = aKey[i].substr(0,aKey[i].lastIndexOf('/'));
							sLast = aKey[i].indexOf('/')>-1?aKey[i].substr(0,aKey[i].lastIndexOf('/')):aKey[i];
						else{
							aKey.splice(i,1);
							continue;
						}
					}

					if ((sName = aTmp[aKey[i]].NAME?aTmp[aKey[i]].NAME:Path.basename(aKey[i])) && sName.toLowerCase().indexOf(this.__filter)>-1)
						aOpen.push(sDomain + (sLast?'/' + sLast:''));
				}

				if (aKey.length){
					aData2[sDomain] = {};
					for(var i in aTmp)
						if (inArray(aKey,i)>-1)
							aData2[sDomain][i] = aTmp[i];
				}
			}
			var aData = aData2;
		}

		this.__aFillData = this.__prepare_data?this.__prepare_data(aData):aData;
		this.__row(this.__aFillData);

		//Open all found nodes
		this.__filterOpen = [];
		if (this.__filter && aOpen.length){
			for(var n in aOpen){
				this._openup('minus',aOpen[n]);

				aOpen[n].split('/').forEach(function(v, i, a){
					this.__filterOpen.push(a.slice(0, i+1).join('/'));
				}, this);
			}
		}
	}
	else
		this.__eBody.innerHTML = '';

	this.__sbar_init(this.__eBody,true);
};


_me._invalidateActive = function() {

	try{
		removecss(document.getElementById(this._getElmId(this.__activeNode)),'active');
	}
	catch(e){}

	delete this.__activeNode;
};

_me._getActive = function() {
	if (typeof this.__activeNode == 'undefined')
		return Path.split('');
	else
		return Path.split(this.__activeNode);
}


/**
 * @brief: set active node and open thread
 **/
_me._setActive = function(id,bNoOpen){

	if (this.__activeNode && this.__activeNode != id)
		try{
			removecss(document.getElementById(this._getElmId(this.__activeNode)),'active');
		}
		catch(e){}

	try{
		addcss(document.getElementById(this._getElmId(id)),'active');
	}
	catch(e){
		if (this._onactivate)
			this._onactivate(id,false);

		this.__activeNode = id;

		return false;
	}

	if (!bNoOpen){
		// Open parent node
		var iSPos;
		if ((iSPos = id.lastIndexOf('/')) > -1)
			this._open(id.substr(0,iSPos),'minus');
		else
			this._open(id,'minus');
	}

	if (this._onactivate)
		this._onactivate(id,true);

	this.__activeNode = id;
	return true;
};


/**
 * @brief: return DOM Element ID
 **/
_me._getElmId = function (id){
	return this._pathName +'/'+ id;
};

/**
 * @brief: recursiv method for creating ul-li tree structure
 * @scope: PRIVATE
 * @date : 12.5.2006 11:50:37
 **/
_me.__row = function(aData,child){

	var path='',elm1,elm2,elm3,elm4,elm5,elm6,liclass,me = this;

	/* create main UL element */
	elm1 = mkElement("ul");
	if (!child){
		this.__idtable = {};
		var iTop = this.__eBody.scrollTop;
		liclass = 'root';
	}
	else{
		path = child;
		liclass = 'none';
	}

	for(var i in aData){
		elm2 = mkElement("li",{"className":liclass + (aData[i]["liclass"]?' '+aData[i]["liclass"]:''),"id":this._pathName + '/' + path + i});
		elm3 = mkElement("div",{"className":(aData[i]['ico']?'ico ' + aData[i]['ico']:'')});
		elm3.innerHTML = '<span class="plussign"></span><i></i>';

		if (aData[i]['arg'])
			this.__idtable[path + i] = aData[i]['arg'];

		/* link */
		if (aData[i]["arg"]["disabled"])
			elm4 = mkElement("span",{"className":'inactive'});
		else
			elm4 = mkElement("b");

		if (aData[i]["itmclass"])
			addcss(elm4,aData[i]["itmclass"]);

		elm4.innerHTML = (aData[i]['title']?getLang(aData[i]['title'],null,true):(aData[i]['text']?aData[i]['text']:i.toString().entityify()))/* + (aData[i]['title2']?'<u>'+aData[i]['title2']+'</u>':'')*/;  // Quote STRING !!!

		elm3.appendChild(elm4);

		if (aData[i]['title2'])
			elm3.appendChild(mkElement('u',{innerHTML:aData[i]['title2']}));

		elm2.appendChild(elm3);

		if (aData[i]['nodes'] && !Is.Empty(aData[i]['nodes'])){
			/* set "minus" className for node with childs */
			addcss(elm2,'plus');
			removecss(elm2,'none');

			/* parse and append child nodes */
			elm2.appendChild(this.__row(aData[i]['nodes'],path + i + '/'));
		}
		// n++;
		elm1.appendChild(elm2);
	}

	/* set "end" className for last node with childs */
	elm2.className += ' end';

	/* destruct html elements */
	elm2 = null; elm3 = null; elm4 = null; elm5 = null; elm6 = null;

	/* append root UL into _main */
	if (!child){

		this.__eBody.innerHTML = '';
		this.__eBody.appendChild(elm1);

		elm1.className = 'fTree';

		/* open previously opened nodes */
		if (!Is.Empty(this.__value))
			this._value(this.__value);
		else
		if (this._listener)
			this.__update(this._listener);

		// active
		if (this.__activeNode)
			this._setActive(this.__activeNode);

		this.__eBody.scrollTop = iTop;
		return;
	}

	/* return UL element */
	return elm1;
};


/**
 * @brief: apply given CSS to node and all parent nodes,
 *         if node is not set than function works over all nodes in __value
 * @scope: PUBLIC
 * @date : 14.5.2006 15:58:10
 **/
_me._openup = function(css,id){
	var a = [],elm,pos,styl;

	css = css == 'minus'?'minus':'plus';

	if (!id){
		for(var i in this.__value)
		    a.push(this.__value[i]);
	}
	else
		a.push(id);

	for (var i = 0; i<a.length;i++){
		/* remove wrong paths from array */
		if (!(elm = document.getElementById(this._getElmId(a[i])))){

			if ((pos = a[i].lastIndexOf('/'))>-1 && inArray(a,a[i].substr(0,pos))<0)
				a.push(a[i].substr(0,pos));

			a.splice(i,1);
			i--;
			continue;
		}

		if ((pos = a[i].lastIndexOf('/'))>-1 && inArray(a,a[i].substr(0,pos))<0)
			a.push(a[i].substr(0,pos));

		/* open node and parent nodes */
		if (elm.tagName != 'LI') continue;

		if (elm.className.indexOf(css) == -1){

			if (elm.className.indexOf('minus')>-1){
				removecss(elm,'minus');
				addcss(elm,css);
			}
			else
			if (elm.className.indexOf('plus')>-1){
				removecss(elm,'plus');
				addcss(elm,css);
			}
		}
	}
};

/**
 * @brief: open given node
 * @scope: PUBLIC
 * @param: ID    - Node id
 *         style - private recursive
 * @date : 14.5.2006 17:33:06
 **/
_me._open = function(id,style){
	if(!id) return;

	var css,elm,elmid = this._getElmId(id),a = id.split("/");

	/* check whether element exists */
	if (!(elm = document.getElementById(elmid))) return;

	/* close Node */
	if (elm.className.indexOf('plus')>-1 || style == 'minus'){

		/* add node into __value array */
		this.__value[getFreeKey(this.__value)] = id;
		this.__clear();
		/* open parent Nodes */
		this._openup('minus',id);
	}
	/* open node */
	else
	if (elm.className.indexOf('minus')>-1 || style == 'plus'){
		removecss(elm,'minus');
		addcss(elm,'plus');

		/* close node and all child nodes */
		var e;
		for(var i in this.__value){

			if (this.__value[i]==id){
				try{
					e = document.getElementById(this._pathName+"/"+this.__value[i]);
					if (e.className.indexOf('minus')>-1){
						removecss(e,'minus');
						addcss(e,'plus');
					}
				}
				catch(e){}
				this.__value.splice(i,1);
				break; //pridano
			}
		}

		/* if node is not root node than add parent node path into array */
/*
		if (a.length>1) {
			var t = a.slice(0,-1).join("/");
			if (inArray(this.__value,t)==-1)
				this.__value[getFreeKey(this.__value)] = t;
		}
*/
	}
	else{
		elm = null;
		if (a.length>1)
			this._open(a.slice(0,-1).join("/"),'minus');
		return;
	}

	/* destruct elm var */
	elm = null;

	/* save opened threads into dataset */
	if (this._saveState && this._listener)
		this._saveme();

	if (this._treeCookie)
	{
		//this.__clear();
		Cookie.set([this._treeCookie],clone(this._value(),true));
	}
};

_me._listen_cookie = function(sCookieName)
{
	this._treeCookie = sCookieName;
	this._value(Cookie.get([sCookieName]));
};

/**
 * @brief: listener for tree structure
 **/
_me._listen_data = function(sDataSet,aDataPath){
	this._listener_data = sDataSet;
	if (typeof aDataPath == 'object') this._listenerPath_data = aDataPath;
	dataSet.obey(this,'_listener_data',sDataSet);
};

/**
 * @brief: update method
 **/
_me.__update = function(sDataSet,aDataPath){

	/* no update section */
	if (this._norefresh){
		this._updateBuffer = true;
		return false;
	}
	else
		this._updateBuffer = false;

	/* update tree structure */
	if (this._listener_data == sDataSet){

		if (aDataPath && aDataPath[2] == 'RECENT'){
			var elm,elm2;
			if ((elm = document.getElementById(this._pathName+'/'+aDataPath[0]+'/'+aDataPath[1]))){

				var iRec = dataSet.get(sDataSet,aDataPath),
					elm2 = (elm2 = elm.getElementsByTagName('DIV')) && (elm2 = elm2[0].getElementsByTagName('U'))?elm2[0]:false;

				if (parseInt(iRec)>0){

					if (!elm2){
						elm2 = mkElement('U');
						elm.getElementsByTagName('DIV')[0].appendChild(elm2);
					}

					/*hwn*///if (useLTRprefix) {
					elm2.innerHTML = '&#8234;' + iRec.toString().escapeHTML();
					/*hwn*///}else{elm.innerHTML = '&nbsp;&#8238;(&#8236;'+iRec+'&#8238;)&#8236;';}
				}
				else{
					//dataSet.remove(sDataSet,aDataPath,true);
					if (elm2)
						elm2.parentNode.removeChild(elm2);
				}

				elm = null;
				elm2 = null;
				return;
			}
		}

		this._fill();
	}

	/* update opened nodes */
	if (this._listener == sDataSet)
		this._value(dataSet.get(this._listener,this._listenerPath,true));
};

/**
 * @brief: return all open nodes (only last child in thread) as array of string paths
 * @scope: PUBLIC
 * @date : 14.5.2006 17:33:56
 **/
_me._value = function (v){
	if (v && typeof(v) == 'object') {
		/* close all nodes */
		if (this.__value.length) this._openup('plus');
		this.__value = this.__clear(v);

		/* open all nodes */
		//this._openup('minus');

		var elm;
		for(var i in this.__value)
			if ((elm = document.getElementById(this._getElmId(this.__value[i])))){
				if (elm.tagName == 'LI' && elm.getElementsByTagName('UL').length>0){
					removecss(elm,'plus');
					addcss(elm,'minus');
				}
			}
	}
	else
		this.__value = this.__clear(this.__value);

	return this.__value;
};

/**
 * @brief: removes spare paths from array
 * @scope: PRIVATE
 * @date : 14.5.2006 15:32:02
 **/
_me.__clear = function(a){
	a = a || this.__value;
	a.sort().reverse();

	var pre;
	for(var i=0;i <= a.length;i++)
		if (typeof a[i] != 'undefined')
			if (typeof pre == 'undefined')
				pre = a[i];
			else
			if (pre== a[i])
				a.splice(i,1);//delete a[i];
			else
				pre = a[i];
	return a;
};

/**
 * @brief: optional onclick method
 * @param: e    - Event Handler (onclick event object)
 *         elm  - srcElement (link)
 *         id   - objects internal id (without pathName)
 *         arg  - item's arg section
 */
//_me._onclick = function(e,elm,id,arg){};
