
_me = obj_websocket_api.prototype;
function obj_websocket_api(){};

_me.__constructor = function(){
	this.__state = 0;		// binary; 1 is registred
	this.__requests = {};	//Sent requests
	this.__buffer = [];

	//Listen to socket events
	this._parent._obeyEvent('onmessage', [this, '_onmessage']);
	this._parent._obeyEvent('onclose', [this, '_onclose']);
	this._parent._obeyEvent('onopen', [this, '_onopen']);

	if (this._parent._getState() == 1)
		this._login();


	//extended
	//this._listen('folders');
};

	_me._onmessage = function(e){

		var aResponse = XMLTools.Str2Arr(e.data);
		if (aResponse && aResponse.IQ && aResponse.IQ[0].ATTRIBUTES){

			var id = aResponse.IQ[0].ATTRIBUTES.ID,
				bFailure = false,
				aHandler;

			//Error
			if (aResponse.IQ[0].FAILURE){

				//Authnetification
				if (aResponse.IQ[0].FAILURE[0].STATUS && aResponse.IQ[0].FAILURE[0].STATUS[0].VALUE == 'User not authenticated'){
					this._state(0);

					//Put request back to the beginning of the buffer
					if (id && this.__requests[id])
						this.__buffer_queue(this.__requests[id].iq, true);

					this._login();
					return;
				}

				bFailure = true;

			}

			if (id){
				if (this.__requests[id]){

					if (bFailure && this.__requests[id]['error'])
						aHandler = this.__requests[id]['error'];
					else
						aHandler = this.__requests[id].response;

					if (aHandler)
						executeCallbackFunction(aHandler, aResponse);

					delete this.__requests[id];
				}
			}
			//Push
			else{

				//console.log('PUSH', aResponse);

				//Notifications
				if (aResponse.IQ && aResponse.IQ[0].NOTIFY)
					for (var i in aResponse.IQ[0].NOTIFY){

						if (this._onnotify)
							this._onnotify(aResponse.IQ[0].NOTIFY[i].ATTRIBUTES);

						this.__exeEvent('onnotify', aResponse.IQ[0].NOTIFY[i].ATTRIBUTES, {"owner":this});

						//console.log('NOTIFICATION', aResponse.IQ[0].NOTIFY[i].ATTRIBUTES);
					}
			}
		}
	};

	_me._onclose = function(e){
		this._state(0);
	};

	_me._onopen = function(e){
		this._login();
	};

_me._state = function(v){
	if (Is.Defined(v)){
		this.__state = v;

		//call state change
		this.__exeEvent('onstatechange',this.__state,{"owner":this});
	}
	else
		return this.__state;
};

_me._create_iq = function(aData, aHandler, aErrHandler, bNoBuffer){
	//get free ID
	do { var id = unique_id(); } while (this.__requests[id]);

	var aData = aData || {};
		aData.ATTRIBUTES = {XMLNS:"http://icewarp.com/api/", ID:id};
	var iq = {IQ:[aData]};

	this.__requests[id] = {type:'iq', request: iq, data: aData, response:aHandler, error:aErrHandler, buffer:!bNoBuffer};

	//Logged in
	if (this._state() == 2 || bNoBuffer)
		this._parent._sendArray(iq);
	else{
		this.__buffer_queue(iq);

		if (this._parent._getState() == 1 && this._state() == 0)
			this._login();
	}
};



_me._login = function(aData, bSkip){

	//Step 1 get Challenge
	if (!aData){

		this._state(1);

		//console.log('API', 'Login', 'Challenge');

		this._create_iq({'AUTH':[{ATTRIBUTES:{XMLNS:'urn:ietf:params:xml:ns:xmpp-sasl'}, /*REALM:[{VALUE:dataSet.get('main',['domain'])}],*/ MECHANISM:[{VALUE:'DIGEST-MD5'}]}]}, [this,'_login'], '', true);
	}
	else{

		if (aData.IQ){
			if (aData.IQ[0].CHALLENGE) {

				//Step 4 Final
				if (bSkip){

					//console.log('API', 'Login', 'Finalisation');

					this._create_iq({'RESPONSE':[{ATTRIBUTES:{XMLNS:'urn:ietf:params:xml:ns:xmpp-sasl'}}]}, [this,'_login'],'',true);
				}
				//Step 2 get Digest
				else{

					//console.log('API', 'Login', 'Digest');

					auth.get_digest({
						hash:aData.IQ[0].CHALLENGE[0].VALUE,
						command:'AUTHENTICATE'
					}, 'WEBSOCKET', [this,'_login']);
				}
			}
			else
			//Step 5 Success
			if (aData.IQ[0].SUCCESS){

				//console.log('API', 'Login', 'Success');

				this._state(2);
				this._buffer_flush();
			}
			else
			if (aData.IQ[0].FAILURE){

				//console.log('API', 'Login', 'Failure', aData);

				this._state(0);
			}
		}
		else
		//Step 3 use Digest
		if (Is.String(aData)){
			this._create_iq({'RESPONSE':[{ATTRIBUTES:{XMLNS:'urn:ietf:params:xml:ns:xmpp-sasl'}, VALUE:aData}]}, [this,'_login',[true]], '', true);
		}

	}

};

_me._subscribe = function(aType, aHandler, aErrHandler){

	if (aType.length){

		var aRequest = {'SUBSCRIBE':[{ATTRIBUTES:{XMLNS:'api:iq:control'}, 'DEVICEID':[{VALUE:dataSet.get('main',['device_id'])}], 'ITEMS':[{'ITEM':[]}]}]};

		for(var i = 0; aType.length>i; i++)
			aRequest.SUBSCRIBE[0].ITEMS[0].ITEM.push({VALUE:aType[i]});

		this._create_iq(aRequest, [this, '__subscribers', [aHandler]], aErrHandler);
	}

};

_me._unsubscribe = function(aType, aHandler, aErrHandler){

	if (aType.length){

		var aRequest = {'UNSUBSCRIBE':[{ATTRIBUTES:{XMLNS:'api:iq:control'}, 'ITEMS':[{'ITEM':[]}]}]};

		for(var i = 0; aType.length>i; i++)
			aRequest.UNSUBSCRIBE[0].ITEMS[0].ITEM.push({VALUE:aType[i]});

		this._create_iq(aRequest, [this, '__subscribers', [aHandler]], aErrHandler);
	}

};

	_me.__subscribers = function(aResponse, aHandler){
		var iq, arr = [];
		if (aResponse.IQ && (iq = aResponse.IQ[0])){

			var item,
				sub = iq.SUBSCRIBE || iq.UNSUBSCRIBE;

			if (sub[0].ITEMS && (item = sub[0].ITEMS[0].ITEM))
				for(var i in item)
					arr.push(item[i].VALUE);
		}

		if (aHandler)
			executeCallbackFunction(aHandler, arr);
	};


// BUFFER for case user is not logged in yet
_me.__buffer_queue = function(aIQ, bTop) {
	if (bTop)
		this.__buffer.unshift(aIQ);
	else
		this.__buffer.push(aIQ);
};
_me._buffer_flush = function() {
	while (this.__buffer.length)
		this._parent._sendArray(this.__buffer.shift());
};
_me._buffer_size = function() {
	return this.__buffer.length;
};