_me = scrollbar.prototype;
function scrollbar(){};

_me.__constructor = function(){
	this.__scrollbars = {};
	this._add_destructor('__sbar_disobey');
};

_me._disable_scrolbar = function(elm, bX, bY){
	if (this.__scrollbars[elm]){
		this.__scrollbars[elm].disabledX = bX === true;
		this.__scrollbars[elm].disabledY = Is.Defined(bY)?(bY?true:false):(bX?true:false);
	}	
};

/*
	elm		target scrolling block
	elm2	scrollbar parent element [optional]
	elm3	dimension element (viewable area) [optional]

	bX [optional][bool]
	bY [optional][bool]


For Mobile use:

overflow: auto;
-webkit-overflow-scrolling: touch;
-ms-scroll-snap-type: mandatory;
-ms-scroll-snap-points-x: snapInterval(0%, 100%);

*/
_me._scrollbar = function(elm, elm2, elm3, bX, bY){
	var me = this,
		elm = elm;

	if (navigator.userAgent.indexOf('Mobile')>0){
		this.__sbar_init = function(){};

		elm.style.overflow = 'auto';
		addcss(elm,'scroll_mobile');
		return;
	}
	else
	switch(currentBrowser()){
		case 'MSIE11':
		case 'Chrome':
		case 'Safari':
			addcss(elm,'scroll_tablet');
			break;

		default:
			
			// Browser with either Touch Events of Pointer Events running on touch-capable device
			// We can not hide scrollbars in FFox
			if (gui.__BROWSER.touch && currentBrowser() != 'Mozilla'){ 
				addcss(elm,'scroll_tablet');
				break;
			}
			
			// onScroll scrolling
			elm.style.overflow = 'hidden';
			
			AttachEvent(elm, "onmousewheel", function(e){
				var eSrc = e.srcElement,
					deltaY = e.deltaY,
					deltaX = e.deltaX;

				//Textarea only
				if (eSrc && eSrc.tagName == 'TEXTAREA' && eSrc.clientHeight<eSrc.scrollHeight && ((deltaY<0 && eSrc.scrollTop>0) || (deltaY>0 && eSrc.scrollTop+eSrc.clientHeight < eSrc.scrollHeight)))
					return;			

				//Invert axis for blocks with horizontal scrollbar only
				if (!deltaX && deltaY && elm.scrollHeight<=elm.clientHeight){
					deltaX = deltaY;
					deltaY = 0;
				}

				//Propagate if on limit 
				if (me.__sbar_wheel(elm,deltaX,deltaY) && e.originalEvent){
					e.originalEvent.cancelBubble = true;
					e.originalEvent.returnValue = false;
					if (e.originalEvent.stopPropagation)
						e.originalEvent.stopPropagation();
				}	
			});
	}

 	this.__scrollbars[elm] = {dock:elm2, dime:elm3, disabledX: (bX===false?true:false), disabledY: (bY===false?true:false)};

	//check size & show scrollbar
	AttachEvent(elm,'onmousemove',function(e){
		me.__sbar_init(elm);
	});
	AttachEvent(elm,'onclick',function(e){
		setTimeout(function(){me.__sbar_init(elm);},100);
	});
	AttachEvent(elm, "onscroll", function(e){
		me.__sbar_init(elm,false,true);
	});
};

_me.__sbar_scroll = function(e,arg,elm,elm2,sType,iScroll,iStart,mp){
	var tmp = sType == 'Y'?'Height':'Width';
	try{
		elm[sType == 'Y'?'scrollTop':'scrollLeft'] = iScroll + ((elm['scroll'+tmp] - elm['client'+tmp]) * ((gui[sType == 'Y'?'__Y':'__X']-iStart)/((elm2.firstChild['offset'+tmp]/*-12*/)*((100-this.__scrollbars[elm][sType == 'Y'?'y_size':'x_size'])/100))));
	}
	catch(r){}
};

_me.__sbar_wheel = function(elm, deltaX, deltaY){
	if (this.__scrollbars[elm]){
		var st1 = elm.scrollTop,
			st2 = elm.scrollLeft;
		
		if (!this.__scrollbars[elm].disabledX)
			elm.scrollLeft = elm.scrollLeft + (deltaX*12);

		if (!this.__scrollbars[elm].disabledY)
			elm.scrollTop = elm.scrollTop + (deltaY*12);

		return (st1 != elm.scrollTop || st2 != elm.scrollLeft);
	}
};

_me.__sbar_init = function(elm, bRedraw, bShow){

	if (!this.__scrollbars[elm]){
		if (bRedraw) return;
		this.__scrollbars[elm] = {};
	}

	if ((this.__scrollbars[elm].disabledX && this.__scrollbars[elm].disabledY) || (bRedraw && ((this.__scrollbars[elm].disabledX && !this.__scrollbars[elm].y) || (this.__scrollbars[elm].disabledY && !this.__scrollbars[elm].x))))
		return;

	var x = Math.ceil(elm.clientWidth/(elm.scrollWidth/100)),
		y = Math.ceil(elm.clientHeight/(elm.scrollHeight/100)),
		me = this;

	//SHOW Vertical
	if (!this.__scrollbars[elm].disabledY && y<100){

		//Min Size - no division by zero
		var iMin = elm.clientHeight ? 20/(elm.clientHeight/100) : 1;

		y = y<iMin?Math.ceil(iMin):y;

		this.__scrollbars[elm].y_size = y;

		if (this.__scrollbars[elm].y && this.__scrollbars[elm].y.parentNode == (this.__scrollbars[elm].dock || elm)){
			if (bShow){
				if (Is.Defined(this.__scrollbars[elm].t))
					window.clearTimeout(this.__scrollbars[elm].t);

				removecss(this.__scrollbars[elm].y, 'hide');
			}	
		}	
		else{
			this.__scrollbars[elm].y = mkElement('em',{className:'sbarY'});
			this.__scrollbars[elm].y.innerHTML = '<ins><sub ondragstart="return false;" unselectable="on"></sub></ins><b ondragstart="return false;" unselectable="on"></b><i ondragstart="return false;" unselectable="on"></i>';

			//obey Events
			this.__scrollbars[elm].y.ondblclick = this.__scrollbars[elm].y.onclick = function(e){
				var e = e || window.event;
					e.cancelBubble = true;
				if (e.preventDefault) e.preventDefault();
				if (e.stopPropagation) e.stopPropagation();				
				return false;
			};

			this.__scrollbars[elm].y.onmousedown = function(e, bScrollInt){
				var e = e || window.event,
					tmp = e.target || e.srcElement;

				switch(tmp.tagName){
					//scroll
					case 'SUB':
						addcss(this,'active');
						gui._obeyEvent('mouseup',[me,'__sbar_disobey',[this]]);
						gui._obeyEvent('mousemove',[me,'__sbar_scroll',[elm,this,'Y',elm.scrollTop,gui.__Y]]);

						bScrollInt = true;
						break;

					//buttons
					case 'B':
						elm.scrollTop -= Math.ceil(elm.clientHeight/4);
						break;

					case 'I':
						elm.scrollTop += Math.ceil(elm.clientHeight/4);
						break;

					case 'EM':
					case 'INS':

						//page
						var sub = this.firstChild.firstChild,
							pos1 = getSize(this),
							pos2 = getSize(sub),
							y = gui.__Y; //(Is.Number(e.layerY)?e.layerY:e.y)- pos1.y

							//PgUp
							if (y<pos2.y)
								elm.scrollTop -= elm.clientHeight;
							else
							//PgDown
							if (y>pos2.y+pos2.h)
								elm.scrollTop += elm.clientHeight;
							else{
								if (y<pos2.y + (pos2.h*0.25))
									elm.scrollTop -= elm.clientHeight/3;
								else
								if (y>pos2.y + (pos2.h*0.75))
									elm.scrollTop += elm.clientHeight/3;
							}
						break;

					default:
						bScrollInt = true;
				}
				
				this.onclick(e);
				
				if (!bScrollInt){
					
					if (Is.Defined(me.__scrollint))
						window.clearInterval(me.__scrollint);

					me.__scrollint = window.setInterval(function(){
						me.__scrollbars[elm].y.onmousedown({srcElement:tmp},true);
					},500);

					gui._obeyEvent('mouseup',[function(){
						if (Is.Defined(me.__scrollint))
							window.clearInterval(me.__scrollint);
						return false
					}]);
				}

				return false; 
			};

			(this.__scrollbars[elm].dock || elm).appendChild(this.__scrollbars[elm].y);
		}

		if(this.__scrollbars[elm].dime)
			this.__scrollbars[elm].y.style.height = this.__scrollbars[elm].dime.offsetHeight + 'px';
		
		this.__scrollbars[elm].y.firstChild.firstChild.style.height = y + '%';
		this.__scrollbars[elm].y.firstChild.firstChild.style.top = (100-y)*(elm.scrollTop/(elm.scrollHeight-elm.clientHeight)) + '%';

		//Show Buttons for detail scrolling
		if (elm.scrollHeight/elm.clientHeight>3)
			addcss(this.__scrollbars[elm].y, 'long');
		else
			removecss(this.__scrollbars[elm].y, 'long');
	}
	else
	if (this.__scrollbars[elm].y){
		if (this.__scrollbars[elm].y.parentNode)
			(this.__scrollbars[elm].dock || elm).removeChild(this.__scrollbars[elm].y);

		delete this.__scrollbars[elm].y;
	}

	//SHOW Horizontal
	if (!this.__scrollbars[elm].disabledX && x<100){

		//Min Size - no division by zero
		var iMin = elm.clientWidth ? 20/(elm.clientWidth/100) : 1;
		x = x<iMin?Math.ceil(iMin):x;

		this.__scrollbars[elm].x_size = x;

		if (this.__scrollbars[elm].x && this.__scrollbars[elm].x.parentNode == (this.__scrollbars[elm].dock || elm)){
			if (bShow){
				if (Is.Defined(this.__scrollbars[elm].t))
					window.clearTimeout(this.__scrollbars[elm].t);

				removecss(this.__scrollbars[elm].x, 'hide');
			}	
		}
		else{
			this.__scrollbars[elm].x = mkElement('em',{className:'sbarX'});
			this.__scrollbars[elm].x.innerHTML = '<ins><sub ondragstart="return false;" unselectable="on"></sub></ins>';


			//obey Events
			this.__scrollbars[elm].x.ondblclick = this.__scrollbars[elm].x.onclick = function(e){
				var e = e || window.event;
					e.cancelBubble = true;
				if (e.preventDefault) e.preventDefault();
				if (e.stopPropagation) e.stopPropagation();				
				return false;
			};

			//obey Events
			this.__scrollbars[elm].x.onmousedown = function(e,bScrollInt){
				var e = e || window.event,
					tmp = e.target || e.srcElement;

				e.cancelBubble = true;
				if (e.preventDefault) e.preventDefault();
				if (e.stopPropagation) e.stopPropagation();

				switch(tmp.tagName){
					case 'SUB':
						addcss(this,'active');

						me.__scrollbars[elm].sl = elm.scrollLeft;

						gui._obeyEvent('mouseup',[me,'__sbar_disobey',[this]]);
						gui._obeyEvent('mousemove',[me,'__sbar_scroll',[elm,this,'X',elm.scrollLeft,gui.__X]]);
						bScrollInt = true;
						break;
					
					case 'INS':	
					case 'EM':
					
						var sub = this.firstChild.firstChild,
							pos1 = getSize(this),
							pos2 = getSize(sub),
							x = gui.__X/*(Is.Number(e.layerX)?e.layerX:e.x) + pos1.x*/;

						//PgUp
						if (x<pos2.x)
							elm.scrollLeft -= elm.clientWidth;
						else
						//PgDown
						if (x>pos2.x+pos2.w)
							elm.scrollLeft += elm.clientWidth;
						else{
							if (x<pos2.x + (pos2.w*0.25))
								elm.scrollLeft -= elm.clientWidth/3;
							else
							if (x>pos2.x + (pos2.w*0.75))
								elm.scrollLeft += elm.clientWidth/3;
						}

						break;

					default:
						bScrollInt = true;
				}

				this.onclick(e);

				if (!bScrollInt){
					
					if (Is.Defined(me.__scrollint))
						window.clearInterval(me.__scrollint);

					me.__scrollint = window.setInterval(function(){
						me.__scrollbars[elm].x.onmousedown({srcElement:tmp},true);
					},500);

					gui._obeyEvent('mouseup',[function(){
						if (Is.Defined(me.__scrollint))
							window.clearInterval(me.__scrollint);
						return false
					}]);
				}

				return false;
			};

			(this.__scrollbars[elm].dock || elm).appendChild(this.__scrollbars[elm].x);
		}

		this.__scrollbars[elm].x.firstChild.firstChild.style.width = x + '%';
		this.__scrollbars[elm].x.firstChild.firstChild.style.left = (100-x)*(elm.scrollLeft/(elm.scrollWidth-elm.clientWidth)) + '%';
	}
	else
	if (this.__scrollbars[elm].x){
		if (this.__scrollbars[elm].x.parentNode)
			(this.__scrollbars[elm].dock || elm).removeChild(this.__scrollbars[elm].x);

		delete this.__scrollbars[elm].x;
	}

	if (y<100 || x<100){
		var me = this;
		this.__scrollbars[elm].t = window.setTimeout(function(){
			try{
				me.__sbar_hide(elm);
			}catch(r){}
		},1000);
	}
};

//Hide all scollbars
_me.__sbar_hide = function(elm){
	if (this.__scrollbars[elm]){
		if (this.__scrollbars[elm].x)
			addcss(this.__scrollbars[elm].x,'hide');

		if (this.__scrollbars[elm].y)
			addcss(this.__scrollbars[elm].y,'hide');
	}
};

_me.__sbar_disobey = function(e,arg,elm){
	gui._disobeyEvent('mouseup',[this,'__sbar_disobey']);
	gui._disobeyEvent('mousemove',[this,'__sbar_scroll']);

	if (elm)
		removecss(elm,'active');
};