function wm_xmpp(aHandler){
	var me = this;

	this.__sid;
	this.__domain;
	this.__aHandler = aHandler;

	//request buffer
	this.__buffer = {};
	this.__streamBuffer = {};

	this.__retrydelays = [10,10,10,10,10,10,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60,300];
	this.__reconnecting = 0;

	//global httprequest
	this.__http = new cRequest('/wcs/');
	this.__http.onerror = function(iq){
		switch(iq.status){
			case 409:
				if (me.__aHandler)
					me.reconnect([me.__aHandler[0],me.__aHandler[1],['logout']]);
				else
					me.reconnect('');

				return true;

			case 410:
				if (me.__aHandler)
					me.logout([me.__aHandler[0],me.__aHandler[1],['logout']],true);
				else
					me.logout('',true);
				return true;

			case 0:
				// Provide visual feedback
				if (me.__aHandler)
					executeCallbackFunction([me.__aHandler[0],me.__aHandler[1],['logout']]);

				// Try to log in again
				window.setTimeout(function(){
					me.login('',me.__lastLoginHandler);
				},1000);

				return true;
		}
	};

	this.__http.onsuccess = function(){
		me.__reconnecting = 0;
	};

	//SHA1 hash of vCard photo, used in presence request
	storage.library('wm_upload');
	this.__imageHash = '';

	this._resource = 'WebClient';
};

/**
 * XMPP Login sequence
 * 2.9.2008 16:45:31
 **/
wm_xmpp.prototype.login = function(aInput,aHandler,bOld){
	var me = this;

	if (!aInput){

		if (bOld){
			//step1 (create stream, retrieve authid)
			var gs_serv = (GWOthers.getItem('GLOBAL_SETTINGS','xmppserver') || 'localhost').split(';'),
				gs_port = (GWOthers.getItem('GLOBAL_SETTINGS','xmppport') || '').split(';'),
				tmp_port;

			for (var i in gs_serv)
				if ((tmp_port = parseInt(gs_port[i] || gs_port[0]))>0)
					gs_serv[i] += ':' + tmp_port;

			this.__lastLoginHandler = aHandler;
			this.__http._send('<body hold="1" xmlns="http://jabber.org/protocol/httpbind" to="'+ dataSet.get('main',['domain']).escapeXML(true) +'" route="'+ gs_serv.join(';').escapeXML(true) +'" wait="180" ver="1.6" />', 'text/xml', [this,'login',[aHandler]]);
		}
		else{
			auth.get_xmpp([this,'login',[aHandler]]);
			return;
		}

	}
	else
	//New
	if (aInput.XMPP_USERNAME){
		this.__lastLoginHandler = aHandler;
		this.__http._send('<body hold="1" xmlns="http://jabber.org/protocol/httpbind" to="'+ (aInput.XMPP_DOMAIN || dataSet.get('main',['domain'])).escapeXML(true) +'" route="'+ aInput.XMPP_HOST.escapeXML(true) +'" username="'+ aInput.XMPP_USERNAME.escapeXML(true) +'" resource="'+ this._resource.escapeXML(true) +'" encrypted_password="'+ aInput.XMPP_ENCRYPTEDPASSWORD.escapeXML(true) +'" wait="180" ver="1.6" />', 'text/xml', [this,'login',[aHandler]]);
		return;
	}
	else
	// go oldschool...
	if (aInput.XMPP_HOST){
		this.login('',aHandler,true);
		return;
	}
	else
	if (aInput['Array']){

		aInput = aInput['Array'];

		// Something went badly wrong, no reply body or iq messge
		if (!aInput.BODY && !aInput.IQ){
			if (this.__aHandler)
				executeCallbackFunction(this.__aHandler,'error',aInput);
			return false;
		}

		// If we get an error, retry later
		if (aInput.IQ && aInput.IQ[0] && aInput.IQ[0].ERROR) {
			// Server is not responding (local network may be down), try again in a short while
			window.setTimeout(function(){
				me.login('',me.__lastLoginHandler);
			},2000);
			return false;
		}

		//step2 + step4
		this.__sid = aInput.BODY[0].ATTRIBUTES.SID;

		//step2 (ask wm server for digest)
		if (aInput.BODY[0].ATTRIBUTES.AUTHID)
			auth.get_digest(aInput.BODY[0].ATTRIBUTES.AUTHID,'XMPP',[this,'login',[aHandler]]);
		else
		if (aHandler){

			//ERROR response: <iq type="error"><query><username>admin</username><resource>WebClient</resource><digest>2a6f71a7d41a366bbeafe71e63166c7b70e7522e</digest></query><error code="407">Registration Required</error></iq>
			if (aInput.BODY[0].IQ && aInput.BODY[0].IQ[0].ATTRIBUTES.TYPE == 'error')
				executeCallbackFunction(aHandler);
			else
				this.vcard('','',[this,'photo_hash',[aHandler]]);

			//executeCallbackFunction(aHandler);
		}

/*
Once upon a time, this error happen...

.. [message](string) = aInput.BODY[0].IQ is undefined
.. [fileName](string) = http://merakdemo.com/-.._._.--.._1299751772/new/devel/client/inc/startscript.js
.. [lineNumber](number) = 78
.. [stack](string) = ([object Array],[object Array])@http://merakdemo.com/-.._._.--.._1299751772/new/devel/client/inc/startscript.js:78
executeCallbackFunction([object Array],[object Object])@http://merakdemo.com/-.._._.--.._1299751772/new/devel/client/inc/startscript.js:176
([object Event])@http://merakdemo.com/-.._._.--.._1299751772/new/devel/client/inc/startscript.js:505
.. [name](string) = TypeError

 [aInput]
.. [BODY]
.... [0]
...... [ATTRIBUTES]
........ [XMLNS](string) = http://jabber.org/protocol/httpbind
........ [SID](string) = bbf8ea16e4f8788066e39e800380e684

<body xmlns="http://jabber.org/protocol/httpbind" sid="bbf8ea16e4f8788066e39e800380e684">
	<iq xmlns="jabber:client" type="set">
		<query xmlns="jabber:iq:auth">
			<username>admin@merakdemo.com
			</username>
			<resource>WebClient
			</resource>
			<digest>fbcfb615b5a4a5b8960a19e02639f9878b6dd751
			</digest>
		</query>
	</iq>
</body>

*/
	}
	//step3 (login into Jabber)
	else
	if (aInput){

		var aData = {
            	USERNAME:[{VALUE:dataSet.get('main',['account']).split('@').shift()}],
				RESOURCE:[{VALUE:this._resource}],
				DIGEST:[{VALUE:aInput}]
			};

		this.create_body(this.create_iq(this.create_query(aData,'jabber:iq:auth'),'set'),'',[this,'login',[aHandler]]);

		this.__lastLogin = (new Date()).getUNIX();
	}
};

	wm_xmpp.prototype.photo_hash = function(aData,aHandler){

		//Avatar Photo
		if (aData && aData.VCARD && aData.VCARD[0] && (aData = aData.VCARD[0])){
			if (aData.PHOTO && aData.PHOTO[0] && aData.PHOTO[0].TYPE && aData.PHOTO[0].BINVAL){
				try{
					var up = new wm_upload();
						up.data2xml(aData.PHOTO[0].TYPE[0].VALUE,aData.PHOTO[0].BINVAL[0].VALUE, sPrimaryAccount,[this,'update_hash',[aHandler]]);

					return;
				}
				catch(err){
					if (console)
						console.log('xmpp', 'update_hash error');
				}
			}
			else
				this.__imageHash = '';
		}

		if (aHandler)
			executeCallbackFunction(aHandler);
	};
	wm_xmpp.prototype.update_hash = function(sHash,aHandler){
		this.__imageHash = sHash;

		if (aHandler)
			executeCallbackFunction(aHandler);
	};

wm_xmpp.prototype.logout = function(aHandler,bNoRequest){

	//would be nice to abort keeper request HERE!

	if (this.__sid && !bNoRequest){
		//<presence type="unavailable"><status>Logged out</status></presence>
		var aData = {STATUS:[{VALUE:'Logged out'}]};
		this.create_body(this.create_presence(aData,'unavailable'),'terminate',[this,'response',['exe',aHandler]]);
	}
	else
	if (aHandler)
		executeCallbackFunction(aHandler);

	this.__sid = '';
	this.__imageHash = '';

};

wm_xmpp.prototype.reconnect = function(aHandler) {
	this.logout(aHandler,true);

	var t, me = this;

	// Try to login again
	if ((t = this.__retrydelays[this.__reconnecting++]))
		window.setTimeout(function(){
			if(me && !me.__sid) me.login('',me.__lastLoginHandler);
		}, t*1000);
	else
		this.__reconnecting = 0;
};

////// GATEWAYS //////

/* List
<iq type="get" to="icewarp.com" id="ab07a" >
<query xmlns="http://jabber.org/protocol/disco#items"/>
</iq>


<iq xmlns="jabber:client" type="get" id="5987343346676919001244638385735">
<query xmlns="http://jabber.org/protocol/disco#items"/>
</iq>

<iq from="icewarp.com" type="result" id="ab07a" to="tonda@icewarp.com/Office" >
<query xmlns="http://jabber.org/protocol/disco#items">
<item category="gateway" type="icq" name="ICQ Transport Gateway" jid="icq.icewarp.com" />
<item category="gateway" type="service" name="E-mail Transport" jid="email.icewarp.com" />
</query>
</iq>
*/
wm_xmpp.prototype.gateway_list = function(sDomain, aHandler){
	if (this.__sid){
		var sID = unique_id();
		this.__buffer[sID] = aHandler;

		this.create_body(this.create_iq(this.create_query('','http://jabber.org/protocol/disco#items'),'get', sID, sDomain),'',[this,'response',['exe']]);
	}
};

/*
# Ask for reg info
<iq type="get" to="007guard.com" id="ab4ba" >
<query xmlns="jabber:iq:register"/>
</iq>

<iq from="007guard.com" type="result" id="ab4ba" to="user@merakdemo.com/Work" >
<query xmlns="jabber:iq:register">
<username/>
<password/>
<instructions>Please enter your username and password</instructions>
</query>
</iq>

#Do registration
<iq type="set" to="007guard.com" id="ab48a" >
<query xmlns="jabber:iq:register">
<username>abc</username>
<password>cda</password>
</query>
</iq>
*/
wm_xmpp.prototype.gateway_registr = function(aData, sTo, aHandler){
	if (this.__sid){
		var q = {}, sID = unique_id();
		this.__buffer[sID] = aHandler;

		this.create_body(this.create_iq(this.create_query(aData,'jabber:iq:register'),aData?'set':'get', sID, sTo),'',[this,'response',['exe']]);
	}
};


////// PRESENCE //////

/**
 * Set client status priority
 * 2.9.2008 16:46:13
 **/
wm_xmpp.prototype.set_status = function(iStatus,sShow,sStatus,aHandler){
	if (this.__sid){

		var sType = '';
		var aData = {};

		if (sShow)
			aData.PRIORITY = [{VALUE:(iStatus || 5)}];

		//http://xmpp.org/extensions/xep-0115.html
		//storage.library('sha1');
		aData.C = [{ATTRIBUTES:{
			XMLNS:"http://jabber.org/protocol/caps",
			NODE:"http://psi-im.org/caps",
			VER:GWOthers.getItem('LOGIN_SETTINGS','version')
			}}];

		if (sShow == 'invisible')
			sType = 'invisible';
		else{
			if (sShow && sShow != 'online')
				aData.SHOW = [{VALUE:sShow}];

			if (sStatus)
				aData.STATUS = [{VALUE:sStatus}];
		}

		//Avatar Update <x xmlns='vcard-temp:x:update'><photo>sha1-hash-of-image</photo></x>
		aData.X = [{ATTRIBUTES:{XMLNS:'vcard-temp:x:update'},PHOTO:[{VALUE:this.__imageHash}]}];

		this.create_body(this.create_presence(aData,sType),'',[this,'response',['exe', aHandler]]);
	}
};

/**
 * DOWNLOAD
 **/
wm_xmpp.prototype.oob_cancel = function(aData, sID, sTo){
	if (this.__sid && sTo){
		var iq = this.create_iq(this.create_query(aData,'jabber:iq:oob'),'error', sID, sTo);
			iq.IQ[0].ERROR = [{ATTRIBUTES:{CODE:406,TYPE:'modify'},'NOT-ACCEPTABLE':[{ATTRIBUTES:{XMLNS:'urn:ietf:params:xml:ns:xmpp-stanzas'}}]}];

		this.create_body(iq,'',[this,'response']);
	}
};
/*
<iq from="Vaio" type="error" id="ac7ca" to="t61" >
<error code="403" >Declined</error>
</iq>
*/
wm_xmpp.prototype.stream_cancel = function(sID, sTo){
	if (this.__sid && sTo)
		this.create_body(this.create_iq({ERROR:[{ATTRIBUTES:{CODE:403},VALUE:'Declined'}]},'error', sID, sTo),'',[this,'response']);
};
/*
<iq type="result" to="imap@icewarp.com/Development" id="aac1a" >
<si xmlns="http://jabber.org/protocol/si">
<feature xmlns="http://jabber.org/protocol/feature-neg">
<x xmlns="jabber:x:data" type="submit" >
<field var="stream-method" >
<value>http://jabber.org/protocol/bytestreams</value>
</field>
</x>
</feature>
</si>
</iq>
*/
wm_xmpp.prototype.stream_accept = function(aData, sID, sTo){
	if (this.__sid && sTo){

		if (aData && aData.ATTRIBUTES && aData.ATTRIBUTES.ID && aData.FILE && aData.FILE[0].ATTRIBUTES && aData.FILE[0].ATTRIBUTES.NAME && aData.FILE[0].ATTRIBUTES.SIZE){

			var si = {SI:[{
				ATTRIBUTES:{XMLNS:'http://jabber.org/protocol/si'},
				FEATURE:[{
					ATTRIBUTES:{XMLNS:'http://jabber.org/protocol/feature-neg'},
					X:[{
						ATTRIBUTES:{XMLNS:'jabber:x:data',TYPE:'submit'},
						FIELD:[{
						    ATTRIBUTES:{VAR:'stream-method'},
							VALUE:[{VALUE:'http://jabber.org/protocol/bytestreams'}]
							}]
						}]
					}]
				}]
			};

			//Insert into stream buffer
			this.__streamBuffer[aData.ATTRIBUTES.ID] = {name:aData.FILE[0].ATTRIBUTES.NAME,size:aData.FILE[0].ATTRIBUTES.SIZE};

			this.create_body(this.create_iq(si,'result', sID, sTo), '', [this,'response']);
		}
	}
};
/**
 * UPLOAD
 **/

wm_xmpp.prototype.stream_send = function (sFolder,sFile, sClass,iSize,sName,sTo,sDesc){

	if (!this.__sid) return;

	//Do Upload.Extract when size is 0 (GW Object)
	if (!iSize){
	    storage.library('wm_upload');
		var up = new wm_upload();
			up.extract(sFolder,sFile,sClass,[this,'stream_send',[sTo,sDesc]]);

		return;
	}

	/*
	<<<
	<?xml version="1.0" encoding="utf-8" ?>
	<iq sid="008e4086edb67dfb0869437385289a49" type="result">
		<query xmlns="webmail:iq:upload">
			<upload>
				<name>basic login.png</name>
				<type>application/octet-stream</type>
				<size>80532</size>
			</upload>
		</query>
	</iq>

	>>>
	<iq from="imap@icewarp.com/Development" type="set" id="aac1a" to="klos@icewarp.com/Development" >
		<si xmlns="http://jabber.org/protocol/si" profile="http://jabber.org/protocol/si/profile/file-transfer" id="s5b_f5c122943d5604d5" >
			<file xmlns="http://jabber.org/protocol/si/profile/file-transfer" size="821" name="w7.txt" >
				<range/>
			</file>
			<feature xmlns="http://jabber.org/protocol/feature-neg">
				<x xmlns="jabber:x:data" type="form" >
					<field type="list-single" var="stream-method" >
						<option>
							<value>http://jabber.org/protocol/bytestreams</value>
						</option>
					</field>
				</x>
			</feature>
		</si>
	</iq>

	<iq from="admin@merakdemo.com/WebClient" type="set" id="4877309432968767401262613910041" to="user@merakdemo.com" >
		<si xmlns="http://jabber.org/protocol/si" profile="http://jabber.org/protocol/si/profile/file-transfer" id="a611dcb32f8151ace9a48b51190a54432b7eadd3" >
			<file xmlns="http://jabber.org/protocol/si/profile/file-transfer" size="80532" name="basic login.png" >
				<desc>ahojte</desc>
			</file>
			<feature xmlns="http://jabber.org/protocol/feature-neg">
				<x xmlns="jabber:x:data" var="stream-method" >
					<option>
						<value>http://jabber.org/protocol/bytestreams</value>
					</option>
				</x>
			</feature>
		</si>
	</iq>
	*/
    storage.library('sha1');
	var sHash = SHA1(unique_id()+sPrimaryAccount/*dataSet.get('main',['account'])*/+'/WebClient'+sTo);
	var q = {SI:[{
			ATTRIBUTES:{XMLNS:"http://jabber.org/protocol/si",PROFILE:"http://jabber.org/protocol/si/profile/file-transfer",ID:sHash},
			FILE:[{
				ATTRIBUTES:{XMLNS:"http://jabber.org/protocol/si/profile/file-transfer", SIZE:iSize || '0', NAME:sName},
				DESC:[{VALUE:sDesc}]
				}],
			FEATURE:[{
			    ATTRIBUTES:{XMLNS:"http://jabber.org/protocol/feature-neg"},
			    X:[{
			    	ATTRIBUTES:{XMLNS:"jabber:x:data", TYPE:"form"},
			    	FIELD:[{
			    	    ATTRIBUTES:{TYPE:"list-single", VAR:"stream-method"},
				    	OPTION:[{
							VALUE:[{VALUE:'http://jabber.org/protocol/bytestreams'}]
						}]
					}]
				}]
			}]
		}]};

	//check oob support
	var sID = unique_id();
	this.__buffer[sID] = [this,'stream_support',[sHash, sFolder, sFile, sClass, sDesc]];
	this.create_body(this.create_iq(q,'set', sID, sTo),'',[this,'response',['exe']]);
};

wm_xmpp.prototype.stream_support = function(aData, sHash, sFolder, sFile, sClass, sDesc){
/*
<<<
 [stream_upload]
.. [0]
.... [SI]
...... [0]
........ [FEATURE]
.......... [0]
............ [X]
.............. [0]
................ [FIELD]
.................. [0]
.................... [VALUE]
...................... [0]
........................ [VALUE](string) = http://jabber.org/protocol/bytestreams
.................... [ATTRIBUTES]
...................... [VAR](string) = stream-method
................ [ATTRIBUTES]
.................. [XMLNS](string) = jabber:x:data
.................. [TYPE](string) = submit
............ [ATTRIBUTES]
.............. [XMLNS](string) = http://jabber.org/protocol/feature-neg
........ [ATTRIBUTES]
.......... [XMLNS](string) = http://jabber.org/protocol/si
........ [FROM]
.......... [0]
............ [VALUE](string) = user@merakdemo.com/Work
........ [ID]
.......... [0]
............ [VALUE](string) = 9552796309779942001262614382663
.... [ATTRIBUTES]
...... [ID](string) = 9552796309779942001262614382663
...... [FROM](string) = user@merakdemo.com/Work
...... [TO](string) = admin@merakdemo.com/WebClient
...... [TYPE](string) = result
.. [1](undefined) = undefined
.. [2]
.... [JID](string) = proxy.merakdemo.com
.... [HOST](string) = 127.0.0.1
.... [PORT](string) = 1080
>>>

<iq from="imap@icewarp.com/Development" type="set" to="klos@icewarp.com/Development" id="aac3a" >
	<query xmlns="http://jabber.org/protocol/bytestreams" mode="tcp" sid="s5b_f5c122943d5604d5" >
		<streamhost port="1080" host="192.168.0.2" jid="proxy.icewarp.com" >
			<proxy xmlns="http://affinix.com/jabber/stream"/>
		</streamhost>
		<fast xmlns="http://affinix.com/jabber/stream"/>
	</query>
</iq>
*/

//	this.create_body(this.create_iq(this.create_query('','http://jabber.org/protocol/bytestreams'),'set','',aData.ATTRIBUTES.FROM),'',[this,'response',['exe']]);

/*
 [IQ]
.. [0]
.... [QUERY]
...... [0]
........ [ATTRIBUTES]
.......... [XMLNS](string) = http://jabber.org/protocol/bytestreams
.......... [MODE](string) = tcp
.......... [SID](string) = 81d7fb4d1a173446d61e4032209e8078b091f87d
........ [STREAMHOST]
.......... [0]
............ [ATTRIBUTES]
.............. [JID](string) = proxy.merakdemo.com
.............. [HOST](string) = 127.0.0.1
.............. [PORT](string) = 1080
.... [ATTRIBUTES]
...... [XMLNS](string) = jabber:client
...... [TYPE](string) = set
...... [TO](string) = user@merakdemo.com/Work
...... [ID](string) = 310608205213506201262618697002
*/

	if (aData && aData.ATTRIBUTES && aData.ATTRIBUTES.TYPE == 'result'){
        var bSupport = false;
		try{
			bSupport = aData.SI[0].FEATURE[0].X[0].FIELD[0].VALUE[0].VALUE == 'http://jabber.org/protocol/bytestreams' && aData.SI[0].FEATURE[0].X[0].FIELD[0].ATTRIBUTES.VAR == 'stream-method';
		}
		catch(r){}

		if (bSupport){
			var sID = unique_id(),
				q = this.create_query('','http://jabber.org/protocol/bytestreams');
				q.QUERY[0].ATTRIBUTES.MODE = 'tcp';
				q.QUERY[0].ATTRIBUTES.SID = sHash;
				q.QUERY[0].STREAMHOST = [{ATTRIBUTES:{'JID':GWOthers.getItem('STREAMHOST', 'jid'),'HOST':GWOthers.getItem('STREAMHOST', 'host'),'PORT':GWOthers.getItem('STREAMHOST', 'port')}}];

			this.__buffer[sID] = [this,'stream_upload',[sHash, sFolder, sFile, sClass]];
			this.create_body(this.create_iq(q,'set', sID, aData.ATTRIBUTES.FROM),'',[this,'response',['exe']]);
		}
		else{
			this.oob_send(sFolder,sFile, sClass, aData.ATTRIBUTES.FROM, sDesc);
		}
	}
	//Error, User has canceled the request
	else{
		gui._create('ticket_error','frm_alert','','','','IM::SEND_FILE','IM::ERROR_CANCEL');
		executeCallbackFunction([this.__aHandler[0],this.__aHandler[1],['notice',{FROM:aData.ATTRIBUTES.FROM,TEXT:getLang('IM::ERROR_CANCEL')}]]);
	}
};

wm_xmpp.prototype.stream_upload = function(aData, sHash, sFolder, sFile, sClass){

	if (aData && aData.ATTRIBUTES && aData.ATTRIBUTES.TYPE == 'result' && aData.QUERY && aData.QUERY[0]['STREAMHOST-USED'] && aData.QUERY[0]['STREAMHOST-USED'][0].ATTRIBUTES && aData.QUERY[0]['STREAMHOST-USED'][0].ATTRIBUTES.JID == GWOthers.getItem('STREAMHOST', 'jid')){
		storage.library('wm_upload');
	    storage.library('sha1');

		var sHash = SHA1(sHash+sPrimaryAccount/*dataSet.get('main',['account'])*/+'/WebClient'+aData.ATTRIBUTES.FROM);
		var up = new wm_upload();
			up.socket(sFolder, sFile, sClass, sHash, [this.__aHandler[0],this.__aHandler[1],['bytestream']]);
	}
	//Error
	else
		gui._create('ticket_error','frm_alert','','','','IM::SEND_FILE','IM::ERROR_BYTESTREAM');
};


wm_xmpp.prototype.oob_send = function(sFolder,sFile,sClass,sTo,sDesc){
	storage.library('wm_upload');
	var up = new wm_upload();
		up.ticket(sFolder,sFile,sClass, [this,'oob_support',[sTo,sDesc]]);
};

wm_xmpp.prototype.oob_support = function(aData,sTo,sDesc){
	//check xmpp
	if (!this.__sid) return;

	if (aData.ticket){
		//check oob support
		var sID = unique_id();
		this.__buffer[sID] = [this,'oob_upload',[aData, sTo, sDesc]];
		this.create_body(this.create_iq(this.create_query('','http://jabber.org/protocol/disco#info'),'get', sID, sTo),'',[this,'response',['exe']]);
	}
	//error creating ticket
	else
		gui._create('ticket_error','frm_alert','','','','','IM::ERROR_TICKET');
};

wm_xmpp.prototype.oob_upload = function(aData, aTicket, sTo, sDesc){
	//check xmpp
	if (!this.__sid) return;

	//build URL
	var sURL = document.location.href;
		sURL = sURL.substr(0,sURL.lastIndexOf('/')+1) + 'server/download.php/ticket/'+ encodeURIComponent(aTicket.ticket) +'/'+ encodeURIComponent(aTicket.name);

	//check OOB support
	var f;
	if (aData && aData.QUERY && aData.QUERY[0] && (f = aData.QUERY[0].FEATURE))
		for (var i in f)
			if (f[i].ATTRIBUTES && f[i].ATTRIBUTES.VAR == 'jabber:iq:oob'){

				//send OOB query
				var sID = unique_id(),
					aQ = {URL:[{VALUE:sURL}],DESC:[{VALUE:sDesc}]};

				this.__buffer[sID] = [this,'oob_finish',[aTicket]];

				this.create_body(this.create_iq(this.create_query(aQ,'jabber:iq:oob'),'set', sID, sTo),'',[this,'response',['exe']]);
				return;
			}

	//OOB unsupported, send message with link
	var sBody = getLang('IM::FILE_MESSAGE',[sDesc || '', sURL]);
	this.message(sTo, sBody);
};

wm_xmpp.prototype.oob_finish = function (aData){
	if (aData){
		if (aData.ERROR)
			gui._create('ticket_error','frm_alert','','','','','IM::FILE_CANCEL');
		else
		if (aData.ATTRIBUTES && aData.ATTRIBUTES.TYPE == 'error')
			gui._create('ticket_error','frm_alert','','','','','IM::FILE_ERROR');
		else
			gui._create('ticket_error','frm_alert','','','','','IM::FILE_OK');
	}
};


/**
 * ROSTER
 **/
wm_xmpp.prototype.roster_get = function(aHandler){
	if (this.__sid)
		this.create_body(this.create_iq(this.create_query('','jabber:iq:roster'),'get'),'',[this,'response',['exe', aHandler]]);
};

/**
 * HISTORY
 **/
wm_xmpp.prototype.history_get = function(aData, aHandler){
/*
<retrieve xmlns='urn:xmpp:archive' with='juliet@capulet.com/chamber' start='1469-07-21T02:56:15Z'> // start UTC time
[<body>optional body text search</body>]
<set xmlns='http://jabber.org/protocol/rsm'>
<max>100</max>
[<after></after> // after x secs from start]
[<before/> // from the end]
[<before></before> // backwards before x secs from start]
</set>
</retrieve>
*/

	var q = {RETRIEVE:[{ATTRIBUTES:{XMLNS:'urn:xmpp:archive',WITH:aData.from},SET:[{ATTRIBUTES:{XMLNS:'http://jabber.org/protocol/rsm'}}]}]};

	if (aData['start'])
		q.RETRIEVE[0].ATTRIBUTES.START = typeof aData['start'] == 'date'?aData['start'].format('imDateTime'):aData['start'];

	if (aData['search'])
		q.RETRIEVE[0].BODY = [{VALUE:aData['search']}];

	if (aData['max'])
		q.RETRIEVE[0].SET[0].MAX = [{VALUE:aData['max']}];

	if (typeof aData['before'] != 'undefined')
		q.RETRIEVE[0].SET[0].BEFORE = [{VALUE:aData['before'] || ''}];

	if (aData['after'])
		q.RETRIEVE[0].SET[0].AFTER = [{VALUE:aData['after']}];

	var sID = unique_id();
	this.__buffer[sID] = aHandler;

	if (this.__sid)
		this.create_body(this.create_iq(q,'get',sID),'',[this,'response',['exe']]);
};

/**
 * USER
 **/
wm_xmpp.prototype.user_remove = function(aJID, aHandler){
	/*
	Supports multiple IQ
	<iq type="set" id="aadaa" >
	<query xmlns="jabber:iq:roster">
	<item subscription="remove" jid="asd@merakdemo.com" />
	</query>
	</iq>

	Remove gateway
	<iq type="set" to="monitor.icewarp.com" id="aaf1a" ><query xmlns="jabber:iq:register"><remove/></query></iq>
	 <iq xmlns="jabber:client" type="set"><query xmlns="jabber:iq:register"><remove/></query></iq>
	*/


	if (this.__sid && aJID.length){

		var aData, aTmp = {IQ:[]};
		for(var i in aJID){
			aData = {ITEM:[{ATTRIBUTES:{subscription:'remove',jid:aJID[i]}}]};

			aTmp.IQ.push(this.create_iq(this.create_query(aData,'jabber:iq:roster'),'set').IQ[0]);

			//un-registr gateway
			if (aJID[i].indexOf('@')<0)
            	aTmp.IQ.push(this.create_iq(this.create_query({'REMOVE':[{}]},'jabber:iq:register'),'set','',aJID[i]).IQ[0]);
		}

		if (aTmp.IQ.length)
			this.create_body(aTmp,'',[this,'response',['exe', aHandler]]);
	}
};

wm_xmpp.prototype.user_add = function(sJID, sName, sGroup, aHandler){
	this.user_group(sJID, sName, sGroup, [this,'user_subscribe',[sJID,aHandler]]);
};

wm_xmpp.prototype.user_group = function(sJID, sName, sGroup, aHandler){
	/*
	<iq type="set" id="ab16a" >
	<query xmlns="jabber:iq:roster">
	<item jid="domain@merakdemo.com" >
	<group>skupina</group>
	</item>
	</query>
	</iq>
	*/
	if (this.__sid && sJID){
		var aData = {ITEM:[{ATTRIBUTES:{jid:sJID}}]};

		if (sGroup)
			aData.ITEM[0].GROUP = [{VALUE:sGroup}];

		if (sName)
			aData.ITEM[0].ATTRIBUTES.NAME = sName;

		this.create_body(this.create_iq(this.create_query(aData,'jabber:iq:roster'),'set'),'',[this,'response',['exe', aHandler]]);
	}
};

//request subscription
wm_xmpp.prototype.user_subscribe = function(sJID,aHandler){
	//<presence type="subscribe" to="user@merakdemo.com" >
	//<nick xmlns="http://jabber.org/protocol/nick">zork</nick>
	//</presence>

	//DORESIT NICK (muj)

	this.create_body(this.create_presence('','subscribe',sJID),'',[this,'response',['exe',aHandler]]);
};
//re-send subscription
wm_xmpp.prototype.user_subscribed = function(sJID,aHandler){
	//<presence type="subscribed" to="user@merakdemo.com" />
	if (this.__sid && sJID){
		this.create_body(this.create_presence('','subscribed',sJID),'',[this,'response',['exe',aHandler]]);
		this.create_body(this.create_presence('','subscribe',sJID),'',[this,'response']);
	}
};
//remove subscription
wm_xmpp.prototype.user_unsubscribed = function(sJID,aHandler){
	//<presence type="unsubscribed" to="user@merakdemo.com" />
    if (this.__sid && sJID)
		this.create_body(this.create_presence('','unsubscribed',sJID),'',[this,'response',['exe',aHandler]]);
};

wm_xmpp.prototype.user_rename = function(sJID,sName,sGroup,aHandler){
	/*
	<iq type="set" id="ab21a" >
	<query xmlns="jabber:iq:roster">
	<item name="admin" jid="admin@merakdemo.com" />
	</query>
	</iq>
	*/
	if (this.__sid && sJID){
		var aData = {ITEM:[{ATTRIBUTES:{NAME:sName,JID:sJID}}]};

		if (sGroup)
			aData.ITEM[0].GROUP = [{VALUE:sGroup}];

		this.create_body(this.create_iq(this.create_query(aData,'jabber:iq:roster'),'set'),'',[this,'response',['exe', aHandler]]);
	}
};

/*
 *	Conference Meeting invitation - send
 */
wm_xmpp.prototype.invitation = function(sTo, sBody, aHandler){
	if(this.__sid && sTo) {
		var aData = {BODY:[{VALUE:sBody}],X:[{ATTRIBUTES:{XMLNS:"jabber:x:icewarpconference"},ID:[{VALUE: dataSet.get('meeting',['id']) || 0}]}],ACTIVE:[{ATTRIBUTES:{XMLNS:"http://jabber.org/protocol/chatstates"}}]};
		this.create_body(this.create_message(aData,'chat',sTo),'',[this,'response',['exe', aHandler]]);
	}
};

/**
 * MESSAGE
 **/
wm_xmpp.prototype.message = function(sTo, sBody, aHandler){
	if (this.__sid && sTo){
		var aData = {BODY:[{VALUE:sBody}],ACTIVE:[{ATTRIBUTES:{XMLNS:"http://jabber.org/protocol/chatstates"}}]};
		this.create_body(this.create_message(aData,'chat',sTo),'',[this,'response',['exe', aHandler]]);
	}
};

wm_xmpp.prototype.msg_status = function(sTo,sType,aHandler){
	if (this.__sid && sTo){
        sType = sType.toUpperCase();
		var aData = {};
			aData[sType] = [{ATTRIBUTES:{XMLNS:"http://jabber.org/protocol/chatstates"}}];

		this.create_body(this.create_message(aData,'chat',sTo),'',[this,'response',['exe', aHandler]]);
	}
};

wm_xmpp.prototype.vcard = function(sTo, aValue, aHandler){

	/*
	GET
	<iq type="get" to="admin@merakdemo.com" id="aabda" >
	<vCard xmlns="vcard-temp" version="2.0" prodid="-//HandGen//NONSGML vGen v1.0//EN" />
	</iq>

	SET
	<iq type="set" id="aabea" >
	<vCard xmlns="vcard-temp" version="2.0" prodid="-//HandGen//NONSGML vGen v1.0//EN" >
	<FN>Administrator</FN>
	<NICKNAME>zork</NICKNAME>
	<BDAY>11.09.1983</BDAY>
	<URL>www</URL>
	</vCard>
	</iq>
	*/

	if (this.__sid){

		var aData = {vCard:[{}]};

		if (aValue)
			aData.vCard[0] = aValue;

		aData.vCard[0].ATTRIBUTES = {xmlns:"vcard-temp",version:'2.0',prodid:'-//HandGen//NONSGML vGen v1.0//EN'};

		//add to response buffer
		var sID;
		if (aHandler){
			sID = unique_id();
			this.__buffer[sID] = aHandler;
		}

		//SET is CaseSensitive
		if (aValue){
			var aRequest = {'body':[{ATTRIBUTES:{xmlns:'http://jabber.org/protocol/httpbind', sid:this.__sid}}]};
				aRequest['body'][0].iq = [aData];
				aRequest['body'][0].iq[0].ATTRIBUTES = {type:'set'};

			if (aHandler)
				aRequest['body'][0].iq[0].ATTRIBUTES.id = sID;

			//var	http = this.createHTTP();
				this.__http.sendArray(aRequest,[this, 'response',['exe']],null,true);
		}
		else
			this.create_body(this.create_iq(aData,aValue?'set':'get',sID,sTo || sPrimaryAccount/*dataSet.get('main',['account'])*/),'',[this, 'response',['exe']]);
	}
};


/**
 * STORAGE
 * 3.9.2008 11:51:10
 **/
wm_xmpp.prototype.storage_get = function (sStorage,aHandler){
	if (this.__sid){
		var aData = {WEBMAIL_PRO:[]};

		if (sStorage){
			var tmp = {};
				tmp[sStorage] = [];
			aData.WEBMAIL_PRO.push(tmp);
		}

		this.create_body(this.create_iq(this.create_query(aData,'jabber:iq:private'),'get'),'',aHandler);
	}
};

wm_xmpp.prototype.storage_set = function (sStorage, aIn, aHandler){
	if (this.__sid){

		var aStor = {};
			aStor[sStorage] = [{VALUE:arrToString(aIn)}];

		var aData = {WEBMAIL_PRO:[]};
			aData.WEBMAIL_PRO.push(aStor)

		this.create_body(this.create_iq(this.create_query(aData,'jabber:iq:private'),'set'),'',aHandler);
	}
};


/**
 * Listen to event
 **/
wm_xmpp.prototype.listen = function(aHandler){

	// Send listening message to server and wait for response
	if (this.__sid && (!this.__keeper || this.__keeper.readyState == 0 || this.__keeper.readyState == 4))
		this.__keeper = this.__http._send('<body sid="'+ this.__sid +'" xmlns="http://jabber.org/protocol/httpbind"></body>', 'text/xml', [this, 'response', ['listen',aHandler]]);
};

wm_xmpp.prototype.response = function(aData,sType,aHandler){
try{

	if (!aData || !(aData = aData.Array))
		return;

	if (aData.BODY) {
		aData = aData.BODY[0];

		// Recreate Bind
		if (sType == 'listen' && this.__sid)
			this.listen();

		//REQUEST
		var attr;
		if (aData.IQ){
			for(var i in aData.IQ){
				if (aData.IQ[i].QUERY){
					var query = aData.IQ[i].QUERY[0];
					if (query.ATTRIBUTES)
						switch (query.ATTRIBUTES.XMLNS){
						//ROSTER
						case 'jabber:iq:roster':
							if (this.__aHandler)
								executeCallbackFunction([this.__aHandler[0],this.__aHandler[1],['roster',query]]);
							break;
						//SUPPORTed
						/* Do Not uncomment this it brakes gateway_list() response!
						case 'http://jabber.org/protocol/disco#items':
							var q = this.create_query({}, 'http://jabber.org/protocol/disco#items');
							this.create_body(this.create_iq(q, 'result', aData.IQ[i].ATTRIBUTES.ID, aData.IQ[i].ATTRIBUTES.FROM),'',[this,'response']);
						    break;
						*/

						//OOB SUPPORT (for download)
						case 'http://jabber.org/protocol/disco#info':
							if (aData.IQ[i].ATTRIBUTES.TYPE == 'get'){
								var q = this.create_query({
	                                //<identity xml:lang='en' category='client' name='Psi 0.11' type='pc'/>
	                                IDENTITY:[{ATTRIBUTES:{CATEGORY:'client',NAME:'IceWarp '+GWOthers.getItem('LOGIN_SETTINGS','version'),TYPE:'pc'}}],
									FEATURE:[
										{ATTRIBUTES:{VAR:'http://jabber.org/protocol/bytestreams'}},
										{ATTRIBUTES:{VAR:'http://jabber.org/protocol/si'}},
										{ATTRIBUTES:{VAR:'http://jabber.org/protocol/si/profile/file-transfer'}},
										{ATTRIBUTES:{VAR:'http://jabber.org/protocol/disco#info'}},
										{ATTRIBUTES:{VAR:'http://jabber.org/protocol/commands'}},
										{ATTRIBUTES:{VAR:'jabber:x:data'}}
									]
									},'http://jabber.org/protocol/disco#info');

                                q.QUERY[0].ATTRIBUTES.NODE = 'http://icewarp.com#'+GWOthers.getItem('LOGIN_SETTINGS','version');

								this.create_body(this.create_iq(q, 'result', aData.IQ[i].ATTRIBUTES.ID, aData.IQ[i].ATTRIBUTES.FROM),'',[this,'response']);
							}

							break;
						//DOWNLOAD
						case 'jabber:iq:oob':
							if (this.__aHandler && aData.IQ[i].ATTRIBUTES.TYPE == 'set'){
								query.FROM = [{VALUE:aData.IQ[i].ATTRIBUTES.FROM}];
								query.ID = [{VALUE:aData.IQ[i].ATTRIBUTES.ID}];
								executeCallbackFunction([this.__aHandler[0],this.__aHandler[1],['download',query]]);
							}
							break;
						//Incoming stream
						case 'http://jabber.org/protocol/bytestreams':
							if (query.STREAMHOST && query.ATTRIBUTES && query.ATTRIBUTES.SID && this.__streamBuffer[query.ATTRIBUTES.SID]){

								//Check connection by wm_upload
								storage.library('sha1');
								var out = [];
								//SHA1(SID + Initiator JID + Target JID)
								var sHash = SHA1(query.ATTRIBUTES.SID+aData.IQ[i].ATTRIBUTES.FROM+aData.IQ[i].ATTRIBUTES.TO);
								for (var j in query.STREAMHOST){
									out.push({
										jid:query.STREAMHOST[j].ATTRIBUTES.JID,
										host:query.STREAMHOST[j].ATTRIBUTES.HOST + (query.STREAMHOST[j].ATTRIBUTES.PORT?':'+query.STREAMHOST[j].ATTRIBUTES.PORT:''),
										hash:sHash
									});
								}

								var oUpload = new wm_upload();
									oUpload.socks_connect(out,[this,'_socks_connect',[query.ATTRIBUTES.SID,aData.IQ[i].ATTRIBUTES.ID, aData.IQ[i].ATTRIBUTES.FROM]]);
							}

							break;

						}

				}
				else
				if (aData.IQ[i].SI){
					//SOCKS download
					if (aData.IQ[i].SI[0].FILE){
						var si = aData.IQ[i].SI[0];
							si.FROM = [{VALUE:aData.IQ[i].ATTRIBUTES.FROM}];
							si.ID = [{VALUE:aData.IQ[i].ATTRIBUTES.ID}];

						if (this.__aHandler)
							executeCallbackFunction([this.__aHandler[0],this.__aHandler[1],['download',si]]);
					}
				}

				//IQ CallBack
				var id = aData.IQ[i].ATTRIBUTES?aData.IQ[i].ATTRIBUTES.ID:'';
				if (id && this.__buffer[id]){
					executeCallbackFunction(this.__buffer[id],aData.IQ[i]);
					delete this.__buffer[id];
				}
			}
		}

		//PRESENCE
		if (aData.PRESENCE)
			for(var i in aData.PRESENCE){
				attr = aData.PRESENCE[i].ATTRIBUTES;

				if (aData.PRESENCE[i].ERROR){
					executeCallbackFunction([this.__aHandler[0],this.__aHandler[1],['error',[aData.PRESENCE[i].ERROR[0]]]]);
					return;
				}

				switch(attr.TYPE){
				//Someone added me into roster
				case 'subscribe':
					// --> <presence to="admin@merakdemo.com" from="user@merakdemo.com" type="subscribe"><status/></presence>
					//document.title = attr.FROM +' ask for subscription';

					//auto subscribe users
					// <-- <presence type="subscribed || unsubscribed" to="user@merakdemo.com" />
					//this.create_body(this.create_presence('','subscribed',attr.FROM),'',[this,'response']);

					if (this.__aHandler)
						executeCallbackFunction([this.__aHandler[0],this.__aHandler[1],['subscribe',aData.PRESENCE[i]]]);

				break;

				case 'unavailable':

					//document.title = attr.FROM +' is Offline';

					if (this.__aHandler)
						executeCallbackFunction([this.__aHandler[0],this.__aHandler[1],['unavailable',aData.PRESENCE[i]]]);

				break;

				case 'subscribed':
					//document.title = attr.FROM +" poslal opravneni";

					if (this.__aHandler)
						executeCallbackFunction([this.__aHandler[0],this.__aHandler[1],['subscribed',aData.PRESENCE[i]]]);
				break;

				case 'unsubscribe':
				break;

				case 'unsubscribed':
					//document.title = attr.FROM +" odebral opravneni";

					if (this.__aHandler)
						executeCallbackFunction([this.__aHandler[0],this.__aHandler[1],['unsubscribed',aData.PRESENCE[i]]]);

					//neopravneny offline
				break;

				//Someone changed his status
				default:
					//inspect2({presence:aData});

					/*
					<presence from="user@merakdemo.com/t61" to="admin@merakdemo.com/WebClient">
						<show>chat</show>
						<priority>5</priority>
						<status>cumim na bednu</status>
						<c xmlns="http://jabber.org/protocol/caps" node="http://psi-im.org/caps" ver="0.11-dev-rev8" ext="cs ep-notify html" />
					</presence>*/

					if (this.__aHandler)
						executeCallbackFunction([this.__aHandler[0],this.__aHandler[1],['state_change',aData.PRESENCE[i]]]);
				}
			}

		//MESSAGE
		if (aData.MESSAGE)
			for(var i in aData.MESSAGE){

				//Arrived
				if (this.__aHandler){

					if (aData.MESSAGE[i].ERROR){
						executeCallbackFunction([this.__aHandler[0],this.__aHandler[1],['error',aData.MESSAGE[i].ERROR[0]]]);
						return;
					}

					if (aData.MESSAGE[i].COMPOSING)
						executeCallbackFunction([this.__aHandler[0],this.__aHandler[1],['composing',aData.MESSAGE[i].ATTRIBUTES.FROM]]);
					if (aData.MESSAGE[i].PAUSED)
						executeCallbackFunction([this.__aHandler[0],this.__aHandler[1],['paused',aData.MESSAGE[i].ATTRIBUTES.FROM]]);
					if (aData.MESSAGE[i].GONE)
						executeCallbackFunction([this.__aHandler[0],this.__aHandler[1],['gone',aData.MESSAGE[i].ATTRIBUTES.FROM]]);

					if (aData.MESSAGE[i].BODY)
						executeCallbackFunction([this.__aHandler[0],this.__aHandler[1],['message',aData.MESSAGE[i]]]);
				}
			}
	}
	else
	//Status Error
	if (aData.IQ){

		//<iq type="error"><error uid="offline" status="410">Connection Lost</error></iq>
		if (aData.IQ[0].ERROR){
			/*
			var attr = aData.IQ[0].ERROR[0].ATTRIBUTES;

			// Temporary error, try to reconnect
			if (attr.STATUS == 409){
				if (this.__aHandler)
					this.reconnect([this.__aHandler[0],this.__aHandler[1],['logout']]);
				else
					this.reconnect('');
			}
			else
			// Permanent error, do not try to reconnect
			if(attr.STATUS == 410) {
				if (this.__aHandler)
					this.logout([this.__aHandler[0],this.__aHandler[1],['logout']],true);
				else
					this.logout('',true);
			}
			else
			// No http status code, probably network connection failed
			if (!attr.STATUS){
				var me = this;
				// Provide visual feedback
				if (this.__aHandler)
					executeCallbackFunction([this.__aHandler[0],this.__aHandler[1],['logout']]);
				// Try to log in again
				window.setTimeout(function(){
					me.login('',me.__lastLoginHandler);
				},1000);
			}
			*/

				var me = this;
				// Provide visual feedback
				if (this.__aHandler)
					executeCallbackFunction([this.__aHandler[0],this.__aHandler[1],['logout']]);
				// Try to log in again
				window.setTimeout(function(){
					me.login('',me.__lastLoginHandler);
				},1000);

			return;
		}
	}

}
catch(r){
	//inspect2({error:r,sType:sType,aData:aData},true);
}

	//handle response from other then .listen method
	if (sType == 'exe' && aHandler)
		executeCallbackFunction(aHandler);
};

/**
 * bind controler object (obj_im.js)
 **/
wm_xmpp.prototype.bind = function(aHandler){
	this.__aHandler = aHandler;
};
/**
 * AUXILIARY FUNCTIONS
 **/
wm_xmpp.prototype.init = function(){
	this.login('',[this,'listen']);
};


wm_xmpp.prototype.create_body = function(aData,sType,oResponse){
	var aRequest = {};

	if (aData)
		aRequest.BODY = [aData];
	else
		aRequest.BODY = [{}];

	aRequest.BODY[0].ATTRIBUTES = {XMLNS:'http://jabber.org/protocol/httpbind'};

	if (sType)
		aRequest.BODY[0].ATTRIBUTES.TYPE = sType;

	//add SID
	if (this.__sid)
		aRequest.BODY[0].ATTRIBUTES.SID = this.__sid;

	this.__http.sendArray(aRequest,oResponse);
};

	wm_xmpp.prototype.create_iq = function(aData, sType, sID, sTo){

		var aRequest = {IQ:[{}]};

		if (aData)
			aRequest.IQ = [aData];

		if (!aRequest.IQ[0].ATTRIBUTES)
			aRequest.IQ[0].ATTRIBUTES = {};

		aRequest.IQ[0].ATTRIBUTES.XMLNS = "jabber:client";

		if (sType)
			aRequest.IQ[0].ATTRIBUTES.TYPE = sType;

		if (sTo)
			aRequest.IQ[0].ATTRIBUTES.TO = sTo;

		if (sID)
			aRequest.IQ[0].ATTRIBUTES.ID = sID;

		return aRequest;
	};

		wm_xmpp.prototype.create_query = function(aData,sXMLns){

			var aRequest = {'QUERY':[{}]};

			if (aData)
				aRequest.QUERY = [aData];

			if (sXMLns){
				if (!aRequest.QUERY[0].ATTRIBUTES)
					aRequest.QUERY[0].ATTRIBUTES = {};

				aRequest.QUERY[0].ATTRIBUTES['XMLNS'] = sXMLns;
			}

			return aRequest;
		};

	wm_xmpp.prototype.create_presence = function(aData,sType,sTo){

		var aRequest = {PRESENCE:[{}]};

		if (aData)
			aRequest.PRESENCE = [aData];

		if (!aRequest.PRESENCE[0].ATTRIBUTES)
			aRequest.PRESENCE[0].ATTRIBUTES = {};

		aRequest.PRESENCE[0].ATTRIBUTES.XMLNS = "jabber:client";
		aRequest.PRESENCE[0].ATTRIBUTES.FROM = sPrimaryAccount; //dataSet.get('main',['account']);

		if (sType)
			aRequest.PRESENCE[0].ATTRIBUTES.TYPE = sType;

		if (sTo)
			aRequest.PRESENCE[0].ATTRIBUTES.TO = sTo;

		return aRequest;
	};

	wm_xmpp.prototype.create_message = function(aData, sType, sTo){
		var aRequest = {MESSAGE:[]},
			tmp = {};

		if (typeof sTo == 'string')
			sTo = [sTo];

		for (var i in sTo)
			if (sTo[i]){
				if (aData)
					tmp = clone(aData,true);
				else
				    tmp = {};

				if (!tmp.ATTRIBUTES)
					tmp.ATTRIBUTES = {};

				if (sType)
					tmp.ATTRIBUTES.TYPE = sType;

				tmp.ATTRIBUTES.TO = sTo[i];

				aRequest.MESSAGE.push(tmp);
			}
		return aRequest;
	};

//Extended Private handler
wm_xmpp.prototype._socks_connect = function (aData,sSID,sID,sFrom){
	if (aData){
		var out = this.__streamBuffer[sSID];
		if (out && sID && sFrom){
			out.jid = aData.jid;
			out.socket = aData.socket;

			this.create_body(this.create_iq(this.create_query({'STREAMHOST-USED':[{ATTRIBUTES:{JID:out.jid}}]},'http://jabber.org/protocol/bytestreams'),'result',sID, sFrom), '', [this,'response']);
			executeCallbackFunction([this.__aHandler[0],this.__aHandler[1],['streamhost',out]]);
		}
	}
	//Handle Error (Socket can not be open)
	else
		executeCallbackFunction([this.__aHandler[0],this.__aHandler[1],['streamhost']]);

	delete this.__streamBuffer[sSID];
};